Changelog
*********


Python 3.14.0 final
===================

*Release date: 2025-10-07*


macOS
-----

* gh-124111: Update macOS installer to use Tcl/Tk 8.6.17.

* gh-139573: Updated bundled version of OpenSSL to 3.0.18.


Windows
-------

* gh-139573: Updated bundled version of OpenSSL to 3.0.18.


Tools/Demos
-----------

* gh-139330: SBOM generation tool didn’t cross-check the version and
  checksum values against the "Modules/expat/refresh.sh" script,
  leading to the values becoming out-of-date during routine updates.

* gh-132006: XCframeworks now include privacy manifests to satisfy
  Apple App Store submission requirements.

* gh-138171: A script for building an iOS XCframework was added. As
  part of this change, the top level "iOS" folder has been moved to be
  a subdirectory of the "Apple" folder.


Security
--------

* gh-139400: "xml.parsers.expat": Make sure that parent Expat parsers
  are only garbage-collected once they are no longer referenced by
  subparsers created by "ExternalEntityParserCreate()". Patch by
  Sebastian Pipping.


Library
-------

* gh-139312: Upgrade bundled libexpat to 2.7.3


Python 3.14.0 release candidate 3
=================================

*Release date: 2025-09-18*


Windows
-------

* gh-138896: Fix error installing C runtime on non-updated Windows
  machines


Tools/Demos
-----------

* gh-137873: The iOS test runner has been simplified, resolving some
  issues that have been observed using the runner in GitHub Actions
  and Azure Pipelines test environments.


Security
--------

* gh-135661: Fix CDATA section parsing in "html.parser.HTMLParser"
  according to the HTML5 standard: "] ]>" and "]] >" no longer end the
  CDATA section. Add private method "_set_support_cdata()" which can
  be used to specify how to parse "<[CDATA[" — as a CDATA section in
  foreign content (SVG or MathML) or as a bogus comment in the HTML
  namespace.


Library
-------

* gh-138998: Update bundled libexpat to 2.7.2

* gh-118803: Add back "collections.abc.ByteString" and
  "typing.ByteString". Both had been removed in prior alpha, beta and
  release candidates for Python 3.14, but their removal has now been
  postponed to Python 3.17.

* gh-137226: Fix "typing.get_type_hints()" calls on generic
  "typing.TypedDict" classes defined with string annotations.

* gh-138804: Raise "TypeError" instead of "AttributeError" when an
  argument of incorrect type is passed to "shlex.quote()". This
  restores the behavior of the function prior to 3.14.

* gh-128636: Fix crash in PyREPL when os.environ is overwritten with
  an invalid value for mac

* gh-138514: Raise "ValueError" when a multi-character string is
  passed to the *echo_char* parameter of "getpass.getpass()". Patch by
  Benjamin Johnson.

* gh-138515: "email" is added to Emscripten build.

* gh-99948: "ctypes.util.find_library()" now works in Emscripten
  build.

* gh-138253: Add the *block* parameter in the "put()" and "get()"
  methods of the "concurrent.interpreters" queues for compatibility
  with the "queue.Queue" interface.

* gh-138133: Prevent infinite traceback loop when sending CTRL^C to
  Python through "strace".

* gh-134869: Fix an issue where pressing Ctrl+C during tab completion
  in the REPL would leave the autocompletion menu in a corrupted
  state.

* gh-90548: Fix "musl" detection for "platform.libc_ver()" on Alpine
  Linux if compiled with –strip-all.

* gh-136134: "SMTP.auth_cram_md5()" now raises an "SMTPException"
  instead of a "ValueError" if Python has been built without MD5
  support. In particular, "SMTP" clients will not attempt to use this
  method even if the remote server is assumed to support it. Patch by
  Bénédikt Tran.

* gh-136134: "IMAP4.login_cram_md5" now raises an "IMAP4.error" if
  CRAM-MD5 authentication is not supported. Patch by Bénédikt Tran.

* gh-134953: Expand "_colorize" theme with "keyword_constant" and
  implement in *repl*.


Core and Builtins
-----------------

* gh-71810: Raise "OverflowError" for "(-1).to_bytes()" for signed
  conversions when bytes count is zero.  Patch by Sergey B Kirpichev.

* gh-138192: Fix "contextvars" initialization so that all
  subinterpreters are assigned the "MISSING" value.

* gh-138479: Fix a crash when a generic object’s "__typing_subst__"
  returns an object that isn’t a "tuple".

* gh-138372: Fix "SyntaxWarning" emitted for erroneous subscript
  expressions involving template string literals. Patch by Brian
  Schubert.

* gh-138318: The default REPL now avoids highlighting built-in names
  (for instance "set" or "format()") when they are used as attribute
  names (for instance in "value.set" or "text.format").

* gh-138349: Fix crash in certain cases where a module contains both a
  module-level annotation and a comprehension.

* gh-137384: Fix a crash when using the "warnings" module in a
  finalizer at shutdown. Patch by Kumar Aditya.

* gh-137883: Fix runaway recursion when calling a function with
  keyword arguments.

* gh-137079: Fix keyword typo recognition when parsing files. Patch by
  Pablo Galindo.

* gh-137728: Fix the JIT’s handling of many local variables. This
  previously caused a segfault.

* gh-137576: Fix for incorrect source code being shown in tracebacks
  from the Basic REPL when "PYTHONSTARTUP" is given. Patch by Adam
  Hartz.


Python 3.14.0 release candidate 2
=================================

*Release date: 2025-08-14*


macOS
-----

* gh-137450: macOS installer shell path management improvements:
  separate the installer "Shell profile updater" postinstall script
  from the "Update Shell Profile.command" to enable more robust error
  handling.

* gh-137134: Update macOS installer to ship with SQLite version
  3.50.4.


Windows
-------

* gh-137134: Update Windows installer to ship with SQLite 3.50.4.


Library
-------

* gh-137426: Remove the code deprecation of
  "importlib.abc.ResourceLoader". It is documented as deprecated, but
  left for backwards compatibility with other classes in
  "importlib.abc".

* gh-137282: Fix tab completion and "dir()" on "concurrent.futures".

* gh-137257: Bump the version of pip bundled in ensurepip to version
  25.2

* gh-137226: Fix behavior of "annotationlib.ForwardRef.evaluate()"
  when the *type_params* parameter is passed and the name of a type
  param is also present in an enclosing scope.

* gh-130522: Fix unraisable "TypeError" raised during *interpreter
  shutdown* in the "threading" module.

* gh-137059: Fix handling of file URLs with a Windows drive letter in
  the URL authority by "urllib.request.url2pathname()". This fixes a
  regression in earlier pre-releases of Python 3.14.

* gh-130577: "tarfile" now validates archives to ensure member offsets
  are non-negative.  (Contributed by Alexander Enrique Urieles Nieto
  in gh-130577.)

* gh-135228: When "dataclasses" replaces a class with a slotted
  dataclass, the original class can now be garbage collected again.
  Earlier changes in Python 3.14 caused this class to always remain in
  existence together with the replacement class synthesized by
  "dataclasses".


Documentation
-------------

* gh-136155: We are now checking for fatal errors in EPUB builds in
  CI.


Core and Builtins
-----------------

* gh-137400: Fix a crash in the *free threading* build when disabling
  profiling or tracing across all threads with
  "PyEval_SetProfileAllThreads()" or "PyEval_SetTraceAllThreads()" or
  their Python equivalents "threading.settrace_all_threads()" and
  "threading.setprofile_all_threads()".

* gh-137314: Fixed a regression where raw f-strings incorrectly
  interpreted escape sequences in format specifications. Raw f-strings
  now properly preserve literal backslashes in format specs, matching
  the behavior from Python 3.11. For example, "rf"{obj:\xFF}"" now
  correctly produces "'\\xFF'" instead of "'ÿ'". Patch by Pablo
  Galindo.

* gh-137308: A standalone docstring in a node body is optimized as a
  "pass" statement to ensure that the node’s body is never empty.
  There was a "ValueError" in "compile()" otherwise.

* gh-137288: Fix bug where some bytecode instructions of a boolean
  expression are not associated with the correct exception handler.

* gh-134291: Remove some newer macOS API usage from the JIT compiler
  in order to restore compatibility with older OSX 10.15 deployment
  targets.

* gh-131338: Disable computed stack limit checks on non-glibc linux
  platforms to fix crashes on deep recursion.

* gh-136870: Fix data races while de-instrumenting bytecode of code
  objects running concurrently in threads.


C API
-----

* gh-137573: Mark "_PyOptimizer_Optimize" as "Py_NO_INLINE" to prevent
  stack overflow crashes on macOS.


Build
-----

* gh-132339: Add support for OpenSSL 3.5.


Python 3.14.0 release candidate 1
=================================

*Release date: 2025-07-22*


Tools/Demos
-----------

* gh-136251: Fixes and usability improvements for
  "Tools/wasm/emscripten/web_example"


Security
--------

* gh-135661: Fix parsing attributes with whitespaces around the "="
  separator in "html.parser.HTMLParser" according to the HTML5
  standard.

* gh-118350: Fix support of escapable raw text mode (elements
  “textarea” and “title”) in "html.parser.HTMLParser".


Library
-------

* gh-136170: Removed the unreleased "zipfile.ZipFile.data_offset"
  property added in 3.14.0a7 as it wasn’t fully clear which behavior
  it should have in some situations so the result was not always what
  a user might expect.

* gh-124621: pyrepl now works in Emscripten.

* gh-136874: Discard URL query and fragment in
  "urllib.request.url2pathname()".

* gh-130645: Enable color help by default in "argparse".

* gh-136549: Fix signature of "threading.excepthook()".

* gh-136523: Fix "wave.Wave_write" emitting an unraisable when open
  raises.

* gh-52876: Add missing "keepends" (default "True") parameter to
  "codecs.StreamReaderWriter.readline()" and
  "codecs.StreamReaderWriter.readlines()".

* gh-136470: Correct "concurrent.futures.InterpreterPoolExecutor"’s
  default thread name.

* gh-136476: Fix a bug that was causing the "get_async_stack_trace"
  function to miss some frames in the stack trace.

* gh-136434: Fix docs generation of "UnboundItem" in
  "concurrent.interpreters" when running with "-OO".

* gh-136380: Raises "AttributeError" when accessing
  "concurrent.futures.InterpreterPoolExecutor" and subinterpreters are
  not available.

* gh-134759: Fix "UnboundLocalError" in
  "email.message.Message.get_payload()" when the payload to decode is
  a "bytes" object. Patch by Kliment Lamonov.

* gh-134657: "asyncio": Remove some private names from
  "asyncio.__all__".


Core and Builtins
-----------------

* gh-136801: Fix PyREPL syntax highlighting on match cases after
  multi-line case. Contributed by Olga Matoula.

* gh-136421: Fix crash when initializing "datetime" concurrently.

* gh-136541: Fix some issues with the perf trampolines on x86-64 and
  aarch64.  The trampolines were not being generated correctly for
  some cases, which could lead to the perf integration not working
  correctly. Patch by Pablo Galindo.

* gh-136517: Fixed a typo that prevented printing of uncollectable
  objects when the "gc.DEBUG_UNCOLLECTABLE" mode was set.

* gh-136525: Fix issue where per-thread bytecode was not instrumented
  for newly created threads.

* gh-132661: "Interpolation.expression" now has a default, the empty
  string.

* gh-132661: Reflect recent **PEP 750** change.

  Disallow concatenation of "string.templatelib.Template" and "str".
  Also, disallow implicit concatenation of t-string literals with
  string or f-string literals.

* gh-116738: Make functions in "grp" thread-safe on the *free
  threaded* build.

* gh-135148: Fixed a bug where f-string debug expressions (using =)
  would incorrectly strip out parts of strings containing escaped
  quotes and # characters. Patch by Pablo Galindo.

* gh-133136: Limit excess memory usage in the *free threading* build
  when a large dictionary or list is resized and accessed by multiple
  threads.

* gh-91153: Fix a crash when a "bytearray" is concurrently mutated
  during item assignment.

* gh-127971: Fix off-by-one read beyond the end of a string in string
  search.


C API
-----

* gh-112068: Revert support of nullable arguments in "PyArg_Parse()".

* gh-133296: New variants for the critical section API that accept one
  or two "PyMutex" pointers rather than "PyObject" instances are now
  public in the non-limited C API.

* gh-134009: Expose "PyMutex_IsLocked()" as part of the public C API.


Build
-----

* gh-135621: PyREPL no longer depends on the "curses" standard
  library. Contributed by Łukasz Langa.


Python 3.14.0 beta 4
====================

*Release date: 2025-07-08*


Tools/Demos
-----------

* gh-135968: Stubs for "strip" are now provided as part of an iOS
  install.

* gh-133600: Backport file reorganization for Tools/wasm/wasi.

  This should make backporting future code changes easier. It also
  simplifies instructions around how to do WASI builds in the
  devguide.


Tests
-----

* gh-135966: The iOS testbed now handles the "app_packages" folder as
  a site directory.

* gh-135494: Fix regrtest to support excluding tests from "--pgo"
  tests. Patch by Victor Stinner.


Security
--------

* gh-136053: "marshal": fix a possible crash when deserializing
  "slice" objects.

* gh-135661: Fix parsing start and end tags in
  "html.parser.HTMLParser" according to the HTML5 standard.

  * Whitespaces no longer accepted between "</" and the tag name. E.g.
    "</ script>" does not end the script section.

  * Vertical tabulation ("\v") and non-ASCII whitespaces no longer
    recognized as whitespaces. The only whitespaces are "\t\n\r\f" and
    space.

  * Null character (U+0000) no longer ends the tag name.

  * Attributes and slashes after the tag name in end tags are now
    ignored, instead of terminating after the first ">" in quoted
    attribute value. E.g. "</script/foo=">"/>".

  * Multiple slashes and whitespaces between the last attribute and
    closing ">" are now ignored in both start and end tags. E.g. "<a
    foo=bar/ //>".

  * Multiple "=" between attribute name and value are no longer
    collapsed. E.g. "<a foo==bar>" produces attribute “foo” with value
    “=bar”.

  * [Reverted in gh-136927] Whitespaces between the "=" separator and
    attribute name or value are no longer ignored. E.g. "<a foo =bar>"
    produces two attributes “foo” and “=bar”, both with value None;
    "<a foo= bar>" produces two attributes: “foo” with value “” and
    “bar” with value None.

* gh-102555: Fix comment parsing in "html.parser.HTMLParser" according
  to the HTML5 standard. "--!>" now ends the comment. "-- >" no longer
  ends the comment. Support abnormally ended empty comments "<-->" and
  "<--->".


Library
-------

* gh-136286: Fix pickling failures for protocols 0 and 1 for many
  objects realted to subinterpreters.

* gh-136316: Improve support for evaluating nested forward references
  in "typing.evaluate_forward_ref()".

* gh-85702: If "zoneinfo._common.load_tzdata" is given a package
  without a resource a "zoneinfo.ZoneInfoNotFoundError" is raised
  rather than a "PermissionError". Patch by Victor Stinner.

* gh-136028: Fix parsing month names containing “İ” (U+0130, LATIN
  CAPITAL LETTER I WITH DOT ABOVE) in "time.strptime()". This affects
  locales az_AZ, ber_DZ, ber_MA and crh_UA.

* gh-135995: In the palmos encoding, make byte "0x9b" decode to "›"
  (U+203A - SINGLE RIGHT-POINTING ANGLE QUOTATION MARK).

* gh-53203: Fix "time.strptime()" for "%c" and "%x" formats on locales
  byn_ER, wal_ET and lzh_TW, and for "%X" format on locales ar_SA,
  bg_BG and lzh_TW.

* gh-91555: An earlier change, which was introduced in 3.14.0b2, has
  been reverted. It disabled logging for a logger during handling of
  log messages for that logger. Since the reversion, the behaviour
  should be as it was before 3.14.0b2.

* gh-135878: Fixes a crash of "types.SimpleNamespace" on *free
  threading* builds, when several threads were calling its
  "__repr__()" method at the same time.

* gh-135836: Fix "IndexError" in "asyncio.loop.create_connection()"
  that could occur when non-"OSError" exception is raised during
  connection and socket’s "close()" raises "OSError".

* gh-135836: Fix "IndexError" in "asyncio.loop.create_connection()"
  that could occur when the Happy Eyeballs algorithm resulted in an
  empty exceptions list during connection attempts.

* gh-135855: Raise "TypeError" instead of "SystemError" when
  "_interpreters.set___main___attrs()" is passed a non-dict object.
  Patch by Brian Schubert.

* gh-135815: "netrc": skip security checks if "os.getuid()" is
  missing. Patch by Bénédikt Tran.

* gh-135640: Address bug where it was possible to call
  "xml.etree.ElementTree.ElementTree.write()" on an ElementTree object
  with an invalid root element. This behavior blanked the file passed
  to "write" if it already existed.

* gh-135645: Added "supports_isolated_interpreters" field to
  "sys.implementation".

* gh-135646: Raise consistent "NameError" exceptions in
  "annotationlib.ForwardRef.evaluate()"

* gh-135557: Fix races on "heapq" updates and "list" reads on the
  *free threaded* build.

* gh-119180: Only fetch globals and locals if necessary in
  "annotationlib.get_annotations()"

* gh-135561: Fix a crash on DEBUG builds when an HACL* HMAC routine
  fails. Patch by Bénédikt Tran.

* gh-135487: Fix "reprlib.Repr.repr_int()" when given integers with
  more than "sys.get_int_max_str_digits()" digits. Patch by Bénédikt
  Tran.

* gh-135335: "multiprocessing": Flush "stdout" and "stderr" after
  preloading modules in the "forkserver".

* gh-135069: Fix the “Invalid error handling” exception in
  "encodings.idna.IncrementalDecoder" to correctly replace the
  ‘errors’ parameter.

* gh-130662: +Accept leading zeros in precision and width fields for
  +:class:"Decimal" formatting, for example "format(Decimal(1.25),
  '.016f')".

* gh-130662: Accept leading zeros in precision and width fields for
  "Fraction" formatting, for example "format(Fraction(1, 3),
  '.016f')".

* gh-87790: Support underscore and comma as thousands separators in
  the fractional part for "Fraction"’s formatting.  Patch by Sergey B
  Kirpichev.

* gh-87790: Support underscore and comma as thousands separators in
  the fractional part for "Decimal"’s formatting.  Patch by Sergey B
  Kirpichev.

* gh-130664: Handle corner-case for "Fraction"’s formatting: treat
  zero-padding (preceding the width field by a zero ("'0'") character)
  as an equivalent to a fill character of "'0'" with an alignment type
  of "'='", just as in case of "float"’s.


Documentation
-------------

* gh-136155: EPUB builds are fixed by excluding non-XHTML-compatible
  tags.


Core and Builtins
-----------------

* gh-109700: Fix memory error handling in "PyDict_SetDefault()".

* gh-78465: Fix error message for "cls.__new__(cls, ...)" where "cls"
  is not instantiable builtin or extension type (with "tp_new" set to
  "NULL").

* gh-129958: Differentiate between t-strings and f-strings in syntax
  error for newlines in format specifiers of single-quoted
  interpolated strings.

* gh-135871: Non-blocking mutex lock attempts now return immediately
  when the lock is busy instead of briefly spinning in the *free
  threading* build.

* gh-135106: Restrict the trashcan mechanism to GC’ed objects and
  untrack them while in the trashcan to prevent the GC and trashcan
  mechanisms conflicting.

* gh-135607: Fix potential "weakref" races in an object’s destructor
  on the *free threaded* build.

* gh-135608: Fix a crash in the JIT involving attributes of modules.

* gh-135543: Emit "sys.remote_exec" audit event when
  "sys.remote_exec()" is called and migrate "remote_debugger_script"
  to "cpython.remote_debugger_script".

* gh-134280: Disable constant folding for "~" with a boolean argument.
  This moves the deprecation warning from compile time to runtime.


C API
-----

* gh-135906: Fix compilation errors when compiling the internal
  headers with a C++ compiler.


Build
-----

* gh-134273: Add support for configuring compiler flags for the JIT
  with "CFLAGS_JIT"


Python 3.14.0 beta 3
====================

*Release date: 2025-06-17*


Windows
-------

* gh-135099: Fix a crash that could occur on Windows when a background
  thread waits on a "PyMutex" while the main thread is shutting down
  the interpreter.


Tests
-----

* gh-132815: Fix test__opcode: add "JUMP_BACKWARD" to specialization
  stats.

* gh-135489: Show verbose output for failing tests during PGO
  profiling step with –enable-optimizations.

* gh-135120: Add "test.support.subTests()".


Security
--------

* gh-135462: Fix quadratic complexity in processing specially crafted
  input in "html.parser.HTMLParser". End-of-file errors are now
  handled according to the HTML5 specs – comments and declarations are
  automatically closed, tags are ignored.

* gh-135034: Fixes multiple issues that allowed "tarfile" extraction
  filters ("filter="data"" and "filter="tar"") to be bypassed using
  crafted symlinks and hard links.

  Addresses **CVE 2024-12718**, **CVE 2025-4138**, **CVE 2025-4330**,
  and **CVE 2025-4517**.


Library
-------

* gh-65697: "configparser"’s error message when attempting to write an
  invalid key is now more helpful.

* gh-135497: Fix "os.getlogin()" failing for longer usernames on BSD-
  based platforms.

* gh-135429: Fix the argument mismatch in "_lsprof" for "PY_THROW"
  event.

* gh-135368: Fix "unittest.mock.Mock" generation on
  "dataclasses.dataclass()" objects. Now all special attributes are
  set as it was before gh-124429.

* gh-133967: Do not normalize "locale" name ‘C.UTF-8’ to
  ‘en_US.UTF-8’.

* gh-135321: Raise a correct exception for values greater than
  0x7fffffff for the "BINSTRING" opcode in the C implementation of
  "pickle".

* gh-135276: Backported bugfixes in zipfile.Path from zipp 3.23. Fixed
  ".name", ".stem" and other basename-based properties on Windows when
  working with a zipfile on disk.

* gh-135244: "uuid": when the MAC address cannot be determined, the
  48-bit node ID is now generated with a cryptographically-secure
  pseudo-random number generator (CSPRNG) as per **RFC 9562,
  §6.10.3**. This affects "uuid1()" and "uuid6()".

* gh-134970: Fix the “unknown action” exception in
  "argparse.ArgumentParser.add_argument_group()" to correctly replace
  the action class.

* gh-134718: "ast.dump()" now only omits "None" and "[]" values if
  they are default values.

* gh-134939: Add the "concurrent.interpreters" module.  See **PEP
  734**.

* gh-134885: Fix possible crash in the "compression.zstd" module
  related to setting parameter types. Patch by Jelle Zijlstra.

* gh-134857: Improve error report for "doctest"s run with "unittest".
  Remove "doctest" module frames from tracebacks and redundant newline
  character from a failure message.

* gh-128840: Fix parsing long IPv6 addresses with embedded IPv4
  address.

* gh-134637: Fix performance regression in calling a "ctypes" function
  pointer in *free threading*.

* gh-134696: Built-in HACL* and OpenSSL implementations of hash
  function constructors now correctly accept the same *documented*
  named arguments. For instance, "md5()" could be previously invoked
  as "md5(data=data)" or "md5(string=string)" depending on the
  underlying implementation but these calls were not compatible. Patch
  by Bénédikt Tran.

* gh-134151: "email": Fix "TypeError" in "email.utils.decode_params()"
  when sorting **RFC 2231** continuations that contain an unnumbered
  section.

* gh-134210: "curses.window.getch()" now correctly handles signals.
  Patch by Bénédikt Tran.

* gh-134152: "email": Fix parsing of email message ID with invalid
  domain.

* gh-133489: "random.getrandbits()" can now generate more that 2^31
  bits. "random.randbytes()" can now generate more that 256 MiB.

* gh-132813: Improve error messages for incorrect types and values of
  "csv.Dialect" attributes.

* gh-132969: Prevent the "ProcessPoolExecutor" executor thread, which
  remains running when "shutdown(wait=False)", from attempting to
  adjust the pool’s worker processes after the object state has
  already been reset during shutdown. A combination of conditions,
  including a worker process having terminated abormally, resulted in
  an exception and a potential hang when the still-running executor
  thread attempted to replace dead workers within the pool.

* gh-127081: Fix libc thread safety issues with "os" by replacing
  "getlogin" with "getlogin_r" re-entrant version.

* gh-131884: Fix formatting issues in "json.dump()" when both *indent*
  and *skipkeys* are used.

* gh-130999: Avoid exiting the new REPL and offer suggestions even if
  there are non-string candidates when errors occur.


Documentation
-------------

* gh-135171: Document that the *iterator* for the leftmost "for"
  clause in the generator expression is created immediately.

* bpo-45210: Document that error indicator may be set in tp_dealloc,
  and how to avoid clobbering it.


Core and Builtins
-----------------

* gh-135496: Fix typo in the f-string conversion type error
  (“exclamanation” -> “exclamation”).

* gh-135371: Fixed "asyncio" debugging tools to properly display
  internal coroutine call stacks alongside external task dependencies.
  The "python -m asyncio ps" and "python -m asyncio pstree" commands
  now show complete execution context. Patch by Pablo Galindo.

* gh-127319: Set the "allow_reuse_port" class variable to "False" on
  the XMLRPC, logging, and HTTP servers. This matches the behavior in
  prior Python releases, which is to not allow port reuse.

* gh-135171: Reverts the behavior of async generator expressions when
  created with object w/o __aiter__ method to the pre-3.13 behavior of
  raising a TypeError.

* gh-130077: Properly raise custom syntax errors when incorrect syntax
  containing names that are prefixes of soft keywords is encountered.
  Patch by Pablo Galindo.

* gh-135171: Reverts the behavior of generator expressions when
  created with a non-iterable to the pre-3.13 behavior of raising a
  TypeError. It is no longer possible to cause a crash in the debugger
  by altering the generator expression’s local variables. This is
  achieved by moving the "GET_ITER" instruction back to the creation
  of the generator expression and adding an additional check to
  "FOR_ITER".

* gh-116738: Make methods in "heapq" thread-safe on the *free
  threaded* build.

* gh-134876: Add support to **PEP 768** remote debugging for Linux
  kernels which don’t have CONFIG_CROSS_MEMORY_ATTACH configured.

* gh-134889: Fix handling of a few opcodes that leave operands on the
  stack when optimizing "LOAD_FAST".

* gh-134908: Fix crash when iterating over lines in a text file on the
  *free threaded* build.

* gh-132617: Fix "dict.update()" modification check that could
  incorrectly raise a “dict mutated during update” error when a
  different dictionary was modified that happens to share the same
  underlying keys object.

* gh-134679: Fix crash in the *free threading* build’s QSBR code that
  could occur when changing an object’s "__dict__" attribute.

* gh-127682: No longer call "__iter__" twice in list comprehensions.
  This brings the behavior of list comprehensions in line with other
  forms of iteration

* gh-133912: Fix the C API function "PyObject_GenericSetDict" to
  handle extension classes with inline values.


C API
-----

* gh-134989: Fix "Py_RETURN_NONE", "Py_RETURN_TRUE" and
  "Py_RETURN_FALSE" macros in the limited C API 3.11 and older: don’t
  treat "Py_None", "Py_True" and "Py_False" as immortal. Patch by
  Victor Stinner.

* gh-134989: Implement "PyObject_DelAttr()" and
  "PyObject_DelAttrString()" as macros in the limited C API 3.12 and
  older. Patch by Victor Stinner.

* gh-133968: Add "PyUnicodeWriter_WriteASCII()" function to write an
  ASCII string into a "PyUnicodeWriter". The function is faster than
  "PyUnicodeWriter_WriteUTF8()", but has an undefined behavior if the
  input string contains non-ASCII characters. Patch by Victor Stinner.


Build
-----

* gh-119132: Remove “experimental” tag from the CPython free-threading
  build.

* gh-135497: Fix the detection of "MAXLOGNAME" in the "configure.ac"
  script.

* gh-134923: Windows builds with profile-guided optimization enabled
  now use "/GENPROFILE" and "/USEPROFILE" instead of deprecated
  "/LTCG:" options.

* gh-134774: Fix "Py_DEBUG" macro redefinition warnings on Windows
  debug builds. Patch by Chris Eibl.

* gh-134632: Fixed "build-details.json" generation to use "INCLUDEPY",
  in order to reference the "pythonX.Y" subdirectory of the include
  directory, as required in **PEP 739**, instead of the top-level
  include directory.


Python 3.14.0 beta 2
====================

*Release date: 2025-05-26*


Windows
-------

* gh-130727: Fix a race in internal calls into WMI that can result in
  an “invalid handle” exception under high load. Patch by Chris Eibl.

* gh-76023: Make "os.path.realpath()" ignore Windows error 1005 when
  in non-strict mode.

* gh-133779: Reverts the change to generate different "pyconfig.h"
  files based on compiler settings, as it was frequently causing
  extension builds to break. In particular, the "Py_GIL_DISABLED"
  preprocessor variable must now always be defined explicitly when
  compiling for the experimental free-threaded runtime. The
  "sysconfig.get_config_var()" function can be used to determine
  whether the current runtime was compiled with that flag or not.

* gh-133626: Ensures packages are not accidentally bundled into the
  traditional installer.


Tools/Demos
-----------

* gh-134215: *REPL* import autocomplete only suggests private modules
  when explicitly specified.


Tests
-----

* gh-133744: Fix multiprocessing interrupt test. Add an event to
  synchronize the parent process with the child process: wait until
  the child process starts sleeping. Patch by Victor Stinner.

* gh-133682: Fixed test case
  "test.test_annotationlib.TestStringFormat.test_displays" which
  ensures proper handling of complex data structures (lists, sets,
  dictionaries, and tuples) in string annotations.

* gh-133639: Fix "TestPyReplAutoindent.test_auto_indent_default()"
  doesn’t run "input_code".


Security
--------

* gh-133767: Fix use-after-free in the “unicode-escape” decoder with a
  non-“strict” error handler.

* gh-128840: Short-circuit the processing of long IPv6 addresses early
  in "ipaddress" to prevent excessive memory consumption and a minor
  denial-of-service.


Library
-------

* gh-132710: If possible, ensure that "uuid.getnode()" returns the
  same result even across different processes. Previously, the result
  was constant only within the same process. Patch by Bénédikt Tran.

* gh-80334: "multiprocessing.freeze_support()" now checks for work on
  any “spawn” start method platform rather than only on Windows.

* gh-134582: Fix tokenize.untokenize() round-trip errors related to
  t-strings braces escaping

* gh-134546: Ensure "pdb" remote debugging script is readable by
  remote Python process.

* gh-134451: Converted "asyncio.tools.CycleFoundException" from
  dataclass to a regular exception type.

* gh-114177: Fix "asyncio" to not close subprocess pipes which would
  otherwise error out when the event loop is already closed.

* gh-90871: Fixed an off by one error concerning the backlog parameter
  in "create_unix_server()". Contributed by Christian Harries.

* gh-134323: Fix the "threading.RLock.locked()" method.

* gh-86802: Fixed asyncio memory leak in cancelled shield tasks. For
  shielded tasks where the shield was cancelled, log potential
  exceptions through the exception handler. Contributed by Christian
  Harries.

* gh-134209: "curses": The "curses.window.instr()" and
  "curses.window.getstr()" methods now allocate their internal buffer
  on the heap instead of the stack; in addition, the max buffer size
  is increased from 1023 to 2047.

* gh-134235: Updated tab completion on REPL to include builtin
  modules. Contributed by Tom Wang, Hunter Young

* gh-134152: Fixed "UnboundLocalError" that could occur during "email"
  header parsing if an expected trailing delimiter is missing in some
  contexts.

* gh-134168: "http.server": Fix IPv6 address binding and "--directory"
  handling when using HTTPS.

* gh-62184: Remove import of C implementation of "io.FileIO" from
  Python implementation which has its own implementation

* gh-133982: Emit "RuntimeWarning" in the Python implementation of
  "io" when the *file-like object* is not closed explicitly in the
  presence of multiple I/O layers.

* gh-133890: The "tarfile" module now handles "UnicodeEncodeError" in
  the same way as "OSError" when cannot extract a member.

* gh-134097: Fix interaction of the new *REPL* and "-X showrefcount"
  command line option.

* gh-133889: The generated directory listing page in
  "http.server.SimpleHTTPRequestHandler" now only shows the decoded
  path component of the requested URL, and not the query and fragment.

* gh-134098: Fix handling paths that end with a percent-encoded slash
  ("%2f" or "%2F") in "http.server.SimpleHTTPRequestHandler".

* gh-132124: On POSIX-compliant systems,
  "multiprocessing.util.get_temp_dir()" now ignores "TMPDIR" (and
  similar environment variables) if the path length of "AF_UNIX"
  socket files exceeds the platform-specific maximum length when using
  the forkserver start method. Patch by Bénédikt Tran.

* gh-134062: "ipaddress": fix collisions in "__hash__()" for
  "IPv4Network" and "IPv6Network" objects.

* gh-133970: Make "string.templatelib.Template" and
  "string.templatelib.Interpolation" generic.

* gh-71253: Raise "ValueError" in "open()" if *opener* returns a
  negative file-descriptor in the Python implementation of "io" to
  match the C implementation.

* gh-133960: Simplify and improve "typing.evaluate_forward_ref()". It
  now no longer raises errors on certain invalid types. In several
  situations, it is now able to evaluate forward references that were
  previously unsupported.

* gh-133925: Make the private class "typing._UnionGenericAlias"
  hashable.

* gh-133653: Fix "argparse.ArgumentParser" with the *formatter_class*
  argument. Fix TypeError when *formatter_class* is a custom subclass
  of "HelpFormatter". Fix TypeError when *formatter_class* is not a
  subclass of "HelpFormatter" and non-standard *prefix_char* is used.
  Fix support of colorizing when *formatter_class* is not a subclass
  of "HelpFormatter".

* gh-132641: Fixed a race in "functools.lru_cache()" under free-
  threading.

* gh-133783: Fix bug with applying "copy.replace()" to "ast" objects.
  Attributes that default to "None" were incorrectly treated as
  required for manually created AST nodes.

* gh-133684: Fix bug where "annotationlib.get_annotations()" would
  return the wrong result for certain classes that are part of a class
  hierarchy where "from __future__ import annotations" is used.

* gh-77057: Fix handling of invalid markup declarations in
  "html.parser.HTMLParser".

* gh-130328: Speedup pasting in "PyREPL" on Windows in a legacy
  console. Patch by Chris Eibl.

* gh-133701: Fix bug where "typing.TypedDict" classes defined under
  "from __future__ import annotations" and inheriting from another
  "TypedDict" had an incorrect "__annotations__" attribute.

* gh-133581: Improve unparsing of t-strings in "ast.unparse()" and
  "from __future__ import annotations". Empty t-strings now round-trip
  correctly and formatting in interpolations is preserved. Patch by
  Jelle Zijlstra.

* gh-133551: Support t-strings (**PEP 750**) in "annotationlib". Patch
  by Jelle Zijlstra.

* gh-133439: Fix dot commands with trailing spaces are mistaken for
  multi-line SQL statements in the sqlite3 command-line interface.

* gh-132493: Avoid accessing "__annotations__" unnecessarily in
  "inspect.signature()".

* gh-132876: "ldexp()" on Windows doesn’t round subnormal results
  before Windows 11, but should.  Python’s "math.ldexp()" wrapper now
  does round them, so results may change slightly, in rare cases of
  very small results, on Windows versions before 11.

* gh-133009: "xml.etree.ElementTree": Fix a crash in
  "Element.__deepcopy__" when the element is concurrently mutated.
  Patch by Bénédikt Tran.

* gh-91555: Ignore log messages generated during handling of log
  messages, to avoid deadlock or infinite recursion. [NOTE: This
  change has since been reverted.]

* gh-125028: "functools.Placeholder" cannot be passed to
  "functools.partial()" as a keyword argument.

* gh-62824: Fix aliases for "iso8859_8" encoding. Patch by Dave
  Goncalves.

* gh-86155: "html.parser.HTMLParser.close()" no longer loses data when
  the "<script>" tag is not closed. Patch by Waylan Limberg.

* gh-69426: Fix "html.parser.HTMLParser" to not unescape character
  entities in attribute values if they are followed by an ASCII
  alphanumeric or an equals sign.

* bpo-28494: Improve Zip file validation false positive rate in
  "zipfile.is_zipfile()".


Core and Builtins
-----------------

* gh-134381: Fix "RuntimeError" when using a not-started
  "threading.Thread" after calling "os.fork()"

* gh-127960: PyREPL interactive shell no longer starts with
  "__package__" and "__file__" global names set to "_pyrepl" package
  internals. Contributed by Yuichiro Tachibana.

* gh-130397: Remove special-casing for C stack depth limits for WASI.
  Due to WebAssembly’s built-in stack protection this does not pose a
  security concern.

* gh-128066: Fixes an edge case where PyREPL improperly threw an error
  when Python is invoked on a read only filesystem while trying to
  write history file entries.

* gh-69605: When auto-completing an import in the *REPL*, finding no
  candidates now issues no suggestion, rather than suggestions from
  the current namespace.

* gh-134158: Fix coloring of double braces in f-strings and t-strings
  in the *REPL*.

* gh-134119: Fix crash when calling "next()" on an exhausted template
  string iterator. Patch by Jelle Zijlstra.

* gh-134100: Fix a use-after-free bug that occurs when an imported
  module isn’t in "sys.modules" after its initial import. Patch by
  Nico-Posada.

* gh-133999: Fix "SyntaxError" regression in "except" parsing after
  gh-123440.

* gh-133886: Fix "sys.remote_exec()" for non-ASCII paths in non-UTF-8
  locales and non-UTF-8 paths in UTF-8 locales.

* gh-133703: Fix hashtable in dict can be bigger than intended in some
  situations.

* gh-133778: Fix bug where assigning to the "__annotations__"
  attributes of classes defined under "from __future__ import
  annotations" had no effect.

* gh-132762: "fromkeys()" no longer loops forever when adding a small
  set of keys to a large base dict. Patch by Angela Liss.

* gh-133541: Inconsistent indentation in user input crashed the new
  REPL when syntax highlighting was active. This is now fixed.

* gh-133516: Raise "ValueError" when constants "True", "False" or
  "None" are used as an identifier after NFKC normalization.

* gh-132542: Update "Thread.native_id" after *fork(2)* to ensure
  accuracy. Patch by Noam Cohen.


C API
-----

* gh-134144: Fix crash when calling "Py_EndInterpreter()" with a
  *thread state* that isn’t the initial thread for the interpreter.


Build
-----

* gh-134455: Fixed "build-details.json" generation to use the correct
  "c_api.headers" as defined in **PEP 739**, instead of
  "c_api.include".

* gh-131769: Fix detecting when the build Python in a cross-build is a
  pydebug build.

* gh-117088: AIX linker don’t support -h option, so avoid it through
  platform check


Python 3.14.0 beta 1
====================

*Release date: 2025-05-06*


Windows
-------

* gh-132930: Marks the installer for Windows as deprecated and updates
  documentation to cover the new Python install manager.

* gh-127405: Add "ABIFLAGS" to "sysconfig.get_config_vars()" on
  Windows. Patch by Xuehai Pan.


Tools/Demos
-----------

* gh-130453: Allow passing multiple keyword arguments with the same
  function name in **pygettext**.

* gh-130195: Add warning messages when **pygettext** unimplemented "-a
  /--extract-all" option is called.


Tests
-----

* gh-133131: The iOS testbed will now select the most recently
  released “SE-class” device for testing if a device isn’t explicitly
  specified.

* gh-91048: Add ability to externally inspect all pending asyncio
  tasks, even if no task is currently entered on the event loop.

* gh-109981: The test helper that counts the list of open file
  descriptors now uses the optimised "/dev/fd" approach on all Apple
  platforms, not just macOS. This avoids crashes caused by guarded
  file descriptors.

* gh-132678: Add "--prioritize" to "-m test". This option allows the
  user to specify which selected tests should execute first, even if
  the order is otherwise randomized. This is particularly useful for
  tests that run the longest.

* gh-131290: Tests in "Lib/test" can now be correctly executed as
  standalone scripts.


Security
--------

* gh-115322: The underlying extension modules behind "readline":,
  "subprocess", and "ctypes" now raise audit events on previously
  uncovered code paths that could lead to file system access related
  to C function calling and external binary execution.  The
  "ctypes.call_function" audit hook has also been fixed to use an
  unsigned value for its "function pointer".


Library
-------

* gh-133490: Add color support to PDB in remote mode.

* gh-132493: Avoid eagerly evaluating annotations in functions
  decorated with "reprlib.recursive_repr()".

* gh-130645: Add color to stdlib argparse CLIs. Patch by Hugo van
  Kemenade.

* gh-119180: Make "annotationlib.get_annotations()" succeed with the
  "FORWARDREF" format if evaluating the annotations throws an
  exception other than "NameError" or "AttributeError".

* gh-133351: Fix remote PDB to correctly request tab completions for
  Python expressions from the server when completing a continuation
  line of a multi-line Python block.

* gh-133367: Add the "--feature-version", "--optimize", and "--show-
  empty" options to the "ast" command-line interface. Patch by Semyon
  Moroz.

* gh-133363: The "cmd.Cmd" class has been fixed to reliably call the
  "completedefault" method whenever the "do_shell" method is not
  defined and tab completion is requested for a line beginning with
  "!".

* gh-113081: Highlight syntax on source code in "pdb".

* gh-133349: Introduced auto-indent in "pdb" multi-line input.

* gh-133306: Use "\z" instead of "\Z" in "fnmatch.translate()" and
  "glob.translate()".

* gh-133306: Support "\z" as a synonym for "\Z" in "regular
  expressions".

* gh-133300: Make "argparse.ArgumentParser"’s "suggest_on_error" a
  keyword-only parameter. Patch by Hugo van Kemenade.

* gh-133290: Fix attribute caching issue when setting
  "ctypes._Pointer._type_" in the undocumented and deprecated
  "ctypes.SetPointerType()" function and the undocumented "set_type()"
  method.

* gh-133223: When PDB is attached to a remote process, do a better job
  of intercepting Ctrl+C and forwarding it to the remote process.

* gh-133153: Do not complete "pdb" commands in "interact" mode of
  "pdb".

* gh-133139: Add the "curses.assume_default_colors()" function, a
  refinement of the "curses.use_default_colors()" function which
  allows to change the color pair "0".

* gh-133089: Use original timeout value for
  "subprocess.TimeoutExpired" when the func "subprocess.run()" is
  called with a timeout instead of sometimes a confusing partial
  remaining time out value used internally on the final "wait()".

* gh-133036: "codecs.open()" is now deprecated. Use "open()" instead.
  Contributed by Inada Naoki.

* gh-132987: Many builtin and extension functions which accept an
  unsigned integer argument, now use "__index__()" if available.

* gh-124703: Set return code to "1" when aborting process from "pdb".

* gh-133005: Support passing "preset" option to "tarfile.open()" when
  using "'w|xz'" mode.

* gh-115032: Support for custom logging handlers with the *strm*
  argument is deprecated and scheduled for removal in Python 3.16.
  Define handlers with the *stream* argument instead. Patch by Mariusz
  Felisiak.

* gh-132991: Add "socket.IP_FREEBIND" constant on Linux 2.4 and later.

* gh-132995: Bump the version of pip bundled in ensurepip to version
  25.1.1

* gh-132933: The zipapp module now applies the filter when creating
  the list of files to add, rather than waiting until the file is
  being added to the archive.

* gh-121249: Always support the float complex and double complex C
  types in the "struct" module.  Patch by Sergey B Kirpichev.

* gh-132915: "fcntl.fcntl()" and "fcntl.ioctl()" can now detect a
  buffer overflow and raise "SystemError". The stack and memory can be
  corrupted in such case, so treat this error as fatal.

* gh-132017: Fix error when "pyrepl" is suspended, then resumed and
  terminated.

* gh-132893: Improved "statistics.NormalDist.cdf()" accuracy for
  inputs smaller than the mean.

* gh-130328: Speedup pasting in "PyREPL" on Windows. Fix by Chris
  Eibl.

* gh-132882: Fix copying of "typing.Union" objects containing objects
  that do not support the "|" operator.

* gh-93696: Fixed the breakpoint display error for frozen modules in
  "pdb".

* gh-129965: Add MIME types for ".7z", ".apk", ".deb", ".glb",
  ".gltf", ".gz", ".m4v", ".php", ".rar", ".rpm", ".stl" and ".wmv".
  Patch by Hugo van Kemenade.

* gh-132742: "fcntl.fcntl()" now supports arbitrary *bytes-like
  objects*, not only "bytes". "fcntl.ioctl()" now automatically
  retries system calls failing with EINTR and releases the GIL during
  a system call even for large bytes-like object.

* gh-132451: The CLI for the PDB debugger now accepts a "-p PID"
  argument to allow attaching to a running process. The process must
  be running the same version of Python as the one running PDB.

* gh-125618: Add a *format* parameter to
  "annotationlib.ForwardRef.evaluate()". Evaluating annotations in the
  "FORWARDREF" format now succeeds in more cases that would previously
  have raised an exception.

* gh-132805: Fix incorrect handling of nested non-constant values in
  the FORWARDREF format in "annotationlib".

* gh-132734: Add new constants for Bluetooth "sockets".

* gh-132673: Fix "AssertionError" raised on "ctypes.Structure" with
  "_align_ = 0" and "_fields_ = []".

* gh-132578: Rename the "threading.Thread._handle" field to avoid
  shadowing methods defined on subclasses of "threading.Thread".

* gh-132561: Fix the public "locked" method of
  "multiprocessing.SemLock" class. Also adding 2 tests for the
  derivated "multiprocessing.Lock" and "multiprocessing.RLock"
  classes.

* gh-121468: Add "pdb.set_trace_async()" function to support "await"
  statements in "pdb".

* gh-132493: "typing.Protocol" now uses
  "annotationlib.get_annotations()" when checking whether or not an
  instance implements the protocol with "isinstance()". This enables
  support for "isinstance" checks against classes with deferred
  annotations.

* gh-132536: Do not disable "PY_THROW" event in "bdb" because it can’t
  be disabled.

* gh-132527: Include the valid typecode ‘w’ in the error message when
  an invalid typecode is passed to "array.array".

* gh-132099: The Bluetooth socket with the "BTPROTO_HCI" protocol on
  Linux now accepts an address in the format of an integer
  "device_id", not only a tuple  "(device_id,)".

* gh-81793: Fix "os.link()" on platforms (like Linux) where the system
  "link()" function does not follow symlinks. On Linux, it now follows
  symlinks by default or if "follow_symlinks=True" is specified. On
  Windows, it now raises an error if "follow_symlinks=True" is passed.
  On macOS, it now raises an error if "follow_symlinks=False" is
  passed and the system "linkat()" function is not available at
  runtime.

* gh-132493: Support creation of "typing.Protocol" classes with
  annotations that cannot be resolved at class creation time.

* gh-132491: Rename "annotationlib.value_to_string" to
  "annotationlib.type_repr()" and provide better handling for function
  objects.

* gh-132426: Add "annotationlib.get_annotate_from_class_namespace()"
  as a helper for accessing annotations in metaclasses, and remove
  "annotationlib.get_annotate_function".

* gh-70145: Add support for channels in Bluetooth HCI protocol
  ("BTPROTO_HCI").

* gh-131913: Add a shortcut function
  "multiprocessing.Process.interrupt()" alongside the existing
  "multiprocessing.Process.terminate()" and
  "multiprocessing.Process.kill()" for an improved control over child
  process termination.

* gh-132439: Fix "PyREPL" on Windows: characters entered via AltGr are
  swallowed. Patch by Chris Eibl.

* gh-132429: Fix support of Bluetooth sockets on NetBSD and DragonFly
  BSD. Add support for *cid* and *bdaddr_type* in the BTPROTO_L2CAP
  address on FreeBSD. Return *cid* in "getsockname()" for
  BTPROTO_L2CAP if it is not zero.

* gh-132106: "QueueListener.start" now raises a "RuntimeError" if the
  listener is already started.

* gh-132417: Fix a "NULL" pointer dereference when a C function called
  using "ctypes" with "restype" "py_object" returns "NULL".

* gh-132385: Fix instance error suggestions trigger potential
  exceptions in "object.__getattr__()" in "traceback".

* gh-125866: Add optional *add_scheme* argument to
  "urllib.request.pathname2url()"; when set to true, a complete URL is
  returned. Likewise add optional *require_scheme* argument to
  "url2pathname()"; when set to true, a complete URL is accepted.

* gh-132308: A "traceback.TracebackException" now correctly renders
  the "__context__" and "__cause__" attributes from falsey
  "Exception", and the "exceptions" attribute from falsey
  "ExceptionGroup".

* gh-130645: Add colour to "argparse" help output. Patch by Hugo van
  Kemenade.

* gh-127495: In PyREPL, append a new entry to the "PYTHON_HISTORY"
  file *after* every statement.  This should preserve command-line
  history after interpreter is terminated.  Patch by Sergey B
  Kirpichev.

* gh-129463: Comparison of "annotationlib.ForwardRef" objects no
  longer uses the internal "__code__" and "__ast_node__" attributes,
  which are used as caches.

* gh-132250: Fixed the "SystemError" in "cProfile" when locating the
  actual C function of a method raises an exception.

* gh-132064: "annotationlib.get_annotations()" now uses the
  "__annotate__" attribute if it is present, even if "__annotations__"
  is not present. Additionally, the function now raises a "TypeError"
  if it is passed an object that does not have any annotatins.

* gh-130664: Support the "'_'" digit separator in formatting of the
  integral part of "Decimal"’s.  Patch by Sergey B Kirpichev.

* gh-131952: Add color output to the **json** CLI. Patch by Tomas
  Roun.

* gh-132063: Prevent exceptions that evaluate as falsey (namely, when
  their "__bool__" method returns "False" or their "__len__" method
  returns 0) from being ignored by
  "concurrent.futures.ProcessPoolExecutor" and
  "concurrent.futures.ThreadPoolExecutor".

* gh-132106: "logging.handlers.QueueListener" now implements the
  context manager protocol, allowing it to be used in a "with"
  statement.

* gh-132054: The "application/yaml" mime type (**RFC 9512**) is now
  supported by "mimetypes". Patch by Sasha “Nelie” Chernykh and Hugo
  van Kemenade.

* gh-119605: Respect "follow_wrapped" for "__init__()" and "__new__()"
  methods when getting the class signature for a class with
  "inspect.signature()". Preserve class signature after wrapping with
  "warnings.deprecated()". Patch by Xuehai Pan.

* gh-118761: Improve import times by up to 33x for the "shlex" module,
  and improve the performance of "shlex.quote()" by up to 12x. Patch
  by Adam Turner.

* gh-85302: Add support for "BTPROTO_SCO" in sockets on FreeBSD.

* gh-131757: Make "functools.lru_cache()" call the cached function
  unlocked to allow concurrency.

* gh-131423: "ssl" can show descriptions for errors added in OpenSSL
  3.4.1. Patch by Bénédikt Tran.

* gh-131434: Improve error reporting for incorrect format in
  "time.strptime()".

* gh-131524: Add help message to "platform" command-line interface.
  Contributed by Harry Lees.

* gh-100926: Move "ctypes.POINTER()" types cache from a global
  internal cache ("_pointer_type_cache") to the
  "ctypes._CData.__pointer_type__" attribute of the corresponding
  "ctypes" types. This will stop the cache from growing without limits
  in some situations.

* gh-85702: If "zoneinfo._common.load_tzdata" is given a package
  without a resource a "ZoneInfoNotFoundError" is raised rather than a
  "IsADirectoryError".

* gh-123471: Make concurrent iterations over "itertools.repeat" safe
  under free-threading.

* gh-131127: Systems using LibreSSL now successfully build.

* gh-89157: Make the pure Python implementation of
  "datetime.date.fromisoformat()", only accept ASCII strings for
  consistency with the C implementation.

* gh-130941: Fix "configparser.ConfigParser" parsing empty
  interpolation with "allow_no_value" set to "True".

* gh-110067: Make "heapq" max-heap functions "heapq.heapify_max()",
  "heapq.heappush_max()", "heapq.heappop_max()", and
  "heapq.heapreplace_max()" public. Previous underscored naming is
  kept for backwards compatibility. Additionally, the missing function
  "heapq.heappushpop_max()" has been added to both the C and Python
  implementations.

* gh-129098: Fix REPL traceback reporting when using "compile()" with
  an inexisting file. Patch by Bénédikt Tran.

* gh-130631: "http.cookiejar.join_header_words()" is now more similar
  to the original Perl version. It now quotes the same set of
  characters and always quote values that end with ""\n"".

* gh-130482: Add ability to specify name for "tkinter.OptionMenu" and
  "tkinter.ttk.OptionMenu".

* gh-77065: Add keyword-only optional argument *echo_char* for
  "getpass.getpass()" for optional visual keyboard feedback support.
  Patch by Semyon Moroz.

* gh-130317: Fix "PyFloat_Pack2()" and "PyFloat_Unpack2()" for NaN’s
  with payload.  This corrects round-trip for "struct.unpack()" and
  "struct.pack()" in case of the IEEE 754 binary16 “half precision”
  type. Patch by Sergey B Kirpichev.

* gh-130402: Joining running daemon threads during interpreter
  shutdown now raises "PythonFinalizationError".

* gh-130167: Improve speed of "difflib.IS_LINE_JUNK()". Patch by
  Semyon Moroz.

* gh-101410: Added more detailed messages for domain errors in the
  "math" module.

* gh-128384: Make "warnings.catch_warnings" use a context variable for
  holding the warning filtering state if the
  "sys.flags.context_aware_warnings" flag is set to true.  This makes
  using the context manager thread-safe in multi-threaded programs.
  The flag is true by default in free-threaded builds and is otherwise
  false. The value of the flag can be overridden by the the "-X
  context_aware_warnings" command-line option or by the
  "PYTHON_CONTEXT_AWARE_WARNINGS" environment variable.

* gh-129719: Fix missing "socket.CAN_RAW_ERR_FILTER" constant in the
  socket module on Linux systems. It was missing since Python 3.11.

* gh-129027: Raise "DeprecationWarning" for "sys._clear_type_cache()".
  This function was deprecated in Python 3.13 but it didn’t raise a
  runtime warning.

* gh-128307: Add "eager_start" keyword argument to
  "asyncio.loop.create_task()"

* gh-127604: Add support for printing the C stack trace on systems
  that support it via "faulthandler.dump_c_stack()" or via the
  *c_stack* argument in "faulthandler.enable()".

* gh-127385: Add the "F_DUPFD_QUERY" constant to the "fcntl" module.

* gh-126838: Add *resolve_host* keyword-only parameter to
  "urllib.request.url2pathname()", and fix handling of file URLs with
  authorities.

* gh-82129: Fix "NameError" when calling "typing.get_type_hints()" on
  a "dataclasses.dataclass()" created by
  "dataclasses.make_dataclass()" with un-annotated fields.

* gh-122559: Remove "__reduce__()" and "__reduce_ex__()" methods that
  always raise "TypeError" in the C implementation of "io.FileIO",
  "io.BufferedReader", "io.BufferedWriter" and "io.BufferedRandom" and
  replace them with default "__getstate__()" methods that raise
  "TypeError". This restores fine details of behavior of Python 3.11
  and older versions.

* gh-122179: "hashlib.file_digest()" now raises "BlockingIOError" when
  no data is available during non-blocking I/O. Before, it added
  spurious null bytes to the digest.

* gh-53032: Expose "decimal.IEEEContext()" to support creation of
  contexts corresponding to the IEEE 754 (2008) decimal interchange
  formats. Patch by Sergey B Kirpichev.

* gh-120220: Deprecate the "tkinter.Variable" methods
  "trace_variable()", "trace_vdelete()" and "trace_vinfo()". Methods
  "trace_add()", "trace_remove()" and "trace_info()" can be used
  instead.

* gh-113539: "webbrowser": Names in the "BROWSER" environment variable
  can now refer to already registered web browsers, instead of always
  generating a new browser command.

  This makes it possible to set "BROWSER" to the value of one of the
  supported browsers on macOS.

* bpo-44172: Keep a reference to original "curses" windows in
  subwindows so that the original window does not get deleted before
  subwindows.

* gh-75223: Deprecate undotted extensions in
  "mimetypes.MimeTypes.add_type()". Patch by Hugo van Kemenade.


IDLE
----

* gh-112936: fix IDLE: no Shell menu item in single-process mode.


Documentation
-------------

* gh-107006: Move documentation and example code for "threading.local"
  from its docstring to the official docs.

* gh-125142: As part of the builtin help intro text, show the keyboard
  shortcuts for the new, non-basic REPL (F1, F2, and F3).


Core and Builtins
-----------------

* gh-133336: "-J" is no longer reserved for use by Jython. Patch by
  Adam Turner.

* gh-133261: Fix bug where the cycle GC could untrack objects in the
  trashcan because they looked like they were immortal. When objects
  are added to the trashcan, we take care to ensure they keep a mortal
  reference count.

* gh-133346: Added experimental color theming support to the
  "_colorize" module.

* gh-132917: For the free-threaded build, check the process memory
  usage increase before triggering a full automatic garbage
  collection.  If the memory used has not increased 10% since the last
  collection then defer it.

* gh-91048: Add a new "python -m asyncio ps PID" command-line
  interface to inspect asyncio tasks in a running Python process.
  Displays a flat table of await relationships. A variant showing a
  tree view is also available as "python -m asyncio pstree PID". Both
  are useful for debugging async code. Patch by Pablo Galindo, Łukasz
  Langa, Yury Selivanov, and Marta Gomez Macias.

* gh-133304: Workaround NaN’s “canonicalization” in "PyFloat_Pack4()"
  and "PyFloat_Unpack4()" on RISC-V.

* gh-133197: Improve "SyntaxError" error messages for incompatible
  string / bytes prefixes.

* gh-133231: Add new utilities of observing JIT compilation:
  "sys._jit.is_available()", "sys._jit.is_enabled()", and
  "sys._jit.is_active()".

* gh-133194: "ast.parse()" will no longer parse new **PEP 758** syntax
  with older *feature_version* passed.

* gh-131798: Split "CALL_LEN" into several uops allowing the JIT to
  remove them when optimizing. Patch by Diego Russo.

* gh-131798: Use "sym_new_type" instead of "sym_new_not_null" for
  _BUILD_STRING, _BUILD_SET

* gh-132942: Fix two races in the type lookup cache.  This affected
  the free-threaded build and could cause crashes (apparently quite
  difficult to trigger).

* gh-131798: Propagate the return type of
  "_BINARY_OP_SUBSCR_TUPLE_INT" in JIT. Patch by Tomas Roun

* gh-132952: Speed up startup with the "-S" argument by importing the
  private "_io" module instead of "io". This fixes a performance
  regression introduced earlier in Python 3.14 development and
  restores performance to the level of Python 3.13.

* gh-131798: Allow the JIT to remove int guards after "_CALL_LEN" by
  setting the return type to int. Patch by Diego Russo

* gh-131798: Split "CALL_TUPLE_1" into several uops allowing the JIT
  to remove some of them. Patch by Tomas Roun

* gh-131798: Split "CALL_STR_1" into several uops allowing the JIT to
  remove some of them. Patch by Tomas Roun

* gh-132825: Enhance unhashable key/element error messages for "dict"
  and "set". Patch by Victor Stinner.

* gh-131591: Reset any **PEP 768** remote debugging pending call in
  children after "os.fork()" calls.

* gh-132713: Fix "repr(list)" race condition: hold a strong reference
  to the item while calling "repr(item)". Patch by Victor Stinner.

* gh-132661: Implement **PEP 750** (Template Strings). Add new syntax
  for t-strings and implement new internal
  "string.templatelib.Template" and "string.templatelib.Interpolation"
  types.

* gh-132479: Fix compiler crash in certain circumstances where
  multiple module-level annotations include comprehensions and other
  nested scopes.

* gh-132747: Fix a crash when calling "__get__()" of a *method* with a
  "None" second argument.

* gh-132744: Certain calls now check for runaway recursion and respect
  the system recursion limit.

* gh-132449: Syntax errors that look like misspellings of Python
  keywords now provide a helpful fix suggestion for the typo.
  Contributed by Pablo Galindo Salgado.

* gh-132737: Support profiling code that requires "__main__", such as
  "pickle".

* gh-132639: Added "PyLong_AsNativeBytes()",
  "PyLong_FromNativeBytes()" and "PyLong_FromUnsignedNativeBytes()" to
  the limited C API.

* gh-100239: Add specialisation for "BINARY_OP/SUBSCR" on list and
  slice.

* gh-132508: Uses tagged integers on the evaluation stack to represent
  the instruction offsets when reraising an exception. This avoids the
  need to box the integer which could fail in low memory conditions.

* gh-124476: Fix decoding from the locale encoding in the C.UTF-8
  locale.

* gh-131927: Compiler warnings originating from the same module and
  line number are now only emitted once, matching the behaviour of
  warnings emitted from user code. This can also be configured with
  "warnings" filters.

* gh-132457: Make "staticmethod()" and "classmethod()" generic.

* gh-131798: Use "sym_new_type" instead of "sym_new_not_null" for
  _BUILD_LIST, _BUILD_SET, _BUILD_MAP

* gh-131798: Split "CALL_TYPE_1" into several uops allowing the JIT to
  remove some of them.

* gh-132386: Fix crash when passing a dict subclass as the "globals"
  parameter to "exec()".

* gh-127682: No longer call "__iter__" twice when creating and
  executing a generator expression. Creating a generator expression
  from a non-interable will raise only when the generator expression
  is executed. This brings the behavior of generator expressions in
  line with other generators.

* gh-132261: The internal storage for annotations and annotate
  functions on classes now uses different keys in the class
  dictionary. This eliminates various edge cases where access to the
  "__annotate__" and "__annotations__" attributes would behave
  unpredictably.

* gh-132284: Don’t wrap base "PyCFunction" slots on class creation if
  not overridden.

* gh-130415: Improve the JIT’s ability to remove unused constant and
  local variable loads, and fix an issue where deallocating unused
  values could cause JIT code to crash or behave incorrectly.

* gh-126703: Fix possible use after free in cases where a method’s
  definition has the same lifetime as its "self".

* gh-132286: Fix that "type.__annotate__" was not deleted, when
  "type.__annotations__" was deleted.

* gh-131798: Allow the JIT to remove an extra "_TO_BOOL_BOOL"
  instruction after "_CONTAINS_OP_DICT" by setting the return type to
  bool.

* gh-124715: Prevents against stack overflows when calling
  "Py_DECREF()". Third-party extension objects no longer need to use
  the “trashcan” mechanism, as protection is now built into the
  "Py_DECREF()" macro.

* gh-131798: Allow the JIT compiler to remove some type checks for
  operations on lists, tuples, dictionaries, and sets.

* gh-128398: Improve error message when an object supporting the
  synchronous (resp. asynchronous) context manager protocol is entered
  using "async with" (resp. "with") instead of "with" (resp. "async
  with"). Patch by Bénédikt Tran.

* gh-131798: Allow the JIT to remove unicode guards after
  "_BINARY_OP_SUBSCR_STR_INT" by setting the return type to string.

* gh-131878: Handle uncaught exceptions in the main input loop for the
  new REPL.

* gh-131878: Fix support of unicode characters with two or more
  codepoints on Windows in the new REPL.

* gh-126835: Move constant folding to the peephole optimizer. Rename
  AST optimization related files (Python/ast_opt.c ->
  Python/ast_preprocess.c), structs (_PyASTOptimizeState ->
  _PyASTPreprocessState) and functions (_PyAST_Optimize ->
  _PyAST_Preprocess, _PyCompile_AstOptimize ->
  _PyCompile_AstPreprocess).

* gh-114809: Add support for macOS multi-arch builds with the JIT
  enabled

* gh-131507: PyREPL now supports syntax highlighting. Contributed by
  Łukasz Langa.

* gh-130907: If the "__annotations__" of a module object are accessed
  while the module is executing, return the annotations that have been
  defined so far, without caching them.

* gh-130104: Three-argument "pow()" now try calling "__rpow__()" if
  necessary. Previously it was only called in two-argument "pow()" and
  the binary power operator.

* gh-130070: Fixed an assertion error for "exec()" passed a string
  "source" and a non-"None" "closure". Patch by Bartosz Sławecki.

* gh-129958: Fix a bug that was allowing newlines inconsistently in
  format specifiers for single-quoted f-strings. Patch by Pablo
  Galindo.

* gh-129858: "elif" statements that follow an "else" block now have a
  specific error message.

* gh-69605: Add module autocomplete to PyREPL.

* gh-128555: Add the "sys.flags.thread_inherit_context" flag.

  * This flag is set to true by default on the free-threaded build and
    false otherwise.  If the flag is true, starting a new thread using
    "threading.Thread" will, by default, use a copy of the
    "contextvars.Context" from the caller of
    "threading.Thread.start()" rather than using an empty context.

  * Add the "-X thread_inherit_context" command-line option and
    "PYTHON_THREAD_INHERIT_CONTEXT" environment variable, which set
    the "thread_inherit_context" flag.

  * Add the "context" keyword parameter to "Thread".  It can be used
    to explicitly pass a context value to be used by a new thread.

  * Make the "_contextvars" module built-in.

* gh-123539: Improve "SyntaxError" message for using "import ... as"
  and "from ... import ... as" with not a name.

* gh-102567: "-X importtime" now accepts value "2", which indicates
  that an "importtime" entry should also be printed if an imported
  module has already been loaded. Patch by Noah Kim and Adam Turner.

* gh-116436: Improve error message when "TypeError" occurs during
  "dict.update()"

* gh-103997: String arguments passed to “-c” are now automatically
  dedented as if by "textwrap.dedent()". This allows “python -c”
  invocations to be indented in shell scripts without causing
  indentation errors. (Patch by Jon Crall and Steven Sun)

* gh-89562: Remove "hostflags" member from "PySSLContext" struct.


C API
-----

* gh-133166: Fix regression where "PyType_GetModuleByDef()" returns
  NULL without setting "TypeError" when a static type is passed.

* gh-133164: Add "PyUnstable_Object_IsUniqueReferencedTemporary()"
  function for determining if an object exists as a unique temporary
  variable on the interpreter’s stack.  This is a replacement for some
  cases where checking that "Py_REFCNT()" is one is no longer
  sufficient to determine if it’s safe to modify a Python object in-
  place with no visible side effects.

* gh-133140: Add "PyUnstable_Object_IsUniquelyReferenced()" as a
  replacement for "Py_REFNCT(op) == 1" on *free threaded* builds of
  Python.

* gh-131747: On non-Windows platforms, deprecate using
  "ctypes.Structure._pack_" to use a Windows-compatible layout on non-
  Windows platforms. The layout should be specified explicitly by
  setting "ctypes.Structure._layout_" to "'ms'".

* gh-128972: For non-free-threaded builds, the memory layout of
  "PyASCIIObject" is reverted to match Python 3.13. (Note that the
  structure is not part of stable ABI and so its memory layout is
  *guaranteed* to remain stable.)

* gh-133079: The undocumented APIs "Py_C_RECURSION_LIMIT" and
  "PyThreadState.c_recursion_remaining", added in 3.13, are removed
  without a deprecation period.

* gh-132987: The "k" and "K" formats in "PyArg_Parse()" now support
  the "__index__()" special method, like all other integer formats.

* gh-132909: Fix an overflow when handling the K format in
  "Py_BuildValue()". Patch by Bénédikt Tran.

* gh-132798: Deprecated and undocumented functions
  "PyUnicode_AsEncodedObject()", "PyUnicode_AsDecodedObject()",
  "PyUnicode_AsEncodedUnicode()" and "PyUnicode_AsDecodedUnicode()"
  are scheduled for removal in 3.15.

* gh-132470: Creating a "ctypes.CField" with a *byte_size* that does
  not match the actual type size now raises a "ValueError" instead of
  crashing the interpreter.

* gh-112068: [Reverted in gh-136991] Add support of nullable arguments
  in "PyArg_Parse()" and similar functions. Adding "?" after any
  format unit makes "None" be accepted as a value.

* gh-50333: Non-tuple sequences are deprecated as argument for the
  "(items)" format unit in "PyArg_ParseTuple()" and other argument
  parsing functions if *items* contains format units which store a
  borrowed buffer or a *borrowed reference*.


Build
-----

* gh-113464: Use the cpython-bin-deps “externals” repository for
  Windows LLVM dependency management. Installing LLVM manually is no
  longer necessary for Windows JIT builds.

* gh-133183: iOS compiler shims now include
  "IPHONEOS_DEPLOYMENT_TARGET" in target triples, ensuring that SDK
  version minimums are honored.

* gh-133167: Fix compilation process with "--enable-optimizations" and
  "--without-docstrings".

* gh-133171: Since free-threaded builds do not support the
  experimental JIT compiler, prevent these configurations from being
  combined.

* gh-132758: Fix building with tail call interpreter and pystats.

* gh-132649: The "PClayout" script now allows passing "--include-
  tcltk" on Windows ARM64.

* gh-132257: Change the default LTO flags on GCC to not pass "-flto-
  partition=none", and allow parallelization of LTO. For newer GNU
  makes and GCC, this has a multiple factor speedup for LTO build
  times, with no noticeable loss in performance.

* gh-132026: Fix use of undefined identifiers in platform triplet
  detection on MIPS Linux platforms.


Python 3.14.0 alpha 7
=====================

*Release date: 2025-04-08*


macOS
-----

* gh-124111: Update macOS installer to use Tcl/Tk 8.6.16.

* gh-131423: Update macOS installer to use OpenSSL 3.0.16. Patch by
  Bénédikt Tran.

* gh-131025: Update macOS installer to ship with SQLite 3.49.1.


Windows
-------

* gh-131423: Update bundled version of OpenSSL to 3.0.16. The new
  build also disables uplink support, which may be relevant to
  embedders but has no impact on normal use.

* gh-131453: Some "SND_*" and "MB_*" constants are added to
  "winsound".

* gh-91349: Replaces our copy of "zlib" with "zlib-ng", for
  performance improvements in "zlib".

* gh-131025: Update Windows installer to ship with SQLite 3.49.1.


Tools/Demos
-----------

* gh-132121: Always escape non-printable Unicode characters in
  **pygettext**.

* gh-131852: **msgfmt** no longer adds the "POT-Creation-Date" to
  generated ".mo" files for consistency with GNU "msgfmt".


Tests
-----

* gh-131277: Allow to unset one or more environment variables at once
  via "EnvironmentVarGuard.unset()". Patch by Bénédikt Tran.

* gh-131050: "test_ssl.test_dh_params" is skipped if the underlying
  TLS library does not support finite-field ephemeral Diffie-Hellman.


Security
--------

* gh-131809: Update bundled libexpat to 2.7.1

* gh-131261: Upgrade to libexpat 2.7.0

* gh-121284: Fix bug in the folding of rfc2047 encoded-words when
  flattening an email message using a modern email policy. Previously
  when an encoded-word was too long for a line, it would be decoded,
  split across lines, and re-encoded. But commas and other special
  characters in the original text could be left unencoded and
  unquoted. This could theoretically be used to spoof header lines
  using a carefully constructed encoded-word if the resulting rendered
  email was transmitted or re-parsed.


Library
-------

* gh-132174: Fix function name in error message of
  "_interpreters.run_string".

* gh-132171: Fix crash of "_interpreters.run_string" on string
  subclasses.

* gh-129204: Introduce new "_PYTHON_SUBPROCESS_USE_POSIX_SPAWN"
  environment variable knob in "subprocess" to control the use of
  "os.posix_spawn()".

* gh-132159: Do not shadow user arguments in generated "__new__()" by
  decorator "warnings.deprecated". Patch by Xuehai Pan.

* gh-132168: The "ctypes.py_object" type now supports subscription,
  making it a *generic type*.

* gh-84481: Add the "zipfile.ZipFile.data_offset" attribute, which
  stores the offset to the beginning of ZIP data in a file when
  available. When the "zipfile.ZipFile" is opened in either mode "'w'"
  or "'x'" and the underlying file does not support "tell()", the
  value will be "None" instead.

* gh-132075: Fix possible use of "socket" address structures with
  uninitialized members. Now all structure members are initialized
  with zeroes by default.

* gh-118761: Improve import times by up to 27x for the "string"
  module. Patch by Adam Turner.

* gh-125434: Display thread name in "faulthandler". Patch by Victor
  Stinner.

* gh-132002: Fix crash when deallocating "contextvars.ContextVar" with
  weird unahashable string names.

* gh-131938: "xml.etree.ElementTree": update the error message when an
  element to remove via "Element.remove" is not found. Patch by
  Bénédikt Tran.

* gh-115942: Add "threading.RLock.locked()",
  "multiprocessing.Lock.locked()", "multiprocessing.RLock.locked()",
  and allow "multiprocessing.managers.SyncManager.Lock()" and
  "multiprocessing.managers.SyncManager.RLock()" to proxy "locked()"
  call.

* gh-131974: Fix several thread-safety issues in "ctypes" on the *free
  threaded* build.

* gh-118761: Improve the import time of the "ast" module by extracting
  the "unparse()" function to a helper module.

* gh-107369: Improved performance of "textwrap.indent()" by an average
  of ~1.3x. Patch by Adam Turner.

* gh-131792: Improved performance of "textwrap.dedent()" by an average
  of ~2.4x, (with improvements of up to 4x for large inputs), and
  fixed a bug where blank lines with whitespace characters other than
  space or horizontal tab were not normalised to the newline. Patch by
  Adam Turner, Marius Juston, and Pieter Eendebak.

* gh-131668: "socket": Fix code parsing AF_BLUETOOTH socket addresses.

* gh-60115: Support frozen modules for "linecache.getline()".

* gh-131492: Fix a resource leak when constructing a "gzip.GzipFile"
  with a filename fails, for example when passing an invalid
  "compresslevel".

* gh-131435: 10-20% performance improvement of "random.randint()".

* gh-131461: Fix "ResourceWarning" when constructing a "gzip.GzipFile"
  in write mode with a broken file object.

* gh-125866: Deprecate the "nturl2path" module. Call
  "urllib.request.url2pathname()" and "pathname2url()" instead.

* gh-126367: Fix issue where "urllib.request.url2pathname()" raised
  "OSError" when given a Windows URI containing a colon character not
  following a drive letter, such as before an NTFS alternate data
  stream.

* gh-120144: Disable "CALL" event in "bdb" in "monitoring" backend
  when we don’t need any new events on the code object to get a better
  performance.

* gh-131358: Register "cseuckr" as an encoding alias for "euc_kr".

* gh-131325: Fix sendfile fallback implementation to drain data after
  writing to transport in "asyncio".

* gh-90548: "platform.libc_ver()" can now detect and report the
  version of "musl" on Alpine Linux.

* gh-129843: Fix incorrect argument passing in
  "warnings.warn_explicit()".

* gh-70647: When creating a "datetime" object with an out of range
  date a more informative error is raised.

* gh-130914: Allow "graphlib.TopologicalSorter.prepare()" to be called
  more than once as long as sorting has not started. Patch by Daniel
  Pope.

* gh-131236: Allow to generate multiple UUIDs at once via "python -m
  uuid --count".

* gh-126895: Fix "readline" in *free-threaded* build.

* gh-121468: "$_asynctask" is added as a "pdb" convenience variable to
  access the current asyncio task if applicable.

* gh-118761: Improve import time of "locale" using lazy import "re".
  Patch by Semyon Moroz.

* gh-129598: Fix "ast.unparse()" when "ast.Interactive" contains
  multiple statements.

* gh-85162: The "http.server" module now includes built-in support for
  HTTPS servers exposed by "http.server.HTTPSServer". This
  functionality is exposed by the command-line interface ("python -m
  http.server") through the "--tls-cert", "--tls-key" and "--tls-
  password-file" options. Patch by Semyon Moroz.

* gh-129463: The implementations of equality and hashing for
  "annotationlib.ForwardRef" now use all attributes on the object. Two
  "ForwardRef" objects are equal only if all attributes are equal.

* gh-128593: "annotationlib.ForwardRef" objects no longer cache their
  value when they are successfully evaluated. Successive calls to
  "annotationlib.ForwardRef.evaluate()" may return different values.

* gh-117779: Fix reading duplicated entries in "zipfile" by name.
  Reading duplicated entries (except the last one) by "ZipInfo" now
  emits a warning instead of raising an exception.

* gh-128715: The class of "Structure"/"Union" field descriptors is now
  available as "CField", and has new attributes to aid debugging and
  introspection.

* gh-128055: Fix "test.test_sysconfig.test_sysconfigdata_json" when
  running outside the build directory (eg. after installing).

* gh-126037: "xml.etree.ElementTree": Fix a crash in "Element.find",
  "Element.findtext" and "Element.findall" when the tag to find
  implements an "__eq__()" method mutating the element being queried.
  Patch by Bénédikt Tran.

* gh-127794: When headers are added to "email.message.Message"
  objects, either through "email.message.Message.__setitem__()" or
  "email.message.Message.add_header()", the field name is now
  validated according to **RFC 5322, Section 2.2** and a "ValueError"
  is raised if the field name contains any invalid characters.

* gh-123599: Deprecate "pathlib.PurePath.as_uri()"; use
  "pathlib.Path.as_uri()" instead.

* gh-126033: "xml.etree.ElementTree": Fix a crash in "Element.remove"
  when the element is concurrently mutated. Patch by Bénédikt Tran.

* gh-120144: Add the optional backend of "sys.monitoring" to "bdb" and
  use it for "pdb".

* gh-74598: Add "fnmatch.filterfalse()" for excluding names matching a
  pattern. Patch by Bénédikt Tran.

* gh-114917: Add support for AI_NUMERICSERV in getaddrinfo emulation

* bpo-17254: Added aliases for Thai Language using Microsoft Code
  Pages.


Documentation
-------------

* gh-131417: Mention "asyncio.Future" and "asyncio.Task" in generic
  classes list.


Core and Builtins
-----------------

* gh-131798: Allow the JIT to remove an extra "_TO_BOOL_BOOL"
  instruction after "_CONTAINS_OP_SET" by setting the return type to
  bool.

* gh-132011: Fix crash when calling "list.append()" as an unbound
  method.

* gh-131998: Fix a crash when using an unbound method *descriptor*
  object in a function where a bound method descriptor was used.

* gh-131591: Implement **PEP 768** (Safe external debugger interface
  for CPython). Add a new "sys.remote_exec()" function to the "sys"
  module. This function schedules the execution of a Python file in a
  separate process. Patch by Pablo Galindo, Matt Wozniski and Ivona
  Stojanovic.

* gh-131798: Allow JIT to omit str guard in truthiness test when str
  type is known.

* gh-131833: Add support for optionally dropping grouping parentheses
  when using multiple exception types as per **PEP 758**. Patch by
  Pablo Galindo

* gh-130924: Usage of a name in a function-scope annotation no longer
  triggers creation of a cell for that variable. This fixes a
  regression in earlier alphas of Python 3.14.

* gh-131800: Improve the experimental JIT’s ability to remove type
  checks for certain subscripting operations.

* gh-131738: Compiler emits optimized code for builtin any/all/tuple
  calls over a generator expression.

* gh-131719: Fix missing NULL check in "_PyMem_FreeDelayed" in *free-
  threaded* build.

* gh-131670: Fix "anext()" failing on sync "__anext__()" raising an
  exception.

* gh-131666: Fix signature of "anext_awaitable.close" objects. Patch
  by Bénédikt Tran.

* gh-130415: Optimize comparison of two constants in JIT builds

* gh-129149: Add fast path for small and medium-size integers in
  "PyLong_FromInt32()", "PyLong_FromUInt32()", "PyLong_FromInt64()"
  and "PyLong_FromUInt64()". Patch by Chris Eibl.

* gh-130887: Optimize the AArch64 code generation for the JIT. Patch
  by Diego Russo

* gh-130956: Optimize the AArch64 code generation for the JIT. Patch
  by Diego Russo

* gh-130928: Fix error message when formatting bytes using the "'i'"
  flag. Patch by Maxim Ageev.

* gh-130935: Annotations at the class and module level that are
  conditionally defined are now only reflected in "__annotations__" if
  the block they are in is executed. Patch by Jelle Zijlstra.

* gh-130775: Do not crash on negative "column" and "end_column" in
  "ast" locations.

* gh-130704: Optimize "LOAD_FAST" and its superinstruction form to
  reduce reference counting overhead. These instructions are replaced
  with faster variants that load borrowed references onto the operand
  stack when we can prove that the reference in the frame outlives the
  reference loaded onto the stack.

* gh-88887: Fixing multiprocessing Resource Tracker process leaking,
  usually observed when running Python as PID 1.

* gh-130115: Fix an issue with thread identifiers being sign-extended
  on some platforms.

* gh-99108: Add support for built-in implementation of HMAC (**RFC
  2104**) based on HACL*. Patch by Bénédikt Tran.

* gh-130080: Implement PEP 765: Disallow return/break/continue that
  exit a finally block.

* gh-129900: Fix return codes inside "SystemExit" not getting returned
  by the REPL.

* gh-128632: Disallow "__classdict__" as the name of a type parameter.
  Using this name would previously crash the interpreter in some
  circumstances.

* gh-126703: Improve performance of builtin methods by using a
  freelist.

* gh-126703: Improve performance of  "range" by using a freelist.


C API
-----

* gh-131740: Update PyUnstable_GC_VisitObjects to traverse perm gen.

* gh-131525: The PyTupleObject now caches the computed hash value in
  the new field ob_hash.


Build
-----

* gh-131865: The DTrace build now properly passes the "CC" and
  "CFLAGS" variables to the "dtrace" command when utilizing SystemTap
  on Linux.

* gh-131675: Fix mimalloc library builds for 32-bit ARM targets.

* gh-131691: clang-cl on Windows needs option "/EHa" to support SEH
  (structured exception handling) correctly. Fix by Chris Eibl.

* gh-131278: Add optimizing flag "WITH_COMPUTED_GOTOS" to Windows
  builds for when using a compiler that supports it (currently clang-
  cl). Patch by Chris Eibl.

* gh-130213: Update the vendored HACL* library to fix build issues
  with older clang compilers.

* gh-130673: Fix potential "KeyError" when handling object sections
  during JIT building process.


Python 3.14.0 alpha 6
=====================

*Release date: 2025-03-14*


macOS
-----

* gh-128540: Ensure web browser is launched by "webbrowser.open()" on
  macOS, even for "file://" URLs.


Windows
-------

* gh-131020: pylauncher correctly detects a BOM when searching for the
  shebang. Fix by Chris Eibl.


Tools/Demos
-----------

* gh-130453: Make it possible to override default keywords in
  **pygettext**.

* gh-85012: Correctly reset "msgctxt" when compiling messages in
  **msgfmt**.

* gh-130453: Extend support for specifying custom keywords in
  **pygettext**.

* gh-130195: Add warning messages when "pygettext" unimplemented "-a
  /--extract-all" option is called.

* gh-130057: Add support for translator comments in **pygettext.py**.

* gh-130025: The iOS testbed now correctly handles symlinks used as
  Python framework references.

* gh-129911: Fix the keyword entry in the help output of
  **pygettext**.


Tests
-----

* gh-129200: Multiple iOS testbed runners can now be started at the
  same time without introducing an ambiguity over simulator ownership.

* gh-130292: The iOS testbed will now run successfully on a machine
  that has not previously run Xcode tests (such as CI configurations).

* gh-130293: The tests of terminal colorization are no longer
  sensitive to the value of the "TERM" variable in the testing
  environment.

* gh-129401: Fix a flaky test in "test_repr_rlock" that checks the
  representation of "multiprocessing.RLock".

* gh-126332: Add unit tests for pyrepl.


Security
--------

* gh-127371: Avoid unbounded buffering for
  "tempfile.SpooledTemporaryFile.writelines()". Previously, disk
  spillover was only checked after the lines iterator had been
  exhausted. This is now done after each line is written.


Library
-------

* gh-131204: Use monospace font from System Font Stack for cross-
  platform support in "difflib.HtmlDiff".

* gh-131196: Improve performance of "uuid.UUID.hex" and
  "uuid.UUID.__str__".

* gh-130940: The behavior of "PyConfig.use_system_logger" was modified
  to be enabled by default on iOS. It remains disabled by default on
  macOS.

* gh-131123: Supported completions for attributes of convenience
  variables in "pdb".

* gh-93096: Removed undocumented CLI "python -m difflib". Use "python
  -m doctest Lib/difflib.py -v" instead. Patch by Semyon Moroz.

* gh-93096: Removed undocumented "-t" and "-v" arguments of "python -m
  pickle". Use "python -m doctest Lib/pickle.py -v" instead. Patch by
  Semyon Moroz.

* gh-81267: Correct "time.sleep()" error message when an object that
  cannot be interpreted as an integer or float is provided.

* gh-93096: Removed undocumented "-t" and "-v" arguments of "python -m
  pickletools". Use "python -m doctest Lib/pickletools.py -v" instead.
  Patch by Semyon Moroz.

* gh-131045: Fix issue with "__contains__", values, and pseudo-members
  for "enum.Flag".

* gh-130959: Fix pure-Python implementation of
  "datetime.time.fromisoformat()" to reject times with spaces in
  fractional part (for example, "12:34:56.400 +02:00"), matching the C
  implementation. Patch by Michał Gorny.

* gh-130806: Deleting "gzip.GzipFile" before it is closed now emits a
  "ResourceWarning".

* gh-130637: Add validation for numeric response data in
  poplib.POP3.stat() method

* gh-130665: Only apply locale to calendar CLI when set via "--locale"
  and not via "LANG" environment variable.

* gh-130660: "sys.ps1" and "sys.ps2" are now restored after
  "code.interact()" call.

* gh-130608: Remove *dirs_exist_ok* argument from
  "pathlib.Path.copy()" and "copy_into()". These methods are new in
  Python 3.14.

* gh-130461: Remove ".. index::" directives from the "uuid" module
  documentation. These directives previously created entries in the
  general index for "getnode()" as well as the "uuid1()", "uuid3()",
  "uuid4()", "uuid5()", and "uuid8()" constructor functions.

* gh-130379: The zipapp module now calculates the list of files to be
  added to the archive before creating the archive. This avoids
  accidentally including the target when it is being created in the
  source directory.

* gh-82987: Inline breakpoints like "breakpoint()" or
  "pdb.set_trace()" will always stop the program at calling frame,
  ignoring the "skip" pattern (if any).

* gh-125377: "<tab>" at the beginning of the line in "pdb" multi-line
  input will fill in a 4-space indentation now, instead of inserting a
  "\t" character.

* gh-125413: Ensure the path returned from "pathlib.Path.copy()" or
  "move()" has fresh "info".

* gh-65697: stdlib configparser will now attempt to validate that keys
  it writes will not result in file corruption (creating a file unable
  to be accurately parsed by a future read() call from the same
  parser). Attempting a corrupting write() will raise an
  InvalidWriteError.

* gh-125413: Speed up "Path.copy" by making better use of "info"
  internally.

* gh-130285: Fix corner case for "random.sample()" allowing the
  *counts* parameter to specify an empty population. So now,
  "sample([], 0, counts=[])" and "sample('abc', k=0, counts=[0, 0,
  0])" both give the same result as "sample([], 0)".

* gh-124703: Executing "quit" command in "pdb" will raise
  "bdb.BdbQuit" when "pdb" is started from an interactive console
  using "breakpoint()" or "pdb.set_trace()".

* gh-107773: Make "datetime" subclass "__repr__()" consistent both
  implementations. Patch by Semyon Moroz.

* gh-130250: Fix regression in "traceback.print_last()".

* gh-123471: Make concurrent iterations over "itertools.batched" safe
  under free-threading.

* gh-57537: Support breakpoints for "zipimport" modules on "pdb"

* gh-130230: Fix crash in "pow()" with only "Decimal" third argument.

* gh-126944: Show explicit errors when required arguments of "pdb"
  commands are missing

* gh-127750: Improve repr of "functools.singledispatchmethod" methods
  and descriptors.

* gh-128520: Apply type conversion consistently in "pathlib.PurePath"
  and "Path" methods can accept a path object as an argument, such as
  "match()" and "rename()". The argument is now converted to path
  object if it lacks a "with_segments()" attribute, and not otherwise.

* gh-118761: Reverts a change in the previous release attempting to
  make some stdlib imports used within the "subprocess" module lazy as
  this was causing errors during "__del__" finalizers calling methods
  such as "terminate", or "kill", or "send_signal".

* gh-130164: Fixed failure to raise "TypeError" in
  "inspect.Signature.bind()" for positional-only arguments provided by
  keyword when a variadic keyword argument (e.g. "**kwargs") is
  present.

* gh-130151: Fix reference leaks in "_hashlib.hmac_new()" and
  "_hashlib.hmac_digest()". Patch by Bénédikt Tran.

* gh-130145: Fix "asyncio.AbstractEventloop.run_forever()" when
  another loop is already running.

* gh-130139: Fix bug where "ast.parse()" did not error on AST input
  which is not of the correct type, when called with optimize=False.

* gh-127260: Forbid the use of colon (“:”) as a fractional component
  separator and other improvements to the consistency of error raising
  between the C and Python implementations of
  "datetime.time.fromisoformat()" and
  "datetime.datetime.fromisoformat()". Patch by Semyon Moroz.

* gh-85795: Using "super()" and "__class__" *closure variable* in
  user-defined methods of "typing.NamedTuple" subclasses is now
  explicitly prohibited at runtime. Contributed by Bartosz Sławecki in
  gh-130082.

* gh-118761: Improve import time of "cmd" by lazy importing "inspect"
  and removing "string". Patch by Semyon Moroz.

* gh-129726: Fix "gzip.GzipFile" raising an unraisable exception
  during garbage collection when referring to a temporary object by
  breaking the reference loop with "weakref".

* gh-127750: Remove broken "functools.singledispatchmethod()" caching
  introduced in gh-85160. Achieve the same performance using different
  optimization.

* gh-129948: Add support for shared "set" to
  "multiprocessing.managers.SyncManager" via "SyncManager.set()".

* gh-129965: Update MIME types for ".avi" and ".wav". Add MIME types
  for ".docx", ".pptx", ".xlsx", ".epub", ".flac", ".m4a", ".odg",
  ".odp", ".ods", ".odt", ".oga", ".ogg", ".ogx" and ".weba". Patch by
  Hugo van Kemenade.

* gh-129889: Support context manager protocol by "contextvars.Token".
  Patch by Andrew Svetlov.

* gh-97850: Update the deprecation warning of
  "importlib.abc.Loader.load_module()".

* gh-129678: "configparser.ConfigParser": do not write an empty
  unnamed section

* gh-128641: Restore "configparser.ConfigParser.read()" performance.

* gh-129569: Fix "unicodedata.normalize()" to always return a built-in
  "str" object when given an input of a "str" subclass, regardless of
  whether the string is already normalized.

* gh-128231: Execution of multiple statements in the new REPL now
  stops immediately upon the first exception encountered. Patch by
  Bartosz Sławecki.

* gh-96092: Fix bug in "traceback.walk_stack()" called with None where
  it was skipping more frames than in prior versions. This bug fix
  also changes walk_stack to walk the stack in the frame where it was
  called rather than where it first gets used.

* gh-129288: Add optional "l2_cid" and "l2_bdaddr_type" fields to
  "socket" "BTPROTO_L2CAP" sockaddr tuple.

* gh-128703: Fix "mimetypes.guess_type()" to use default mapping for
  empty "Content-Type" in registry.

* gh-128647: Eagerly write to buffers passed to "gzip.GzipFile"’s
  "readinto()" and "readinto1()" implementations, avoiding unnecessary
  allocations. Patch by Chris Markiewicz.

* gh-128184: Improve display of "annotationlib.ForwardRef" object
  within "inspect.Signature" representations. This also fixes a
  "NameError" that was raised when using "dataclasses.dataclass()" on
  classes with unresolvable forward references.

* gh-128041: Add
  "concurrent.futures.ProcessPoolExecutor.terminate_workers()" and
  "concurrent.futures.ProcessPoolExecutor.kill_workers()" as ways to
  terminate or kill all living worker processes in the given pool.
  (Contributed by Charles Machalow in gh-130849.)

* gh-127647: Add protocols "io.Reader" and "io.Writer" as alternatives
  to "typing.IO", "typing.TextIO", and "typing.BinaryIO".

* gh-109798: Added additional information into error messages in
  "datetime", and made the messages more consistent between the C and
  Python implementations. Patch by Semyon Moroz.

* gh-125746: Delay deprecated "zipimport.zipimporter.load_module()"
  removal time to 3.15. Use "zipimport.zipimporter.exec_module()"
  instead.

* gh-74028: Add the optional "buffersize" parameter to
  "concurrent.futures.Executor.map()" to limit the number of submitted
  tasks whose results have not yet been yielded. If the buffer is
  full, iteration over the *iterables* pauses until a result is
  yielded from the buffer.

* gh-124927: Non-printing characters are now properly handled in the
  new REPL.

* gh-124096: Turn on virtual terminal mode and enable bracketed paste
  in REPL on Windows console. (If the terminal does not support
  bracketed paste, enabling it does nothing.)

* gh-89083: Add "uuid.uuid7()" for generating UUIDv7 objects as
  specified in **RFC 9562**. Patch by Bénédikt Tran.

* gh-89083: Add "uuid.uuid6()" for generating UUIDv6 objects as
  specified in **RFC 9562**. Patch by Bénédikt Tran.

* gh-117151: Increase "io.DEFAULT_BUFFER_SIZE" from 8k to 128k and
  adjust "open()" on platforms where "os.fstat()" provides a
  "st_blksize" field (such as Linux) to use "max(min(blocksize, 8
  MiB), io.DEFAULT_BUFFER_SIZE)" rather than always using the device
  block size. This should improve I/O performance. Patch by Romain
  Morotti.

* gh-105499: Make "types.UnionType" an alias for "typing.Union". Both
  "int | str" and "Union[int, str]" now create instances of the same
  type. Patch by Jelle Zijlstra.

* gh-93096: Document the command-line for "mimetypes". It now exits
  with "1" on failure instead of "0" and "2" on incorrect command-line
  parameters instead of "1". Also, errors are printed to stderr
  instead of stdout and their text is made tighter. Patch by Oleg
  Iarygin and Hugo van Kemenade.


Documentation
-------------

* gh-125722: Require Sphinx 8.2.0 or later to build the Python
  documentation. Patch by Adam Turner.

* gh-129712: The wheel tags supported by each macOS universal SDK
  option are now documented.

* gh-46236: C API: Document "PyUnicode_RSplit()",
  "PyUnicode_Partition()" and "PyUnicode_RPartition()".


Core and Builtins
-----------------

* gh-131141: Fix data race in "sys.monitoring" instrumentation while
  registering callback.

* gh-130804: Fix support of unicode characters on Windows in the new
  REPL.

* gh-130932: Fix incorrect exception handling in
  "_PyModule_IsPossiblyShadowing"

* gh-122029: "sys.setprofile()" and "sys.settrace()" will not generate
  a "c_call" event for "INSTRUMENTED_CALL_FUNCTION_EX" if the callable
  is a method with a C function wrapped, because we do not generate
  "c_return" event in such case.

* gh-129964: Fix JIT crash on Windows on Arm. Patch by Diego Russo and
  Brandt Bucher.

* gh-130851: Fix a crash in the *free threading* build when
  constructing a "code" object with "co_consts" that contains
  instances of types that are not otherwise generated by the bytecode
  compiler.

* gh-128534: Ensure that both left and right branches have the same
  source for "async for" loops. Add these branches to the
  "co_branches()" iterator.

* gh-130794: Fix memory leak in the *free threaded* build when
  resizing a shared list or dictionary from multiple short-lived
  threads.

* gh-130415: Improve JIT understanding of integers in boolean context.

* gh-130382: Fix "PyRefTracer_DESTROY" not being sent from
  "Python/ceval.c" "Py_DECREF()".

* gh-130574: Renumber "RESUME" from 149 to 128.

* gh-124878: Fix race conditions during runtime finalization that
  could lead to accessing freed memory.

* gh-130415: Improve the experimental JIT’s ability to narrow boolean
  values based on the results of truthiness tests.

* gh-130618: Fix a bug that was causing "UnicodeDecodeError" or
  "SystemError" to be raised when using f-strings with "lambda"
  expressions with non-ASCII characters. Patch by Pablo Galindo

* gh-123044: Make sure that the location of branch targets in "match"
  cases is in the body, not the pattern.

* gh-128534: Add branch monitoring ("BRANCH_LEFT" and "BRANCH_RIGHT"
  events) for "async for" loops.

* gh-130163: Fix possible crashes related to concurrent change and use
  of the "sys" module attributes.

* gh-122029: "INSTRUMENTED_CALL_KW" will expand the method before
  monitoring to reflect the actual behavior more accurately.

* gh-130415: Improve JIT’s ability to optimize strings in boolean
  contexts.

* gh-130396: Use actual stack limits (from *pthread_getattr_np(3)*)
  for linux, and other systems with "_GNU_SOURCE" defined, when
  determining limits for C stack protection.

* gh-128396: Fix a crash that occurs when calling "locals()" inside an
  inline comprehension that uses the same local variable as the outer
  frame scope where the variable is a free or cell var.

* gh-129107: Fix two more "bytearray" functions for *free threading*.

* gh-127705: Use tagged references ("_PyStackRef") for the default
  build as well as for the free-threading build. This has a small
  negative performance impact short-term but will enable larger
  speedups in the future and significantly reduce maintenance costs by
  allowing a single implementation of tagged references in the future.

* gh-130094: Fix two race conditions involving concurrent imports that
  could lead to spurious failures with "ModuleNotFoundError".

* gh-129107: Make "bytearray" iterator safe under *free threading*.

* gh-115802: Use the more efficient “medium” code model for JIT-
  compiled code on supported platforms.

* gh-107956: A "build-details.json" file is now install in the
  platform-independent standard library directory (**PEP 739**
  implementation).

* gh-116042: Fix location for SyntaxErrors of invalid escapes in the
  tokenizer. Patch by Pablo Galindo

* gh-91079: Change C stack overflow protection to consider the amount
  of stack consumed, rather than a counter. This allows deeper
  recursion in many cases, but remains safe.

* gh-129715: Improve the experimental JIT’s handling of returns to
  unknown callers.

* gh-129983: Fix data race in compile_template in "sre.c".

* gh-129967: Fix a race condition in the *free threading* build when
  "repr(set)" is called concurrently with "set.clear()".

* gh-129953: The internal (evaluation) stack is now spilled to memory
  whenever execution escapes from the interpreter or JIT compiled
  code. This should have no observable effect in either Python or
  builtin extensions, but will allow various important optimizations
  in the future.

* gh-129515: Clarify syntax error messages for conditional expressions
  when a statement is specified before an "if" or after an "else"
  keyword.

* gh-129349: "bytes.fromhex()" and "bytearray.fromhex()" now accepts
  ASCII "bytes" and *bytes-like objects*.

* gh-129149: Add fast path for medium-size integers in
  "PyLong_FromSsize_t()". Patch by Chris Eibl.

* gh-129107: Make the "bytearray" safe under *free threading*.

* gh-128974: Fix a crash in "UnicodeError.__str__" when custom
  attributes implement "__str__()" with side-effects. Patch by
  Bénédikt Tran.

* gh-126085: "typing.TypeAliasType" now supports star unpacking.

* gh-125331: "from __future__ import barry_as_FLUFL" now works in more
  contexts, including when it is used in files, with the "-c" flag,
  and in the REPL when there are multiple statements on the same line.
  Previously, it worked only on subsequent lines in the REPL, and when
  the appropriate flags were passed directly to "compile()". Patch by
  Pablo Galindo.

* gh-121464: Make concurrent iterations over the same "enumerate()"
  iterator safe under free-threading. See Strategy for Iterators in
  Free Threading.

* gh-87790: Support underscore and comma as thousands separators in
  the fractional part for floating-point presentation types of the
  new-style string formatting (with "format()" or f-strings).  Patch
  by Sergey B Kirpichev.

* gh-124445: Fix specialization of generic aliases that are generic
  over a "typing.ParamSpec" and have been specialized with a nested
  type variable.

* gh-120608: Adapt "reversed()" for use in the free-threading build.
  The "reversed()" is still not thread-safe in the sense that
  concurrent iterations may see the same object, but they will not
  corrupt the interpreter state.

* gh-100388: Fix the "platform._sys_version()" method when "__DATE__"
  is undefined at buildtime by changing default buildtime datetime
  string to the UNIX epoch.

* bpo-44369: Improve syntax errors for incorrectly closed strings.
  Patch by Pablo Galindo


C API
-----

* gh-111178: Fix "PyCMethod" API: replace "size_t nargs" with
  "Py_ssize_t nargs" in "PyCMethod". Patch by Victor Stinner.

* gh-130947: Add again "PySequence_Fast()" to the limited C API. Patch
  by Victor Stinner.

* gh-128863: The following private functions are deprecated and
  planned for removal in Python 3.18:

  * "_PyUnicodeWriter_Init()": replace
    "_PyUnicodeWriter_Init(&writer)" with "writer =
    PyUnicodeWriter_Create(0)".

  * "_PyUnicodeWriter_Finish()": replace
    "_PyUnicodeWriter_Finish(&writer)" with
    "PyUnicodeWriter_Finish(writer)".

  * "_PyUnicodeWriter_Dealloc()": replace
    "_PyUnicodeWriter_Dealloc(&writer)" with
    "PyUnicodeWriter_Discard(writer)".

  * "_PyUnicodeWriter_WriteChar()": replace
    "_PyUnicodeWriter_WriteChar(&writer, ch)" with
    "PyUnicodeWriter_WriteChar(writer, ch)".

  * "_PyUnicodeWriter_WriteStr()": replace
    "_PyUnicodeWriter_WriteStr(&writer, str)" with
    "PyUnicodeWriter_WriteStr(writer, str)".

  * "_PyUnicodeWriter_WriteSubstring()": replace
    "_PyUnicodeWriter_WriteSubstring(&writer, str, start, end)" with
    "PyUnicodeWriter_WriteSubstring(writer, str, start, end)".

  * "_PyUnicodeWriter_WriteASCIIString()": replace
    "_PyUnicodeWriter_WriteASCIIString(&writer, str)" with
    "PyUnicodeWriter_WriteUTF8(writer, str)".

  * "_PyUnicodeWriter_WriteLatin1String()": replace
    "_PyUnicodeWriter_WriteLatin1String(&writer, str)" with
    "PyUnicodeWriter_WriteUTF8(writer, str)".

  * "_PyUnicodeWriter_Prepare()": (no replacement).

  * "_PyUnicodeWriter_PrepareKind()": (no replacement).

  The pythoncapi-compat project can be used to get these new public
  functions on Python 3.13 and older.

  Patch by Victor Stinner.

* gh-45325: Add a new "p" format parameter to "Py_BuildValue()" that
  allows to take a C integer and produce a Python "bool" object. Patch
  by Pablo Galindo.


Build
-----

* gh-131035: Use "-flto=thin" for faster build times using clang-cl on
  Windows. Patch by Chris Eibl.

* gh-130740: Ensure that "Python.h" is included before "stdbool.h"
  unless "pyconfig.h" is included before or in some platform-specific
  contexts.

* gh-130090: Building with "PlatformToolset=ClangCL" on Windows now
  supports PGO (profile guided optimization). Patch by Chris Eibl with
  invaluable support from Steve Dover.

* gh-129819: Allow building the JIT with the tailcall interpreter.

* gh-129989: Fix a bug where the tailcall interpreter was enabled when
  "--without-tail-call-interp" was provided to the configure script.

* gh-129838: Don’t redefine "_Py_NO_SANITIZE_UNDEFINED" when compiling
  with a recent GCC version and undefined sanitizer enabled.

* gh-82909: "#pragma"-based linking with "python3*.lib" can now be
  switched off with Py_NO_LINK_LIB. Patch by Jean-Christophe Fillion-
  Robin.


Python 3.14.0 alpha 5
=====================

*Release date: 2025-02-11*


macOS
-----

* gh-91132: Update macOS installer to use ncurses 6.5.


Tools/Demos
-----------

* gh-129248: The iOS test runner now strips the log prefix from each
  line output by the test suite.

* gh-104400: Fix several bugs in extraction by switching to an AST
  parser in **pygettext**.


Tests
-----

* gh-129386: Add "test.support.reset_code", which can be used to reset
  various bytecode-level optimizations and local instrumentation for a
  function.

* gh-128474: Disable "test_embed" test cases that segfault on BOLT
  instrument binaries. The tests are only disabled when BOLT is
  enabled.

* gh-128003: Add an option "--parallel-threads=N" to the regression
  test runner that runs individual tests in multiple threads in
  parallel in order to find concurrency bugs.  Note that most of the
  test suite is not yet reviewed for thread-safety or annotated with
  "@thread_unsafe" when necessary.


Security
--------

* gh-105704: When using "urllib.parse.urlsplit()" and
  "urllib.parse.urlparse()" host parsing would not reject domain names
  containing square brackets ("[" and "]"). Square brackets are only
  valid for IPv6 and IPvFuture hosts according to RFC 3986 Section
  3.2.2.

* gh-126108: Fix a possible "NULL" pointer dereference in
  "PySys_AddWarnOptionUnicode()".

* gh-80222: Fix bug in the folding of quoted strings when flattening
  an email message using a modern email policy. Previously when a
  quoted string was folded so that it spanned more than one line, the
  surrounding quotes and internal escapes would be omitted. This could
  theoretically be used to spoof header lines using a carefully
  constructed quoted string if the resulting rendered email was
  transmitted or re-parsed.

* gh-119511: Fix a potential denial of service in the "imaplib"
  module. When connecting to a malicious server, it could cause an
  arbitrary amount of memory to be allocated. On many systems this is
  harmless as unused virtual memory is only a mapping, but if this hit
  a virtual address size limit it could lead to a "MemoryError" or
  other process crash. On unusual systems or builds where all
  allocated memory is touched and backed by actual ram or storage it
  could’ve consumed resources doing so until similarly crashing.


Library
-------

* gh-129939: Comparison pages with highlighted changes generated by
  the "difflib.HtmlDiff" class now support dark mode.

* gh-129928: Raise "sqlite3.ProgrammingError" if a user-defined SQL
  function with invalid number of parameters is created. Patch by
  Erlend Aasland.

* gh-129583: Update bundled pip to 25.0.1

* gh-129766: Fix crash in "warnings", when calling "_release_lock()"
  with no existing lock.

* gh-129005: "_pyio.FileIO.readall()" now allocates, resizes, and
  fills a data buffer using the same algorithm "_io.FileIO.readall()"
  uses.

* gh-129646: Update the locale alias mapping in the "locale" module to
  match the latest X Org locale alias mapping and support new locales
  in Glibc 2.41.

* gh-128317: Put CLI calendar highlighting in private class, removing
  "highlight_day" from public "calendar.TextCalendar" API. Patch by
  Hugo van Kemenade.

* gh-129603: Fix bugs where "sqlite3.Row" objects could segfault if
  their inherited "description" was set to "None". Patch by Erlend
  Aasland.

* gh-129559: Add "bytearray.resize()" method so "bytearray" can be
  efficiently resized in place.

* gh-129502: Unlikely errors in preparing arguments for "ctypes"
  callback are now handled in the same way as errors raised in the
  callback of in converting the result of the callback – using
  "sys.unraisablehook()" instead of "sys.excepthook()" and not setting
  "sys.last_exc" and other variables.

* gh-129403: Corrected "ValueError" message for "asyncio.Barrier" and
  "threading.Barrier".

* gh-129409: Fix an integer overflow in the "csv" module when writing
  a data field larger than 2GB.

* gh-126400: Add a socket *timeout* keyword argument to
  "logging.handlers.SysLogHandler".

* gh-118761: Always lazy import "warnings" in "threading". Patch by
  Taneli Hukkinen.

* gh-118761: Improve import time of "subprocess" by lazy importing
  "locale" and "signal". Patch by Taneli Hukkinen.

* gh-129346: In "sqlite3", handle out-of-memory when creating user-
  defined SQL functions.

* gh-129005: Optimize "_pyio.FileIO.readinto" by avoiding unnecessary
  objects and copies using "os.readinto()".

* gh-129195: Support reporting call graph information from
  "asyncio.staggered.staggered_race()".

* gh-129205: Add "os.readinto()" to read into a buffer object from a
  file descriptor.

* gh-128772: Fix "pydoc" for methods with the "__module__" attribute
  equal to "None".

* gh-129061: Fix FORCE_COLOR and NO_COLOR when empty strings. Patch by
  Hugo van Kemenade.

* gh-92897: Scheduled the deprecation of the "check_home" argument of
  "sysconfig.is_python_build()" to Python 3.15.

* gh-129064: Deprecate "sysconfig.expand_makefile_vars()", in favor of
  using "sysconfig.get_paths()" with the "vars" argument.

* gh-128550: Removed an incorrect optimization relating to eager tasks
  in "asyncio.TaskGroup" that resulted in cancellations being missed.

* gh-128991: Release the enter frame reference within "bdb" callback

* gh-118761: Reduce import time of "pstats" and "zipfile" by up to
  20%, by removing unnecessary imports to "typing". Patch by Bénédikt
  Tran.

* gh-128978: Fix a "NameError" in "sysconfig.expand_makefile_vars()".
  Patch by Bénédikt Tran.

* gh-128961: Fix a crash when setting state on an exhausted
  "array.array" iterator.

* gh-128894: Fix "traceback.TracebackException._format_syntax_error"
  not to fail on exceptions with custom metadata.

* gh-128916: Do not attempt to set "SO_REUSEPORT" on sockets of
  address families other than "AF_INET" and "AF_INET6", as it is
  meaningless with these address families, and the call with fail with
  Linux kernel 6.12.9 and newer.

* gh-118761: Improve import time of "tomllib" by removing "typing",
  "string", and "tomllib._types" imports. Patch by Taneli Hukkinen.

* gh-128679: "tracemalloc": Fix race conditions when
  "tracemalloc.stop()" is called by a thread, while other threads are
  tracing memory allocations. Patch by Victor Stinner.

* gh-128891: Add specialized opcodes to "opcode.opname".

* gh-118761: Reduce import time of "gettext" by up to ten times, by
  importing "re" on demand. In particular, "re" is no longer
  implicitly exposed as "gettext.re". Patch by Eli Schwartz.

* gh-118761: Reduce the import time of "optparse" when no help text is
  printed. Patch by Eli Schwartz.

* gh-128657: Fix possible extra reference when using objects returned
  by "hashlib.sha256()" under *free threading*.

* gh-118761: Reduce the import time of "csv" by up to five times, by
  importing "re" on demand. In particular, "re" is no more implicitly
  exposed as "csv.re". Patch by Bénédikt Tran.

* gh-128308: Support the *name* keyword argument for eager tasks in
  "asyncio.loop.create_task()",  "asyncio.create_task()" and
  "asyncio.TaskGroup.create_task()", by passing on all *kwargs* to the
  task factory set by "asyncio.loop.set_task_factory()".

* gh-118761: Improve the performance of "base64.b16decode()" by up to
  ten times by more efficiently checking the byte-string for
  hexadecimal digits. Reduce the import time of "base64" by up to six
  times, by no longer importing "re". Patch by Bénédikt Tran, Chris
  Markiewicz, and Adam Turner.

* gh-128156: When using macOS system "libffi", support for complex
  types in "ctypes" is now checked at runtime (macOS 10.15 or newer).
  The types must also be available at build time.

* gh-128636: Fix PyREPL failure when "os.environ" is overwritten with
  an invalid value.

* gh-128498: Default to stdout isatty for color detection instead of
  stderr. Patch by Hugo van Kemenade.

* gh-128384: Add locking to "warnings" to avoid some data races when
  free-threading is used.  Change "_warnings_runtime_state.mutex" to
  be a recursive mutex and expose it to "warnings", via the
  "_acquire_lock()" and "_release_lock()" functions. The lock is held
  when "filters" and "_filters_version" are updated.

* gh-128509: Add "sys._is_immortal()" for identifying *immortal*
  objects at runtime.

* gh-128479: Fix "asyncio.staggered.staggered_race()" leaking tasks
  and issuing an unhandled exception.

* gh-128427: "uuid.NIL" and "uuid.MAX" are now available to represent
  the Nil and Max UUID formats as defined by **RFC 9562**.

* gh-91279: "zipfile.ZipFile.writestr()" now respect
  "SOURCE_DATE_EPOCH" that distributions can set centrally and have
  build tools consume this in order to produce reproducible output.

* gh-112064: Fix incorrect handling of negative read sizes in
  "HTTPResponse.read". Patch by Yury Manushkin.

* gh-58956: Fixed a frame reference leak in "bdb".

* gh-128131: Completely support random access of uncompressed
  unencrypted read-only zip files obtained by "ZipFile.open".

* gh-127975: Avoid reusing quote types in "ast.unparse()" if not
  needed.

* gh-115514: Fix exceptions and incomplete writes after
  "asyncio._SelectorTransport" is closed before writes are completed.

* gh-121604: Add missing Deprecation warnings for
  "importlib.machinery.DEBUG_BYTECODE_SUFFIXES",
  "importlib.machinery.OPTIMIZED_BYTECODE_SUFFIXES",
  "importlib.machinery.WindowsRegistryFinder",
  "importlib.abc.ResourceLoader",
  "importlib.abc.SourceLoader.path_mtime()".

* gh-127873: When "-E" is set, only ignore "PYTHON_COLORS" and not
  "FORCE_COLOR"/"NO_COLOR"/"TERM" when colourising output. Patch by
  Hugo van Kemenade.

* gh-125413: Add "pathlib.Path.info" attribute, which stores an object
  implementing the "pathlib.types.PathInfo" protocol (also new). The
  object supports querying the file type and internally caching
  "stat()" results. Path objects generated by "iterdir()" are
  initialized with file type information gleaned from scanning the
  parent directory.

* gh-127712: Fix handling of the "secure" argument of
  "logging.handlers.SMTPHandler".

* gh-127096: Do not recreate unnamed section on every read in
  "configparser.ConfigParser". Patch by Andrey Efremov.

* gh-124369: Deprecate "pdb.Pdb.curframe_locals"

* gh-126332: Fix _pyrepl crash when entering a double CTRL-Z on an
  overflowing line.

* gh-125553: Fix round-trip invariance for backslash continuations in
  "tokenize.untokenize()".

* gh-91048: Add "asyncio.capture_call_graph()" and
  "asyncio.print_call_graph()" functions.

* gh-124703: Quitting "pdb" in "inline" mode will emit a confirmation
  prompt and exit gracefully now, instead of printing an exception
  traceback.

* gh-123987: Fixed issue in NamespaceReader where a non-path item in a
  namespace path, such as a sentinel added by an editable installer,
  would break resource loading.

* gh-119349: Add the "ctypes.util.dllist()" function to list the
  loaded shared libraries for the current process.

* gh-55454: Add IMAP4 "IDLE" support to the "imaplib" module.  Patch
  by Forest.

* gh-119257: Show tab completions menu below the current line, which
  results in less janky behaviour, and fixes a cursor movement bug.
  Patch by Daniel Hollas

* gh-101410: Support custom messages for domain errors in the "math"
  module ("math.sqrt()", "math.log()" and "math.atanh()" were modified
  as examples).  Patch by Charlie Zhao and Sergey B Kirpichev.

* gh-81340: Use "os.copy_file_range()" in "shutil.copy()",
  "shutil.copy2()", and "shutil.copyfile()" functions by default. An
  underlying Linux system call gives filesystems an opportunity to
  implement the use of copy-on-write (in case of btrfs and XFS) or
  server-side copy (in the case of NFS.) Patch by Illia Volochii.

* bpo-27307: Add attribute and item access support to
  "string.Formatter" in auto-numbering mode, which allows format
  strings like ‘{.name}’ and ‘{[1]}’.


IDLE
----

* gh-129873: Simplify displaying the IDLE doc by only copying the text
  section of idle.html to idlelib/help.html. Patch by Stan Ulbrych.


Documentation
-------------

* gh-125722: Require Sphinx 8.1.3 or later to build the Python
  documentation. Patch by Adam Turner.

* gh-67206: Document that "string.printable" is not printable in the
  POSIX sense. In particular, "string.printable.isprintable()" returns
  "False". Patch by Bénédikt Tran.


Core and Builtins
-----------------

* gh-100239: Replace the opcode BINARY_SUBSCR and its family by
  BINARY_OP with oparg NB_SUBSCR.

* gh-129732: Fixed a race in "_Py_qsbr_reserve" in the free threading
  build.

* gh-129763: Remove the internal "LLTRACE" macro (use "Py_DEBUG"
  instead).

* gh-129715: Improve JIT performance for generators.

* gh-129643: Fix thread safety of "PyList_Insert()" in free-threading
  builds.

* gh-129668: Fix race condition when raising "MemoryError" in the free
  threaded build.

* gh-129643: Fix thread safety of "PyList_SetItem()" in free-threading
  builds. Patch by Kumar Aditya.

* gh-128563: Fix an issue where the “lltrace” debug feature could have
  been incorrectly enabled for some frames.

* gh-129393: On FreeBSD, "sys.platform" doesn’t contain the major
  version anymore. It is always "'freebsd'", instead of "'freebsd13'"
  or "'freebsd14'".

* gh-129345: Fix null pointer dereference in "syslog.openlog()" when
  an audit hook raises an exception.

* gh-129231: Improve memory layout of JIT traces. Patch by Diego Russo

* gh-129149: Add fast path for medium-size integers in
  "PyLong_FromUnsignedLong()", "PyLong_FromUnsignedLongLong()" and
  "PyLong_FromSize_t()".

* gh-129201: The free-threaded version of the cyclic garbage collector
  has been optimized to conditionally use CPU prefetch instructions
  during the collection.  This can reduce collection times by making
  it more likely that data is in the CPU cache when it is needed.  The
  prefetch instructions are enabled if the number of long-lived
  objects (objects surviving a full collection) exceeds a threshold.

* gh-129093: Fix f-strings such as "f'{expr=}'" sometimes not
  displaying the full expression when the expression contains "!=".

* gh-124363: Treat debug expressions in f-string as raw strings. Patch
  by Pablo Galindo

* gh-128714: Fix the potential races in get/set dunder methods
  "__annotations__", "__annotate__" and "__type_params__" for function
  object, and add related tests.

* gh-128799: Add frame of "except*" to traceback when it wraps a naked
  exception.

* gh-128842: Collect JIT memory stats using pystats. Patch by Diego
  Russo.

* gh-100239: Specialize "BINARY_OP" for bitwise logical operations on
  compact ints.

* gh-128910: Undocumented and unused private C-API functions
  "_PyTrash_begin" and "_PyTrash_end" are removed.

* gh-128807: Add a marking phase to the free-threaded GC.  This is
  similar to what was done in gh-126491.  Since the free-threaded GC
  does not have generations and is not incremental, the marking phase
  looks for all objects reachable from known roots.  The roots are
  objects known to not be garbage, like the module dictionary for
  "sys".  For most programs, this marking phase should make the GC a
  bit faster since typically less work is done per object.

* gh-100239: Add opcode "BINARY_OP_EXTEND" which executes a pair of
  functions (guard and specialization functions) accessed from the
  inline cache.

* gh-128563: A new type of interpreter has been added to CPython. This
  interpreter uses tail calls for its instruction handlers.
  Preliminary benchmark results suggest 7-11% geometric mean faster on
  pyperformance (depending on platform), and up to 30% faster on
  Python-intensive workloads. This interpreter currently only works on
  newer compilers, such as "clang-19". Other compilers will continue
  using the old interpreter. Patch by Ken Jin, with ideas on how to
  implement this in CPython by Mark Shannon, Garret Gu, Haoran Xu, and
  Josh Haberman.

* gh-126703: Improve performance of iterating over lists and tuples by
  using a freelist for the iterator objects.

* gh-127953: The time to handle a "LINE" event in sys.monitoring (and
  sys.settrace) is now independent of the number of lines in the code
  object.

* gh-128330: Restore terminal control characters on REPL exit.

* gh-128016: Improved the "SyntaxWarning" message for invalid escape
  sequences to clarify that such sequences will raise a "SyntaxError"
  in future Python releases. The new message also suggests a potential
  fix, i.e., "Did you mean "\\e"?".

* gh-126004: Fix handling of "UnicodeError.start" and
  "UnicodeError.end" values in the "codecs.replace_errors()" error
  handler. Patch by Bénédikt Tran.

* gh-126004: Fix handling of "UnicodeError.start" and
  "UnicodeError.end" values in the "codecs.backslashreplace_errors()"
  error handler. Patch by Bénédikt Tran.

* gh-126004: Fix handling of "UnicodeError.start" and
  "UnicodeError.end" values in the "codecs.xmlcharrefreplace_errors()"
  error handler. Patch by Bénédikt Tran.

* gh-127119: Slightly optimize the "int" deallocator.

* gh-127349: Fixed the error when resizing terminal in Python REPL.
  Patch by Semyon Moroz.

* gh-125723: Fix crash with "gi_frame.f_locals" when generator frames
  outlive their generator. Patch by Mikhail Efimov.

* gh-126349: Add "turtle.fill()", "turtle.poly()" and
  "turtle.no_animation()" context managers. Patch by Marie Roald and
  Yngve Mardal Moe.

* gh-115911: If the current working directory cannot be determined due
  to permissions, then import will no longer raise "PermissionError".
  Patch by Alex Willmer.

* gh-112713: Added support for the "Partitioned" cookie flag in
  "http.cookies".


C API
-----

* gh-129533: Update "PyGC_Enable()", "PyGC_Disable()",
  "PyGC_IsEnabled()" to use atomic operation for thread-safety at
  free-threading build. Patch by Donghee Na.

* gh-89188: Implement "PyUnicode_KIND()" and "PyUnicode_DATA()" as
  function, in addition to the macros with the same names. The macros
  rely on C bit fields which have compiler-specific layout. Patch by
  Victor Stinner.

* gh-91417: Remove "PySequence_Fast()" from the limited C API, since
  this function has to be used with "PySequence_Fast_GET_ITEM" which
  never worked in the limited C API. Patch by Victor Stinner.

* gh-128509: Add "PyUnstable_IsImmortal()" for determining whether an
  object is *immortal*.

* gh-129033: Remove "_PyInterpreterState_GetConfigCopy()" and
  "_PyInterpreterState_SetConfig()" private functions. Use instead
  "PyConfig_Get()" and "PyConfig_Set()", public C API added by **PEP
  741** “Python Configuration C API”. Patch by Victor Stinner.

* gh-129033: Remove the private "_Py_InitializeMain()" function. It
  was a *provisional API* added to Python 3.8 by **PEP 587**. Patch by
  Victor Stinner.

* gh-128844: Add "PyUnstable_TryIncRef()" and
  "PyUnstable_EnableTryIncRef()" unstable APIs.  These are helpers for
  dealing with unowned references in a thread-safe way, particularly
  in the free threading build.

* gh-128911: Add "PyImport_ImportModuleAttr()" and
  "PyImport_ImportModuleAttrString()" helper functions to import a
  module and get an attribute of the module. Patch by Victor Stinner.

* gh-128863: The following private functions are deprecated and
  planned for removal in Python 3.18:

  * "_PyBytes_Join()": use "PyBytes_Join()".

  * "_PyDict_GetItemStringWithError()": use
    "PyDict_GetItemStringRef()".

  * "_PyDict_Pop()": use "PyDict_Pop()".

  * "_PyLong_Sign()": use "PyLong_GetSign()".

  * "_PyLong_FromDigits()" and "_PyLong_New()": use
    "PyLongWriter_Create()".

  * "_PyThreadState_UncheckedGet()": use
    "PyThreadState_GetUnchecked()".

  * "_PyUnicode_AsString()": use "PyUnicode_AsUTF8()".

  * "_Py_HashPointer()": use "Py_HashPointer()".

  * "_Py_fopen_obj()": use "Py_fopen()".

  The pythoncapi-compat project can be used to get these new public
  functions on Python 3.13 and older.

  Patch by Victor Stinner.

* gh-126599: Remove some internal test APIs for the experimental JIT
  compiler.

* gh-127925: Convert the "decimal" module to use **PEP 757** C API
  (export-import integers), offering some speed-up if the integer part
  of the "Decimal" instance is small.  Patch by Sergey B Kirpichev.


Build
-----

* gh-129660: Drop "test_embed" from PGO training, whose contribution
  in recent versions is considered to be ignorable.

* gh-128902: Fix compile errors with Clang 9 and older due to lack of
  "__attribute__((fallthrough))" support.


Python 3.14.0 alpha 4
=====================

*Release date: 2025-01-14*


macOS
-----

* gh-127592: Usage of the unified Apple System Log APIs was disabled
  when the minimum macOS version is earlier than 10.12.


Tools/Demos
-----------

* gh-128152: Fix a bug where Argument Clinic’s C pre-processor parser
  tried to parse pre-processor directives inside C comments. Patch by
  Erlend Aasland.


Tests
-----

* gh-128690: Temporarily do not use test_embed in PGO profile builds
  until the problem with test_init_pyvenv_cfg failing in some
  configurations is resolved.


Library
-------

* gh-128731: Fix "ResourceWarning" in
  "urllib.robotparser.RobotFileParser.read()".

* gh-71339: Add new assertion methods for "unittest":
  "assertHasAttr()", "assertNotHasAttr()", "assertIsSubclass()",
  "assertNotIsSubclass()" "assertStartsWith()",
  "assertNotStartsWith()", "assertEndsWith()" and
  "assertNotEndsWith()".

* gh-118761: Improve import time of "pickle" by 25% by removing an
  unnecessary regular expression. As such, "re" is no more implicitly
  available as "pickle.re". Patch by Bénédikt Tran.

* gh-128661: Fixes "typing.evaluate_forward_ref()" not showing
  deprecation when "type_params" arg is not passed.

* gh-128562: Fix possible conflicts in generated "tkinter" widget
  names if the widget class name ends with a digit.

* gh-128559: Improved import time of "asyncio".

* gh-128552: Fix cyclic garbage introduced by
  "asyncio.loop.create_task()" and "asyncio.TaskGroup.create_task()"
  holding a reference to the created task if it is eager.

* gh-128340: Add internal thread safe handle to be used in
  "asyncio.loop.call_soon_threadsafe()" for thread safe cancellation.

* gh-128182: Fix crash when using "ctypes" pointers concurrently on
  the *free threaded* build.

* gh-128400: Only show the current thread in "faulthandler" on the
  *free threaded* build to prevent races.

* gh-128400: Fix crash when using "faulthandler.dump_traceback()"
  while other threads are active on the *free threaded* build.

* gh-128388: Fix "PyREPL" on Windows to support more keybindings, like
  the "Control"-"←" and "Control"-"→" word-skipping keybindings and
  those with meta (i.e. "Alt"), e.g. "Alt"-"d" to "kill-word" or
  "Alt"-"Backspace" "backward-kill-word".

* gh-88834: Unify the instance check for "typing.Union" and
  "types.UnionType": "Union" now uses the instance checks against its
  parameters instead of the subclass checks.

* gh-128302: Fix
  "xml.dom.xmlbuilder.DOMEntityResolver.resolveEntity()", which was
  broken by the Python 3.0 transition.

* gh-128317: Highlight today in colour in "calendar"’s CLI output.
  Patch by Hugo van Kemenade.

* gh-128302: Allow "xml.dom.xmlbuilder.DOMParser.parse()" to correctly
  handle "xml.dom.xmlbuilder.DOMInputSource" instances that only have
  a "systemId" attribute set.

* gh-128151: Improve generation of "UUID" objects version 3, 4, 5, and
  8 via their dedicated functions by 30%. Patch by Bénédikt Tran.

* gh-128118: Improve performance of "copy.copy()" by 30% via a fast
  path for atomic types and container types.

* gh-127946: Fix crash when modifying "ctypes._CFuncPtr" objects
  concurrently on the *free threaded* build.

* gh-128062: Revert the font of "turtledemo"’s menu bar to its default
  value and display the shortcut keys in the correct position.

* gh-128014: Fix resetting the default window icon by passing
  "default=''" to the "tkinter" method "wm_iconbitmap()".

* gh-41872: Fix quick extraction of module docstrings from a file in
  "pydoc". It now supports docstrings with single quotes, escape
  sequences, raw string literals, and other Python syntax.

* gh-127060: Set TERM environment variable to “dumb” to disable
  traceback colors in IDLE, since IDLE doesn’t understand ANSI escape
  sequences. Patch by Victor Stinner.

* gh-126742: Fix support of localized error messages reported by
  *dlerror(3)* and *gdbm_strerror* in "ctypes" and "dbm.gnu" functions
  respectively. Patch by Bénédikt Tran.

* gh-122548: Adds two new local events to sys.monitoring,
  "BRANCH_LEFT" and "BRANCH_RIGHT". This allows the two arms of the
  branch to be disabled independently, which should hugely improve
  performance of branch-level coverage tools. The old branch event,
  "BRANCH" is now deprecated.

* gh-127847: Fix the position when doing interleaved seeks and reads
  in uncompressed, unencrypted zip files returned by
  "zipfile.ZipFile.open()".

* gh-127688: Add the "SCHED_DEADLINE" and "SCHED_NORMAL" constants to
  the "os" module.

* gh-83662: Add missing "__class_getitem__" method to the Python
  implementation of "functools.partial()", to make it compatible with
  the C version. This is mainly relevant for alternative Python
  implementations like PyPy and GraalPy, because CPython will usually
  use the C-implementation of that function.

* gh-127586: "multiprocessing.pool.Pool" now properly restores blocked
  signal handlers of the parent thread when creating processes via
  either *spawn* or *forkserver*.

* gh-98188: Fix an issue in "email.message.Message.get_payload()"
  where data cannot be decoded if the Content Transfer Encoding
  mechanism contains trailing whitespaces or additional junk text.
  Patch by Hui Liu.

* gh-127529: Correct behavior of
  "asyncio.selector_events.BaseSelectorEventLoop._accept_connection()"
  in handling "ConnectionAbortedError" in a loop. This improves
  performance on OpenBSD.

* gh-127360: When a descriptive error message cannot be provided for
  an "ssl.SSLError", the “unknown error” message now shows the
  internal error code (as retrieved by "ERR_get_error" and similar
  OpenSSL functions).

* gh-127196: Fix crash when dict with keys in invalid encoding were
  passed to several functions in "_interpreters" module.

* gh-124130: Fix a bug in matching regular expression "\B" in empty
  input string. Now it is always the opposite of "\b". To get an old
  behavior, use "(?!\A\Z)\B". To get a new behavior in old Python
  versions, use "(?!\b)".

* gh-126639: "tempfile.NamedTemporaryFile" will now issue a
  "ResourceWarning" when it is finalized by the garbage collector
  without being explicitly closed.

* gh-126624: Expose error code "XML_ERROR_NOT_STARTED" of Expat
  >=2.6.4 in "xml.parsers.expat.errors".

* gh-126225: "getopt" and "optparse" are no longer marked as
  deprecated. There are legitimate reasons to use one of these modules
  in preference to "argparse", and none of these modules are at risk
  of being removed from the standard library. Of the three, "argparse"
  remains the recommended default choice, *unless* one of the concerns
  noted at the top of the "optparse" module documentation applies.

* gh-124761: Add "SO_REUSEPORT_LB" constant to "socket" for FreeBSD.

* gh-121720: "enum.EnumDict" can now be used without resorting to
  private API.

* gh-123424: Add "zipfile.ZipInfo._for_archive()" setting default
  properties on "ZipInfo" objects. Patch by Bénédikt Tran and Jason R.
  Coombs.

* gh-121676: Deprecate calling the Python implementation of
  "functools.reduce()" with a "function" or "sequence" as a *keyword
  argument*. This will be forbidden in Python 3.16 in order to match
  the C implementation.

* gh-112015: "ctypes.memoryview_at()" now exists to create a
  "memoryview" object that refers to the supplied pointer and length.
  This works like "ctypes.string_at()" except it avoids a buffer copy,
  and is typically useful when implementing pure Python callback
  functions that are passed dynamically-sized buffers.

* gh-95371: Added support for other image formats (PNG, PGM, and PPM)
  to the turtle module. Patch by Shin-myoung-serp.


Core and Builtins
-----------------

* gh-128078: Fix a "SystemError" when using "anext()" with a default
  tuple value. Patch by Bénédikt Tran.

* gh-128717: Fix a crash when setting the recursion limit while other
  threads are active on the *free threaded* build.

* gh-124483: Treat "Py_DECREF" and variants as escaping when
  generating opcode and uop metadata. This prevents the possibility of
  a "__del__" method causing the JIT to behave incorrectly.

* gh-126703: Improve performance of class methods by using a freelist.

* gh-128137: Update "PyASCIIObject" layout to handle interned field
  with the atomic operation. Patch by Donghee Na.

* gh-128192: Upgrade HTTP digest authentication algorithm for
  "urllib.request" by supporting SHA-256 digest authentication as
  specified in **RFC 7616**.

* gh-126868: Increase usage of freelist for "int" allocation.

* gh-114203: Optimize "Py_BEGIN_CRITICAL_SECTION" for simple recursive
  calls.

* gh-127705: Adds stackref debugging when "Py_STACKREF_DEBUG" is set.
  Finds all double-closes and leaks, logging the origin and last
  borrow.

  Inspired by HPy’s debug mode. https://docs.hpyproject.org/en/latest
  /debug-mode.html

* gh-128079: Fix a bug where "except*" does not properly check the
  return value of an "ExceptionGroup"’s "split()" function, leading to
  a crash in some cases. Now when "split()" returns an invalid object,
  "except*" raises a "TypeError" with the original raised
  "ExceptionGroup" object chained to it.

* gh-128030: Avoid error from calling "PyModule_GetFilenameObject" on
  a non-module object when importing a non-existent symbol from a non-
  module object.

* gh-128035: Indicate through "ssl.HAS_PHA" whether the "ssl" module
  supports TLSv1.3 post-handshake client authentication (PHA). Patch
  by Will Childs-Klein.

* gh-127274: Add a new flag, "CO_METHOD", to "co_flags" that indicates
  whether the code object belongs to a function defined in class
  scope.

* gh-66409: During the path initialization, we now check if
  "base_exec_prefix" is the same as "base_prefix" before falling back
  to searching the Python interpreter directory.

* gh-127970: We now use the location of the "libpython" runtime
  library used in the current process to determine "sys.base_prefix"
  on all platforms implementing the dladdr function defined by the
  UNIX standard — this includes Linux, Android, macOS, iOS, FreeBSD,
  etc. This was already the case on Windows and macOS Framework
  builds.

* gh-127773: Do not use the type attribute cache for types with
  incompatible *MRO*.

* gh-127903: "Objects/unicodeobject.c": fix a crash on DEBUG builds in
  "_copy_characters" when there is nothing to copy.

* gh-127809: Fix an issue where the experimental JIT may infer an
  incorrect result type for exponentiation ("**" and "**="), leading
  to bugs or crashes.

* gh-126862: Fix a possible overflow when a class inherits from an
  absurd number of super-classes. Reported by Valery Fedorenko. Patch
  by Bénédikt Tran.


C API
-----

* gh-128400: "Py_FatalError()" no longer shows all threads on the
  *free threaded* build to prevent crashes.

* gh-128629: Add macros "Py_PACK_VERSION()" and
  "Py_PACK_FULL_VERSION()" for bit-packing Python version numbers.

* gh-128008: Add "PyWeakref_IsDead()" function, which tests if a weak
  reference is dead.

* gh-127350: Add "Py_fopen()" function to open a file. Similar to the
  "fopen()" function, but the *path* parameter is a Python object and
  an exception is set on error. Add also "Py_fclose()" function to
  close a file, function needed for Windows support. Patch by Victor
  Stinner.


Build
-----

* gh-128627: For Emscripten builds the function pointer cast call
  trampoline now uses the wasm-gc ref.test instruction if it’s
  available instead of Wasm JS type reflection.

* gh-128472: Skip BOLT optimization of functions using computed gotos,
  fixing errors on build with LLVM 19.

* gh-115765: GNU Autoconf 2.72 is now required to generate
  "configure". Patch by Erlend Aasland.

* gh-123925: Fix building the "curses" module on platforms with
  libncurses but without libncursesw.

* gh-90905: Add support for cross-compiling to x86_64 on aarch64/arm64
  macOS.

* gh-128321: Set "LIBS" instead of "LDFLAGS" when checking if
  "sqlite3" library functions are available. This fixes the ordering
  of linked libraries during checks, which was incorrect when using a
  statically linked "libsqlite3".

* gh-100384: Error on "unguarded-availability" in macOS builds,
  preventing invalid use of symbols that are not available in older
  versions of the OS.

* gh-128104: Remove "Py_STRFTIME_C99_SUPPORT" conditions in favor of
  requiring C99 *strftime(3)* specifier support at build time. When
  cross-compiling, there is no build time check and support is
  assumed.

* gh-127951: Add option "--pystats" to the Windows build to enable
  performance statistics collection.


Python 3.14.0 alpha 3
=====================

*Release date: 2024-12-17*


Windows
-------

* gh-127353: Allow to force color output on Windows using environment
  variables. Patch by Andrey Efremov.

* gh-125729: Makes the presence of the "turtle" module dependent on
  the Tcl/Tk installer option. Previously, the module was always
  installed but would be unusable without Tcl/Tk.


Tools/Demos
-----------

* gh-126700: Add support for multi-argument "gettext" functions in
  **pygettext.py**.


Tests
-----

* gh-127906: Test the limited C API in test_cppext. Patch by Victor
  Stinner.

* gh-127637: Add tests for the "dis" command-line interface. Patch by
  Bénédikt Tran.

* gh-126925: iOS test results are now streamed during test execution,
  and the deprecated xcresulttool is no longer used.

* gh-127076: Disable strace based system call tests when LD_PRELOAD is
  set.

* gh-127076: Filter out memory-related "mmap", "munmap", and
  "mprotect"  calls from file-related ones when testing "io" behavior
  using strace.


Security
--------

* gh-127655: Fixed the
  "asyncio.selector_events._SelectorSocketTransport" transport not
  pausing writes for the protocol when the buffer reaches the high
  water mark when using "asyncio.WriteTransport.writelines()".


Library
-------

* gh-126907: Fix crash when using "atexit" concurrently on the *free-
  threaded* build.

* gh-127870: Detect recursive calls in ctypes "_as_parameter_"
  handling. Patch by Victor Stinner.

* gh-127732: The "platform" module now correctly detects Windows
  Server 2025.

* gh-126789: Fixed "sysconfig.get_config_vars()",
  "sysconfig.get_paths()", and siblings, returning outdated cached
  data if the value  of "sys.prefix" or "sys.exec_prefix" changes.
  Overwriting "sys.prefix" or "sys.exec_prefix" still is discouraged,
  as that might break other parts of the code.

* gh-127718: Add colour to "test.regrtest" output. Patch by Hugo van
  Kemenade.

* gh-127610: Added validation for more than one var-positional or var-
  keyword parameters in "inspect.Signature". Patch by Maxim Ageev.

* gh-127627: Added "posix._emscripten_debugger()" to help with
  debugging the test suite on the Emscripten target.

* gh-126821: macOS and iOS apps can now choose to redirect stdout and
  stderr to the system log during interpreter configuration.

* gh-93312: Include "<sys/pidfd.h>" to get "os.PIDFD_NONBLOCK"
  constant. Patch by Victor Stinner.

* gh-127481: Add the "EPOLLWAKEUP" constant to the "select" module.

* gh-127065: Make "operator.methodcaller()" thread-safe and re-entrant
  safe.

* gh-127321: "pdb.set_trace()" will not stop at an opcode that does
  not have an associated line number anymore.

* gh-127429: Fixed bug where, on cross-builds, the "sysconfig" POSIX
  data was being generated with the host Python’s "Makefile". The data
  is now generated from current build’s "Makefile".

* gh-127413: Add the "dis --specialized" command-line option to show
  specialized bytecode. Patch by Bénédikt Tran.

* gh-125413: Revert addition of "pathlib.Path.scandir()". This method
  was added in 3.14.0a2. The optimizations remain for file system
  paths, but other subclasses should only have to implement
  "pathlib.Path.iterdir()".

* gh-127257: In "ssl", system call failures that OpenSSL reports using
  "ERR_LIB_SYS" are now raised as "OSError".

* gh-59705: On Linux, "threading.Thread" now sets the thread name to
  the operating system. Patch by Victor Stinner.

* gh-127303: Publicly expose "EXACT_TOKEN_TYPES" in "token.__all__".

* gh-127331: "ssl" can show descriptions for errors added in OpenSSL
  3.4.

* gh-123967: Fix faulthandler for trampoline frames. If the top-most
  frame is a trampoline frame, skip it. Patch by Victor Stinner.

* gh-127178: A "_sysconfig_vars_(...).json" file is now shipped in the
  standard library directory. It contains the output of
  "sysconfig.get_config_vars()" on the default environment encoded as
  JSON data. This is an implementation detail, and may change at any
  time.

* gh-127072: Remove outdated "socket.NETLINK_*" constants not present
  in Linux kernels beyond 2.6.17.

* gh-127255: The "CopyComPointer()" function is now public.
  Previously, this was private and only available in "_ctypes".

* gh-127182: Fix "io.StringIO.__setstate__()" crash, when "None" was
  passed as the first value.

* gh-127217: Fix "urllib.request.pathname2url()" for paths starting
  with multiple slashes on Posix.

* gh-125866: "urllib.request.pathname2url()" now adds an empty
  authority when generating a URL for a path that begins with exactly
  one slash. For example, the path "/etc/hosts" is converted to the
  scheme-less URL "///etc/hosts". As a result of this change, URLs
  without authorities are only generated for relative paths.

* gh-127221: Add colour to "unittest" output. Patch by Hugo van
  Kemenade.

* gh-127035: Fix "shutil.which" on Windows. Now it looks at direct
  match if and only if the command ends with a PATHEXT extension or
  X_OK is not in mode. Support extensionless files if “.” is in
  PATHEXT. Support PATHEXT extensions that end with a dot.

* gh-122273: Support PyREPL history on Windows. Patch by devdanzin and
  Victor Stinner.

* gh-125866: "urllib.request.pathname2url()" and "url2pathname()" no
  longer convert Windows drive letters to uppercase.

* gh-127078: Fix issue where "urllib.request.url2pathname()" failed to
  discard an extra slash before a UNC drive in the URL path on
  Windows.

* gh-126766: Fix issue where "urllib.request.url2pathname()" failed to
  discard any ‘localhost’ authority present in the URL.

* gh-127065: Fix crash when calling a "operator.methodcaller()"
  instance from multiple threads in the free threading build.

* gh-127090: Fix value of "urllib.response.addinfourl.url" for "file:"
  URLs that express relative paths and absolute Windows paths. The
  canonical URL generated by "urllib.request.pathname2url()" is now
  used.

* gh-126992: Fix LONG and INT opcodes to only use base 10 for string
  to integer conversion in "pickle".

* gh-126997: Fix support of STRING and GLOBAL opcodes with non-ASCII
  arguments in "pickletools". "pickletools.dis()" now outputs non-
  ASCII bytes in STRING, BINSTRING and SHORT_BINSTRING arguments as
  escaped ("\xXX").

* gh-126316: "grp": Make "grp.getgrall()" thread-safe by adding a
  mutex. Patch by Victor Stinner.

* gh-126618: Fix the representation of "itertools.count" objects when
  the count value is "sys.maxsize".

* gh-126615: The "COMError" exception is now public. Previously, this
  was private and only available in "_ctypes".

* gh-126985: When running under a virtual environment with the "site"
  disabled (see "-S"), "sys.prefix" and "sys.base_prefix" will now
  point to the virtual environment, instead of the base installation.

* gh-112192: In the "trace" module, increase the coverage precision
  ("cov%") to one decimal.

* gh-118761: Improve import time of "mimetypes" by around 11-16 times.
  Patch by Hugo van Kemenade.

* gh-126947: Raise "TypeError" in "_pydatetime.timedelta.__new__()" if
  the passed arguments are not "int" or "float", so that the Python
  implementation is in line with the C implementation.

* gh-126946: Improve the "GetoptError" error message when a long
  option prefix matches multiple accepted options in "getopt.getopt()"
  and "getopt.gnu_getopt()".

* gh-126899: Make tkinter widget methods "after()" and "after_idle()"
  accept arguments passed by keyword.

* gh-85168: Fix issue where "urllib.request.url2pathname()" and
  "pathname2url()" always used UTF-8 when quoting and unquoting file
  URIs. They now use the *filesystem encoding and error handler*.

* gh-126780: Fix "os.path.normpath()" for drive-relative paths on
  Windows.

* gh-126775: Make "linecache.checkcache()" thread safe and GC re-
  entrancy safe.

* gh-126601: Fix issue where "urllib.request.pathname2url()" raised
  "OSError" when given a Windows path containing a colon character not
  following a drive letter, such as before an NTFS alternate data
  stream.

* gh-126727: "locale.nl_langinfo(locale.ERA)" now returns multiple era
  description segments separated by semicolons. Previously it only
  returned the first segment on platforms with Glibc.

* gh-85046: Add "EHWPOISON" error code to "errno".

* gh-118201: Fixed intermittent failures of "os.confstr",
  "os.pathconf" and "os.sysconf" on iOS and Android.

* gh-86463: The "usage" parameter of "argparse.ArgumentParser" no
  longer affects the default value of the "prog" parameter in
  subparsers.

* gh-124008: Fix possible crash (in debug build), incorrect output or
  returning incorrect value from raw binary "write()" when writing to
  console on Windows.

* gh-123401: The "http.cookies" module now supports parsing obsolete
  **RFC 850** date formats, in accordance with **RFC 9110**
  requirements. Patch by Nano Zheng.

* gh-122431: "readline.append_history_file()" now raises a
  "ValueError" when given a negative value.

* gh-122356: Guarantee that the position of a file-like object passed
  to "zipfile.is_zipfile()" is left untouched after the call. Patch by
  Bénédikt Tran.

* gh-122288: Improve the performances of "fnmatch.translate()" by a
  factor 1.7. Patch by Bénédikt Tran.

* gh-88110: Fixed "multiprocessing.Process" reporting a ".exitcode" of
  1 even on success when using the ""fork"" start method while using a
  "concurrent.futures.ThreadPoolExecutor".

* gh-97514: Authentication was added to the "multiprocessing"
  forkserver start method control socket so that only processes with
  the authentication key generated by the process that spawned the
  forkserver can control it.  This is an enhancement over the other
  gh-97514 fixes so that access is no longer limited only by
  filesystem permissions.

  The file descriptor exchange of control pipes with the forked worker
  process now requires an explicit acknowledgement byte to be sent
  over the socket after the exchange on all forkserver supporting
  platforms. That makes testing the above much easier.


Documentation
-------------

* gh-127347: Publicly expose "traceback.print_list()" in
  "traceback.__all__".


Core and Builtins
-----------------

* gh-127740: Fix error message in "bytes.fromhex()" when given an odd
  number of digits to properly indicate that an even number of
  hexadecimal digits is required.

* gh-127058: "PySequence_Tuple" now creates the resulting tuple
  atomically, preventing partially created tuples being visible to the
  garbage collector or through "gc.get_referrers()"

* gh-127599: Fix statistics for increments of object reference counts
  (in particular, when a reference count was increased by more than 1
  in a single operation).

* gh-127651: When raising "ImportError" for missing symbols in "from"
  imports, use "__file__" in the error message if "__spec__.origin" is
  not a location

* gh-127582: Fix non-thread-safe object resurrection when calling
  finalizers and watcher callbacks in the free threading build.

* gh-127434: The iOS compiler shims can now accept arguments with
  spaces.

* gh-127536: Add missing locks around some list assignment operations
  in the free threading build.

* gh-127085: Fix race when exporting a buffer from a "memoryview"
  object on the *free-threaded* build.

* gh-127238: Correct error message for "sys.set_int_max_str_digits()".

* gh-113841: Fix possible undefined behavior division by zero in
  "complex"’s "_Py_c_pow()".

* gh-127133: Calling "argparse.ArgumentParser.add_argument_group()" on
  an argument group, and calling
  "argparse.ArgumentParser.add_argument_group()" or
  "argparse.ArgumentParser.add_mutually_exclusive_group()" on a
  mutually exclusive group now raise exceptions. This nesting was
  never supported, often failed to work correctly, and was
  unintentionally exposed through inheritance. This functionality has
  been deprecated since Python 3.11.

* gh-126491: Add a marking phase to the GC. All objects that can be
  transitively reached from builtin modules or the stacks are marked
  as reachable before cycle detection. This reduces the amount of work
  done by the GC by approximately half.

* gh-127020: Fix a crash in the free threading build when
  "PyCode_GetCode()", "PyCode_GetVarnames()", "PyCode_GetCellvars()",
  or "PyCode_GetFreevars()" were called from multiple threads at the
  same time.

* gh-127010: Simplify GC tracking of dictionaries. All dictionaries
  are tracked when created, rather than being lazily tracked when a
  trackable object was added to them. This simplifies the code
  considerably and results in a slight speedup.

* gh-126980: Fix "__buffer__()" of "bytearray" crashing when "READ" or
  "WRITE" are passed as flags.

* gh-126937: Fix "TypeError" when a "ctypes.Structure" has a field
  size that doesn’t fit into an unsigned 16-bit integer. Instead, the
  maximum number of *bits* is "sys.maxsize".

* gh-126868: Increase performance of "int" by adding a freelist for
  compact ints.

* gh-126881: Fix crash in finalization of dtoa state. Patch by Kumar
  Aditya.

* gh-126892: Require cold or invalidated code to “warm up” before
  being JIT compiled again.

* gh-126091: Ensure stack traces are complete when throwing into a
  generator chain that ends in a custom generator.

* gh-126024: Optimize decoding of short UTF-8 sequences containing
  non-ASCII characters by approximately 15%.

* gh-125420: Add "memoryview.index()" to "memoryview" objects. Patch
  by Bénédikt Tran.

* gh-125420: Add "memoryview.count()" to "memoryview" objects. Patch
  by Bénédikt Tran.

* gh-124470: Fix crash in free-threaded builds when replacing object
  dictionary while reading attribute on another thread

* gh-69639: Implement mixed-mode arithmetic rules combining real and
  complex numbers as specified by C standards since C99.  Patch by
  Sergey B Kirpichev.

* gh-120010: Correct invalid corner cases which resulted in
  "(nan+nanj)" output in complex multiplication, e.g.,
  "(1e300+1j)*(nan+infj)".  Patch by Sergey B Kirpichev.

* gh-109746: If "_thread.start_new_thread()" fails to start a new
  thread, it deletes its state from interpreter and thus avoids its
  repeated cleanup on finalization.


C API
-----

* gh-127896: The previously undocumented function "PySequence_In()" is
  *soft deprecated*. Use "PySequence_Contains()" instead.

* gh-127791: Fix loss of callbacks after more than one call to
  "PyUnstable_AtExit()".

* gh-127691: The Unicode Exception Objects C API now raises a
  "TypeError" if its exception argument is not a "UnicodeError"
  object. Patch by Bénédikt Tran.

* gh-123378: Ensure that the value of "UnicodeEncodeError.end"
  retrieved by "PyUnicodeEncodeError_GetEnd()" lies in "[min(1,
  objlen), max(min(1, objlen), objlen)]" where *objlen* is the length
  of "UnicodeEncodeError.object". Similar arguments apply to
  "UnicodeDecodeError" and "UnicodeTranslateError" and their
  corresponding C interface. Patch by Bénédikt Tran.

* gh-127314: Improve error message when calling the C API without an
  active thread state on the *free-threaded* build.

* gh-123378: Ensure that the value of "UnicodeEncodeError.start"
  retrieved by "PyUnicodeEncodeError_GetStart()" lies in "[0, max(0,
  objlen - 1)]" where *objlen* is the length of
  "UnicodeEncodeError.object". Similar arguments apply to
  "UnicodeDecodeError" and "UnicodeTranslateError" and their
  corresponding C interface. Patch by Bénédikt Tran.

* gh-109523: Reading text from a non-blocking stream with "read" may
  now raise a "BlockingIOError" if the operation cannot immediately
  return bytes.

* gh-102471: Add a new import and export API for Python "int" objects
  (**PEP 757**):

  * "PyLong_GetNativeLayout()";

  * "PyLong_Export()";

  * "PyLong_FreeExport()";

  * "PyLongWriter_Create()";

  * "PyLongWriter_Finish()";

  * "PyLongWriter_Discard()".

  Patch by Victor Stinner.

* gh-121058: "PyThreadState_Clear()" now warns (and calls
  "sys.excepthook") if the thread state still has an active exception.


Build
-----

* gh-127865: Fix build failure on systems without thread-locals
  support.

* gh-127629: Emscripten builds now include ctypes support.

* gh-127111: Updated the Emscripten web example to use ES6 modules and
  be built into a distinct "web_example" subfolder.

* gh-115869: Make "jit_stencils.h" (which is produced during JIT
  builds) reproducible.

* gh-126898: The Emscripten build of Python is now based on ES6
  modules.


Python 3.14.0 alpha 2
=====================

*Release date: 2024-11-19*


Windows
-------

* gh-126911: Update credits command output.

* gh-118973: Ensures the experimental free-threaded install includes
  the "_tkinter" module. The optional Tcl/Tk component must also be
  installed in order for the module to work.

* gh-126497: Fixes venv failure due to missing redirector executables
  in experimental free-threaded installs.

* gh-126074: Removed unnecessary DLLs from Windows embeddable package

* gh-125315: Avoid crashing in "platform" due to slow WMI calls on
  some Windows machines.

* gh-126084: Fix venvwlauncher to launch pythonw instead of python so
  no extra console window is created.

* gh-125842: Fix a "SystemError" when "sys.exit()" is called with
  "0xffffffff" on Windows.

* gh-125550: Enable the Python Install Manager to detect Python 3.14
  installs from the Windows Store.

* gh-123803: All Windows code pages are now supported as “cpXXX”
  codecs on Windows.


Tools/Demos
-----------

* gh-126807: Fix extraction warnings in **pygettext.py** caused by
  mistaking function definitions for function calls.

* gh-126167: The iOS testbed was modified so that it can be used by
  third-party projects for testing purposes.


Tests
-----

* gh-126909: Fix test_os extended attribute tests to work on
  filesystems with 1 KiB xattr size limit.

* gh-125730: Change "make test" to not run GUI tests by default. Use
  "make ci" to run tests with GUI tests instead.

* gh-124295: Add translation tests to the "argparse" module.


Security
--------

* gh-126623: Upgrade libexpat to 2.6.4


Library
-------

* gh-85957: Add missing MIME types for images with RFCs: emf, fits,
  g3fax, jp2, jpm, jpx, t38, tiff-fx and wmf. Patch by Hugo van
  Kemenade.

* gh-126920: Fix the "prefix" and "exec_prefix" keys from
  "sysconfig.get_config_vars()" incorrectly having the same value as
  "sys.base_prefix" and "sys.base_exec_prefix", respectively, inside
  virtual environments. They now accurately reflect "sys.prefix" and
  "sys.exec_prefix".

* gh-67877: Fix memory leaks when "regular expression" matching
  terminates abruptly, either because of a signal or because memory
  allocation fails.

* gh-125063: "marshal" now supports "slice" objects. The marshal
  format version was increased to 5.

* gh-126789: Fixed the values of "sysconfig.get_config_vars()",
  "sysconfig.get_paths()", and their siblings when the "site"
  initialization happens after "sysconfig" has built a cache for
  "sysconfig.get_config_vars()".

* gh-126188: Update bundled pip to 24.3.1

* gh-126766: Fix issue where "urllib.request.url2pathname()" failed to
  discard two leading slashes introducing an empty authority section.

* gh-126705: Allow "os.PathLike" to be a base for Protocols.

* gh-126699: Allow "collections.abc.AsyncIterator" to be a base for
  Protocols.

* gh-126654: Fix crash when non-dict was passed to several functions
  in "_interpreters" module.

* gh-104745: Limit starting a patcher (from "unittest.mock.patch()" or
  "unittest.mock.patch.object()") more than once without stopping it

* gh-126595: Fix a crash when instantiating "itertools.count" with an
  initial count of "sys.maxsize" on debug builds. Patch by Bénédikt
  Tran.

* gh-120423: Fix issue where "urllib.request.pathname2url()"
  mishandled Windows paths with embedded forward slashes.

* gh-126565: Improve performances of "zipfile.Path.open()" for non-
  reading modes.

* gh-126505: Fix bugs in compiling case-insensitive "regular
  expressions" with character classes containing non-BMP characters:
  upper-case non-BMP character did was ignored and the ASCII flag was
  ignored when matching a character range whose upper bound is beyond
  the BMP region.

* gh-117378: Fixed the "multiprocessing" ""forkserver"" start method
  forkserver process to correctly inherit the parent’s "sys.path"
  during the importing of "multiprocessing.set_forkserver_preload()"
  modules in the same manner as "sys.path" is configured in workers
  before executing work items.

  This bug caused some forkserver module preloading to silently fail
  to preload. This manifested as a performance degradation in child
  processes when the "sys.path" was required due to additional
  repeated work in every worker.

  It could also have a side effect of """" remaining in "sys.path"
  during forkserver preload imports instead of the absolute path from
  "os.getcwd()" at multiprocessing import time used in the worker
  "sys.path".

  The "sys.path" differences between phases in the child process could
  potentially have caused preload to import incorrect things from the
  wrong location.  We are unaware of that actually having happened in
  practice.

* gh-125679: The "multiprocessing.Lock" and "multiprocessing.RLock"
  "repr" values no longer say “unknown” on macOS.

* gh-126476: Raise "calendar.IllegalMonthError" (now a subclass of
  "IndexError") for "calendar.month()" when the input month is not
  correct.

* gh-126489: The Python implementation of "pickle" no longer calls
  "pickle.Pickler.persistent_id()" for the result of
  "persistent_id()".

* gh-126451: Register the "contextvars.Context" type to
  "collections.abc.Mapping".

* gh-126175: Add "msg", "doc", "pos", "lineno" and "colno" attributes
  to "tomllib.TOMLDecodeError". Deprecate instantiating with free-form
  arguments.

* gh-89416: Add **RFC 9559** MIME types for Matroska audiovisual
  container formats. Patch by Hugo van Kemenade.

* gh-126417: Register the "multiprocessing.managers.DictProxy" and
  "multiprocessing.managers.ListProxy" types in
  "multiprocessing.managers" to "collections.abc.MutableMapping" and
  "collections.abc.MutableSequence", respectively.

* gh-126390: Add support for returning intermixed options and non-
  option arguments in order in "getopt.gnu_getopt()".

* gh-126374: Add support for options with optional arguments in the
  "getopt" module.

* gh-126363: Speed up pattern parsing in "pathlib.Path.glob()" by
  skipping creation of a "pathlib.Path" object for the pattern.

* gh-126353: "asyncio.get_event_loop()" now does not implicitly
  creates an event loop. It now raises a "RuntimeError" if there is no
  set event loop. Patch by Kumar Aditya.

* gh-126313: Fix an issue in "curses.napms()" when "curses.initscr()"
  has not yet been called. Patch by Bénédikt Tran.

* gh-126303: Fix pickling and copying of "os.sched_param" objects.

* gh-126138: Fix a use-after-free crash on "asyncio.Task" objects
  whose underlying coroutine yields an object that implements an evil
  "__getattribute__()". Patch by Nico Posada.

* gh-120057: Replace the "os.environ.refresh()" method with a new
  "os.reload_environ()" function. Patch by Victor Stinner.

* gh-126220: Fix crash in "cProfile.Profile" and "_lsprof.Profiler"
  when their callbacks were directly called with 0 arguments.

* gh-126212: Fix issue where "urllib.request.pathname2url()" and
  "url2pathname()" removed slashes from Windows DOS drive paths and
  URLs.

* gh-126223: Raise a "UnicodeEncodeError" instead of a "SystemError"
  upon calling "_interpreters.create()" with an invalid Unicode
  character.

* gh-126205: Fix issue where "urllib.request.pathname2url()" generated
  URLs beginning with four slashes (rather than two) when given a
  Windows UNC path.

* gh-126156: Improved performances of creating "Morsel" objects by a
  factor of 3.8x.

* gh-126105: Fix a crash in "ast" when the "ast.AST._fields" attribute
  is deleted.

* gh-126106: Fixes a possible "NULL" pointer dereference in "ssl".

* gh-126080: Fix a use-after-free crash on "asyncio.Task" objects for
  which the underlying event loop implements an evil
  "__getattribute__()". Reported by Nico-Posada. Patch by Bénédikt
  Tran.

* gh-125322: Correct detection of complex numbers support in libffi.

* gh-126083: Fixed a reference leak in "asyncio.Task" objects when
  reinitializing the same object with a non-"None" context. Patch by
  Nico Posada.

* gh-126068: Fix exceptions in the "argparse" module so that only
  error messages for ArgumentError and ArgumentTypeError are now
  translated. ArgumentError is now only used for command line errors,
  not for logical errors in the program. TypeError is now raised
  instead of ValueError for some logical errors.

* gh-125413: Add "pathlib.Path.scandir()" method to efficiently fetch
  directory children and their file attributes. This is a trivial
  wrapper of "os.scandir()".

* gh-125984: Fix use-after-free crashes on "asyncio.Future" objects
  for which the underlying event loop implements an evil
  "__getattribute__()". Reported by Nico-Posada. Patch by Bénédikt
  Tran.

* gh-125926: Fix "urllib.parse.urljoin()" for base URI with undefined
  authority. Although **RFC 3986** only specify reference resolution
  for absolute base URI, "urljoin()" should continue to return
  sensible result for relative base URI.

* gh-125969: Fix an out-of-bounds crash when an evil
  "asyncio.loop.call_soon()" mutates the length of the internal
  callbacks list. Patch by Bénédikt Tran.

* gh-125966: Fix a use-after-free crash in
  "asyncio.Future.remove_done_callback()". Patch by Bénédikt Tran.

* gh-125789: Fix possible crash when mutating list of callbacks
  returned by "asyncio.Future._callbacks". It now always returns a new
  copy in C implementation "_asyncio". Patch by Kumar Aditya.

* gh-126916: Allow the *initial* parameter of "functools.reduce()" to
  be passed as a keyword argument. Patch by Sayandip Dutta.

* gh-124452: Fix an issue in
  "email.policy.EmailPolicy.header_source_parse()" and
  "email.policy.Compat32.header_source_parse()" that introduced
  spurious leading whitespaces into header values when the header
  includes a newline character after the header name delimiter (":")
  and before the value.

* gh-117941: "argparse.BooleanOptionalAction" now rejects option names
  starting with "--no-".

* gh-125884: Fixed the bug for "pdb" where it can’t set breakpoints on
  functions with certain annotations.

* gh-125355: Fix several bugs in
  "argparse.ArgumentParser.parse_intermixed_args()".

  * The parser no longer changes temporarily during parsing.

  * Default values are not processed twice.

  * Required mutually exclusive groups containing positional arguments
    are now supported.

  * The missing arguments report now includes the names of all
    required optional and positional arguments.

  * Unknown options can be intermixed with positional arguments in
    parse_known_intermixed_args().

* gh-125767: "super" objects are now "pickleable" and "copyable".

* gh-124969: "locale.nl_langinfo(locale.ALT_DIGITS)" now returns a
  string again. The returned value consists of up to 100 semicolon-
  separated symbols.

* gh-84850: Remove "URLopener" and "FancyURLopener" classes from
  "urllib.request". They had previously raised "DeprecationWarning"
  since Python 3.3.

* gh-125666: Avoid the exiting the interpreter if a null byte is given
  as input in the new REPL.

* gh-125710: [Enum] fix hashable<->nonhashable comparisons for member
  values

* gh-125631: Restore ability to set "persistent_id" and
  "persistent_load" attributes of instances of the "Pickler" and
  "Unpickler" classes in the "pickle" module.

* gh-125378: Fixed the bug in "pdb" where after a multi-line command,
  an empty line repeats the first line of the multi-line command,
  instead of the full command.

* gh-125682: Reject non-ASCII digits in the Python implementation of
  "json.loads()" conforming to the JSON specification.

* gh-125660: Reject invalid unicode escapes for Python implementation
  of "json.loads()".

* gh-52551: Use "wcsftime()" to implement "time.strftime()" on
  Windows.

* gh-125259: Fix the notes removal logic for errors thrown in enum
  initialization.

* gh-125633: Add function "inspect.ispackage()" to determine whether
  an object is a *package* or not.

* gh-125614: In the "FORWARDREF" format of "annotationlib", fix bug
  where nested expressions were not returned as
  "annotationlib.ForwardRef" format.

* gh-125590: Allow "FrameLocalsProxy" to delete and pop if the key is
  not a fast variable.

* gh-125600: Only show stale code warning in "pdb" when we display
  source code.

* gh-125542: Deprecate passing keyword-only *prefix_chars* argument to
  "argparse.ArgumentParser.add_argument_group()".

* gh-125541: Pressing "Ctrl"-"C" while blocked in
  "threading.Lock.acquire()", "threading.RLock.acquire()", and
  "threading.Thread.join()" now interrupts the function call and
  raises a "KeyboardInterrupt" exception on Windows, similar to how
  those functions behave on macOS and Linux.

* gh-125519: Improve traceback if "importlib.reload()" is called with
  an object that is not a module. Patch by Alex Waygood.

* gh-125451: Fix deadlock when
  "concurrent.futures.ProcessPoolExecutor" shuts down concurrently
  with an error when feeding a job to a worker process.

* gh-125115: Fixed a bug in "pdb" where arguments starting with "-"
  can’t be passed to the debugged script.

* gh-125398: Fix the conversion of the "VIRTUAL_ENV" path in the
  activate script in "venv" when running in Git Bash for Windows.

* gh-125245: Fix race condition when importing "collections.abc",
  which could incorrectly return an empty module.

* gh-52551: Fix encoding issues in "time.strftime()", the "strftime()"
  method of the "datetime" classes "datetime", "date" and "time" and
  formatting of these classes. Characters not encodable in the current
  locale are now acceptable in the format string. Surrogate pairs and
  sequence of surrogatescape-encoded bytes are no longer recombinated.
  Embedded null character no longer terminates the format string.

* gh-124984: Fixed thread safety in "ssl" in the free-threaded build.
  OpenSSL operations are now protected by a per-object lock.

* gh-124651: Properly quote template strings in "venv" activation
  scripts.

* gh-124694: We’ve added "concurrent.futures.InterpreterPoolExecutor",
  which allows you to run code in multiple isolated interpreters.
  This allows you to circumvent the limitations of CPU-bound threads
  (due to the GIL). Patch by Eric Snow.

  This addition is unrelated to **PEP 734**.

* gh-58032: Deprecate the "argparse.FileType" type converter.

* gh-99749: Adds a feature to optionally enable suggestions for
  argument choices and subparser names if mistyped by the user.

* gh-58956: Fixed a bug in "pdb" where sometimes the breakpoint won’t
  trigger if it was set on a function which is already in the call
  stack.

* gh-124111: The tkinter module can now be built to use either the new
  version 9.0.0 of Tcl/Tk or the latest release 8.6.15 of Tcl/Tk 8.
  Tcl/Tk 9 includes many improvements, both to the Tcl language and to
  the appearance and utility of the graphical user interface provided
  by Tk.

* gh-80958: unittest discovery supports PEP 420 namespace packages as
  start directory again.

* gh-123370: Fix the canvas not clearing after running turtledemo
  clock.

* gh-89083: Add "uuid.uuid8()" for generating UUIDv8 objects as
  specified in **RFC 9562**. Patch by Bénédikt Tran

* gh-122549: Add "platform.invalidate_caches()" to invalidate cached
  results.

* gh-120754: Update unbounded "read" calls in "zipfile" to specify an
  explicit "size" putting a limit on how much data they may read. This
  also updates handling around ZIP max comment size to match the
  standard instead of reading comments that are one byte too long.

* gh-121267: Improve the performance of "tarfile" when writing files,
  by caching user names and group names.

* gh-70764: Fixed an issue where "inspect.getclosurevars()" would
  incorrectly classify an attribute name as a global variable when the
  name exists both as an attribute name and a global variable.

* gh-118289: "posixpath.realpath()" now raises "NotADirectoryError"
  when *strict* mode is enabled and a non-directory path with a
  trailing slash is supplied.

* gh-119826: Always return an absolute path for "os.path.abspath()" on
  Windows.

* gh-97850: Remove deprecated "pkgutil.get_loader()" and
  "pkgutil.find_loader()".

* gh-118986: Add "socket.IPV6_RECVERR" constant (available since Linux
  2.2).

* gh-116897: Accepting objects with false values (like "0" and "[]")
  except empty strings, byte-like objects and "None" in "urllib.parse"
  functions "parse_qsl()" and "parse_qs()" is now deprecated.

* gh-101955: Fix SystemError when match regular expression pattern
  containing some combination of possessive quantifier, alternative
  and capture group.

* gh-71936: Fix a race condition in "multiprocessing.pool.Pool".

* bpo-46128: Strip "unittest.IsolatedAsyncioTestCase" stack frames
  from reported stacktraces.

* gh-84852: Add MIME types for MS Embedded OpenType, OpenType Layout,
  TrueType, WOFF 1.0 and 2.0 fonts. Patch by Sahil Prajapati and Hugo
  van Kemenade.


Documentation
-------------

* gh-126622: Added stub pages for removed modules explaining their
  removal, where to find replacements, and linking to the last Python
  version that supported them. Contributed by Ned Batchelder.

* gh-125277: Require Sphinx 7.2.6 or later to build the Python
  documentation. Patch by Adam Turner.

* gh-60712: Include the "object" type in the lists of documented
  types. Change by Furkan Onder and Martin Panter.


Core and Builtins
-----------------

* gh-126795: Increase the threshold for JIT code warmup. Depending on
  platform and workload, this can result in performance gains of 1-9%
  and memory savings of 3-5%.

* gh-126341: Now "ValueError" is raised instead of "SystemError" when
  trying to iterate over a released "memoryview" object.

* gh-126688: Fix a crash when calling "os.fork()" on some operating
  systems, including SerenityOS.

* gh-126066: Fix "importlib" to not write an incomplete .pyc files
  when a ulimit or some other operating system mechanism is preventing
  the write to go through fully.

* gh-126222: Do not include count of “peek” items in
  "_PyUop_num_popped". This ensures that the correct number of items
  are popped from the stack when a micro-op exits with an error.

* gh-126366: Fix crash when using "yield from" on an object that
  raises an exception in its "__iter__".

* gh-126209: Fix an issue with "skip_file_prefixes" parameter which
  resulted in an inconsistent behaviour between the C and Python
  implementations of "warnings.warn()". Patch by Daehee Kim.

* gh-126312: Fix crash during garbage collection on an object frozen
  by "gc.freeze()" on the free-threaded build.

* gh-103951: Relax optimization requirements to allow fast attribute
  access to module subclasses.

* gh-126072: Following gh-126101, for Code Objects like lambda,
  annotation and type alias, we no longer  add "None" to its
  "co_consts".

* gh-126195: Improve JIT performance by 1.4% on macOS Apple Silicon by
  using platform-specific memory protection APIs. Patch by Diego
  Russo.

* gh-126139: Provide better error location when attempting to use a
  *future statement* with an unknown future feature.

* gh-126072: Add a new attribute in "co_flags" to indicate whether the
  first item in "co_consts" is the docstring. If a code object has no
  docstring, "None" will **NOT** be inserted.

* gh-126076: Relocated objects such as "tuple", "bytes" and "str"
  objects are properly tracked by "tracemalloc" and its associated
  hooks. Patch by Pablo Galindo.

* gh-90370: Avoid temporary tuple creation for vararg in argument
  passing with Argument Clinic generated code (if arguments either
  vararg or positional-only).

* gh-126018: Fix a crash in "sys.audit()" when passing a non-string as
  first argument and Python was compiled in debug mode.

* gh-126012: The "memoryview" type now supports subscription, making
  it a *generic type*.

* gh-125837: Adds "LOAD_SMALL_INT" and "LOAD_CONST_IMMORTAL"
  instructions. "LOAD_SMALL_INT" pushes a small integer equal to the
  "oparg" to the stack. "LOAD_CONST_IMMORTAL" does the same as
  "LOAD_CONST" but is more efficient for immortal objects. Removes
  "RETURN_CONST"  instruction.

* gh-125942: On Android, the "errors" setting of "sys.stdout" was
  changed from "surrogateescape" to "backslashreplace".

* gh-125859: Fix a crash in the free threading build when
  "gc.get_objects()" or "gc.get_referrers()" is called during an in-
  progress garbage collection.

* gh-125868: It was possible in 3.14.0a1 only for attribute lookup to
  give the wrong value. This was due to an incorrect specialization in
  very specific circumstances. This is fixed in 3.14.0a2.

* gh-125498: The JIT has been updated to leverage Clang 19’s new
  "preserve_none" attribute, which supports more platforms and is more
  useful than LLVM’s existing "ghccc" calling convention. This also
  removes the need to manually patch the calling convention in LLVM
  IR, simplifying the JIT compilation process.

* gh-125703: Correctly honour "tracemalloc" hooks in specialized
  "Py_DECREF" paths. Patch by Pablo Galindo

* gh-125593: Use color to highlight error locations in traceback from
  exception group

* gh-125017: Fix crash on certain accesses to the "__annotations__" of
  "staticmethod" and "classmethod" objects.

* gh-125588: The Python PEG generator can now use f-strings in the
  grammar actions. Patch by Pablo Galindo

* gh-125444: Fix illegal instruction for older Arm architectures.
  Patch by Diego Russo, testing by Ross Burton.

* gh-118423: Add a new "INSTRUCTION_SIZE" macro to the cases generator
  which returns the current instruction size.

* gh-125038: Fix crash when iterating over a generator expression
  after direct changes on "gi_frame.f_locals". Patch by Mikhail
  Efimov.

* gh-124855: Don’t allow the JIT and perf support to be active at the
  same time. Patch by Pablo Galindo

* gh-123714: Update JIT compilation to use LLVM 19

* gh-123930: Improve the error message when a script shadowing a
  module from the standard library causes "ImportError" to be raised
  during a “from” import. Similarly, improve the error message when a
  script shadowing a third party module attempts to “from” import an
  attribute from that third party module while still initialising.

* gh-119793: The "map()" built-in now has an optional keyword-only
  *strict* flag like "zip()" to check that all the iterables are of
  equal length. Patch by Wannes Boeykens.

* gh-118950: Fix bug where SSLProtocol.connection_lost wasn’t getting
  called when OSError was thrown on writing to socket.

* gh-113570: Fixed a bug in "reprlib.repr" where it incorrectly called
  the repr method on shadowed Python built-in types.


C API
-----

* gh-126554: Fix error handling in "ctypes.CDLL" objects which could
  result in a crash in rare situations.

* gh-126061: Add "PyLong_IsPositive()", "PyLong_IsNegative()" and
  "PyLong_IsZero()" for checking if a "PyLongObject" is positive,
  negative, or zero, respectively.

* gh-125608: Fix a bug where dictionary watchers (e.g.,
  "PyDict_Watch()") on an object’s attribute dictionary ("__dict__")
  were not triggered when the object’s attributes were modified.

* gh-123619: Added the "PyUnstable_Object_EnableDeferredRefcount()"
  function for enabling **PEP 703** deferred reference counting.

* gh-121654: Add "PyType_Freeze()" function to make a type immutable.
  Patch by Victor Stinner.

* gh-120026: The "Py_HUGE_VAL" macro is *soft deprecated*.


Build
-----

* gh-126691: Removed the "--with-emscripten-target" configure flag. We
  unified the "node" and "browser" options and the same build can now
  be used, independent of target runtime.

* gh-123877: Use "wasm32-wasip1" as the target triple for WASI instead
  of "wasm32-wasi". The latter will eventually be reclaimed for WASI
  1.0 while CPython currently only supports WASI preview1.

* gh-126458: Disable SIMD support for HACL under WASI.

* gh-89640: Hard-code float word ordering as little endian on WASM.

* gh-126206: "make clinic" now runs Argument Clinic using the "--
  force" option, thus forcefully regenerating generated code.

* gh-126187: Introduced "Tools/wasm/emscripten.py" to simplify doing
  Emscripten builds.

* gh-124932: For cross builds, there is now support for having a
  different install "prefix" than the "host_prefix" used by
  "getpath.py". This is set to "/" by default for Emscripten, on other
  platforms the default behavior is the same as before.

* gh-125946: The minimum supported Android version is now 7.0 (API
  level 24).

* gh-125940: The Android build now supports 16 KB page sizes.

* gh-89640: Improve detection of float word ordering on Linux when
  link-time optimizations are enabled.

* gh-124928: Emscripten builds now require node >= 18.

* gh-115382: Fix cross compile failures when the host and target
  SOABIs match.


Python 3.14.0 alpha 1
=====================

*Release date: 2024-10-15*


macOS
-----

* gh-124448: Update bundled Tcl/Tk in macOS installer to 8.6.15.

* gh-123797: Check for runtime availability of "ptsname_r" function on
  macos.

* gh-123418: Updated macOS installer build to use OpenSSL 3.0.15.


Windows
-------

* gh-124487: Increases Windows required OS and API level to Windows
  10.

* gh-124609: Fix "_Py_ThreadId" for Windows builds using MinGW. Patch
  by Tony Roberts.

* gh-124448: Updated bundled Tcl/Tk to 8.6.15.

* gh-124254: Ensures experimental free-threaded binaries remain
  installed when updating.

* gh-123915: Ensure that "Tools\msi\buildrelease.bat" uses different
  directories for AMD64 and ARM64 builds.

* gh-123418: Updated Windows build to use OpenSSL 3.0.15.

* gh-123476: Add support for "socket.TCP_QUICKACK" on Windows
  platforms.

* gh-122573: The Windows build of CPython now requires 3.10 or newer.

* gh-100256: "mimetypes" no longer fails when it encounters an
  inaccessible registry key.

* gh-119679: Ensures correct import libraries are included in Windows
  installs.

* gh-119690: Adds Unicode support and fixes audit events for
  "_winapi.CreateNamedPipe".

* gh-111201: Add support for new pyrepl on Windows

* gh-119070: Fixes "py.exe" handling of shebangs like "/usr/bin/env
  python3.12", which were previously interpreted as "python3.exe"
  instead of "python3.12.exe".

* gh-117505: Fixes an issue with the Windows installer not running
  ensurepip in a fully isolated environment. This could cause
  unexpected interactions with the user site-packages.

* gh-118209: Avoid crashing in "mmap" on Windows when the mapped
  memory is inaccessible due to file system errors or access
  violations.

* gh-79846: Makes "ssl.create_default_context()" ignore invalid
  certificates in the Windows certificate store


Tools/Demos
-----------

* gh-123418: Update GitHub CI workflows to use OpenSSL 3.0.15 and
  multissltests to use 3.0.15, 3.1.7, and 3.2.3.


Tests
-----

* gh-125041: Re-enable skipped tests for "zlib" on the s390x
  architecture: only skip checks of the compressed bytes, which can be
  different between zlib’s software implementation and the hardware-
  accelerated implementation.

* gh-124378: Updated "test_ttk" to pass with Tcl/Tk 8.6.15.

* gh-124213: Detect whether the test suite is running inside a
  systemd-nspawn container with "--suppress-sync=true" option, and
  skip the "test_os" and "test_mmap" tests that are failing in this
  scenario.

* gh-124190: Add capability to ignore entire files or directories in
  check warning CI tool

* gh-121921: Update "Lib/test/crashers/bogus_code_obj.py" so that it
  crashes properly again.

* gh-112301: Add tooling to check for changes in compiler warnings.
  Patch by Nate Ohlson.

* gh-59022: Add tests for "pkgutil.extend_path()". Patch by Andreas
  Stocker.

* gh-99242: "os.getloadavg()" may throw "OSError" when running
  regression tests under certain conditions (e.g. chroot). This error
  is now caught and ignored, since reporting load average is optional.

* gh-121084: Fix test_typing random leaks. Clear typing ABC caches
  when running tests for refleaks ("-R" option): call
  "_abc_caches_clear()" on typing abstract classes and their
  subclasses. Patch by Victor Stinner.

* gh-121160: Add a test for "readline.set_history_length()". Note that
  this test may fail on readline libraries.

* gh-121200: Fix "test_expanduser_pwd2()" of "test_posixpath".  Call
  "getpwnam()" to get "pw_dir", since it can be different than
  "getpwall()" "pw_dir". Patch by Victor Stinner.

* gh-121188: When creating the JUnit XML file, regrtest now escapes
  characters which are invalid in XML, such as the chr(27) control
  character used in ANSI escape sequences. Patch by Victor Stinner.

* gh-120801: Cleaned up fixtures for importlib.metadata tests and
  consolidated behavior with ‘test.support.os_helper’.

* gh-119727: Add "--single-process" command line option to Python test
  runner (regrtest). Patch by Victor Stinner.

* gh-119273: Python test runner no longer runs tests using TTY (ex:
  test_ioctl) in a process group (using "setsid()"). Previously, tests
  using TTY were skipped. Patch by Victor Stinner.

* gh-119050: regrtest test runner: Add XML support to the refleak
  checker (-R option). Patch by Victor Stinner.

* gh-101525: Skip "test_gdb" if the binary is relocated by BOLT. Patch
  by Donghee Na.

* gh-107562: Test certificates have been updated to expire far in the
  future. This allows testing Y2038 with system time set to after
  that, so that actual Y2038 issues can be exposed, and not masked by
  expired certificate errors.


Security
--------

* gh-125140: Remove the current directory from "sys.path" when using
  PyREPL.

* gh-123678: Upgrade libexpat to 2.6.3

* gh-112301: Enable compiler options that warn of potential security
  vulnerabilities.

* gh-122792: Changed IPv4-mapped "ipaddress.IPv6Address" to
  consistently use the mapped IPv4 address value for deciding
  properties. Properties which have their behavior fixed are
  "is_multicast", "is_reserved", "is_link_local", "is_global", and
  "is_unspecified".

* gh-112301: Add ability to ignore warnings per file with warning
  count in warning checking tooling. Patch by Nate Ohlson.

* gh-112301: Add macOS warning tracking to warning check tooling.
  Patch by Nate Ohlson.

* gh-122133: Authenticate the socket connection for the
  "socket.socketpair()" fallback on platforms where "AF_UNIX" is not
  available like Windows.

  Patch by Gregory P. Smith <greg@krypto.org> and Seth Larson
  <seth@python.org>. Reported by Ellie <el@horse64.org>

* gh-121957: Fixed missing audit events around interactive use of
  Python, now also properly firing for "python -i", as well as for
  "python -m asyncio". The events in question are "cpython.run_stdin"
  and "cpython.run_startup".

* gh-112301: Enable runtime protections for glibc to abort execution
  when unsafe behavior is encountered, for all platforms except
  Windows.

* gh-121285: Remove backtracking from tarfile header parsing for
  "hdrcharset", PAX, and GNU sparse headers.

* gh-112301: Add default compiler options to improve security. Enable
  -Wimplicit-fallthrough, -fstack-protector-strong, -Wtrampolines.

* gh-118773: Fixes creation of ACLs in "os.mkdir()" on Windows to work
  correctly on non-English machines.

* gh-118486: "os.mkdir()" on Windows now accepts *mode* of "0o700" to
  restrict the new directory to the current user. This fixes **CVE
  2024-4030** affecting "tempfile.mkdtemp()" in scenarios where the
  base temporary directory is more permissive than the default.


Library
-------

* gh-125422: Fixed the bug where "pdb" and "bdb" can step into the
  bottom caller frame.

* gh-100141: Fixed the bug where "pdb" will be stuck in an infinite
  loop when debugging an empty file.

* gh-53203: Fix "time.strptime()" for "%c", "%x" and "%X" formats in
  many locales that use non-ASCII digits, like Persian, Burmese, Odia
  and Shan.

* gh-125206: Workaround for old libffi versions is added. Module
  ctypes supports double complex only with libffi >= 3.3.0. Patch by
  Mikhail Efimov.

* gh-89967: Make "WeakKeyDictionary" and "WeakValueDictionary" safe
  against concurrent mutations from other threads. Patch by Kumar
  Aditya.

* gh-125260: The "gzip.compress()" *mtime* parameter now defaults to 0
  for reproducible output. Patch by Bernhard M. Wiedemann and Adam
  Turner.

* gh-125243: Fix data race when creating "zoneinfo.ZoneInfo" objects
  in the free threading build.

* gh-125254: Fix a bug where ArgumentError includes the incorrect
  ambiguous option in "argparse".

* gh-125235: Keep "tkinter" TCL paths in venv pointing to base
  installation on Windows.

* gh-61011: Fix inheritance of nested mutually exclusive groups from
  parent parser in "argparse.ArgumentParser". Previously, all nested
  mutually exclusive groups lost their connection to the group
  containing them and were displayed as belonging directly to the
  parser.

* gh-125118: Don’t copy arbitrary values to _Bool in the "struct"
  module.

* gh-125069: Fix an issue where providing a "pathlib.PurePath" object
  as an initializer argument to a second "PurePath" object with a
  different "parser" resulted in arguments to the former object’s
  initializer being joined by the latter object’s parser.

* gh-125096: If the "PYTHON_BASIC_REPL" environment variable is set,
  the "site" module no longer imports the "_pyrepl" module. Moreover,
  the "site" module now respects "-E" and "-I" command line options:
  ignore "PYTHON_BASIC_REPL" in this case. Patch by Victor Stinner.

* gh-124969: Fix "locale.nl_langinfo(locale.ALT_DIGITS)". Now it
  returns a tuple of up to 100 strings (an empty tuple on most
  locales). Previously it returned the first item of that tuple or an
  empty string.

* gh-124960: Fix support for the "barry_as_FLUFL" future flag in the
  new REPL.

* gh-69998: Fix "locale.nl_langinfo()" in case when different
  categories have different locales. The function now sets temporarily
  the "LC_CTYPE" locale in some cases. This temporary change affects
  other threads.

* gh-124958: Fix refcycles in exceptions raised from
  "asyncio.TaskGroup" and the python implementation of
  "asyncio.Future"

* gh-53203: Fix "time.strptime()" for "%c" and "%x" formats in many
  locales: Arabic, Bislama, Breton, Bodo, Kashubian, Chuvash,
  Estonian, French, Irish, Ge’ez, Gurajati, Manx Gaelic, Hebrew,
  Hindi, Chhattisgarhi, Haitian Kreyol, Japanese, Kannada, Korean,
  Marathi, Malay, Norwegian, Nynorsk, Punjabi, Rajasthani, Tok Pisin,
  Yoruba, Yue Chinese, Yau/Nungon and Chinese.

* gh-123961: Convert "curses" to multi-phase initialization (**PEP
  489**), thereby fixing reference leaks at interpreter shutdown.
  Patch by Bénédikt Tran.

* gh-124944: Add "SO_ORIGINAL_DST" to the "socket" module.

* gh-117151: The default buffer size used by "shutil.copyfileobj()"
  has been increased from 64k to 256k on non-Windows platforms. It was
  already larger on Windows.

* gh-90102: Skip the "isatty" system call during open() when the file
  is known to not be a character device. This provides a slight
  performance improvement when reading whole files.

* gh-124917: Allow calling "os.path.exists()" and "os.path.lexists()"
  with keyword arguments on Windows. Fixes a regression in 3.13.0.

* gh-65865: "argparse" now raises early error for invalid "help"
  arguments to "add_argument()", "add_subparsers()" and
  "add_parser()".

* gh-124653: Fix detection of the minimal Queue API needed by the
  "logging" module. Patch by Bénédikt Tran.

* gh-91818: The CLI of many modules ("ast", "ensurepip", "json",
  "pdb", "sqlite3", "tokenize", "venv") now uses the actual executable
  name instead of simply “python” to display in the usage message.

* gh-124858: Fix reference cycles left in tracebacks in
  "asyncio.open_connection()" when used with "happy_eyeballs_delay"

* gh-124390: Fixed "AssertionError" when using
  "asyncio.staggered.staggered_race()" with
  "asyncio.eager_task_factory".

* gh-85935: "argparse.ArgumentParser.add_argument()" now raises an
  exception if an action that does not consume arguments (like
  ‘store_const’ or ‘store_true’) or explicit "nargs=0" are specified
  for positional arguments.

* gh-124835: Make "tomllib.loads()" raise "TypeError" not
  "AttributeError" on bad input types that do not have the "replace"
  attribute. Improve error message when "bytes" is received.

* gh-124693: Fix a bug where "argparse" doesn’t recognize negative
  complex numbers or negative numbers using scientific notation.

* gh-124787: Fix "typing.TypeAliasType" with incorrect "type_params"
  argument. Now it raises a "TypeError" when a type parameter without
  a default follows one with a default, and when an entry in the
  "type_params" tuple is not a type parameter object.

* gh-66436: Improved prog default value for "argparse.ArgumentParser".
  It will now include the name of the Python executable along with the
  module or package name, or the path to a directory, ZIP file, or
  directory within a ZIP file if the code was run that way.

* gh-116850: Fix "argparse" for namespaces with not directly writable
  dict (e.g. classes).

* gh-101552: Add an *annoation_format* parameter to
  "inspect.signature()". Add an *quote_annotation_strings* parameter
  to "inspect.Signature.format()". Use the new functionality to
  improve the display of annotations in signatures in "pydoc". Patch
  by Jelle Zijlstra.

* gh-58573: Fix conflicts between abbreviated long options in the
  parent parser and subparsers in "argparse".

* gh-124594: All "asyncio" REPL prompts run in the same "context".
  Contributed by Bartosz Sławecki.

* gh-61181: Fix support of choices with string value in "argparse".
  Substrings of the specified string no longer considered valid
  values.

* gh-116750: Provide "sys.monitoring.clear_tool_id()" to unregister
  all events and callbacks set by the tool.

* gh-124552: Improve the accuracy of "bdb"’s check for the possibility
  of breakpoint in a frame. This makes it possible to disable
  unnecessary events in functions.

* gh-124538: Fixed crash when using "gc.get_referents()" on a capsule
  object.

* gh-80259: Fix "argparse" support of positional arguments with
  "nargs='?'", "default=argparse.SUPPRESS" and specified "type".

* gh-120378: Fix a crash related to an integer overflow in
  "curses.resizeterm()" and "curses.resize_term()".

* gh-124498: Fix "typing.TypeAliasType" not to be generic, when
  "type_params" is an empty tuple.

* gh-53834: Fix support of arguments with choices in "argparse".
  Positional arguments with nargs equal to "'?'" or "'*'" no longer
  check default against "choices". Optional arguments with "nargs"
  equal to "'?'" no longer check const against "choices".

* gh-123884: Fixed bug in itertools.tee() handling of other tee inputs
  (a tee in a tee). The output now has the promised *n* independent
  new iterators.  Formerly, the first iterator was identical (not
  independent) to the input iterator. This would sometimes give
  surprising results.

* gh-123017: Due to unreliable results on some devices,
  "time.strftime()" no longer accepts negative years on Android.

* gh-123014: "os.pidfd_open()" and "signal.pidfd_send_signal()" are
  now unavailable when building against Android API levels older than
  31, since the underlying system calls may cause a crash.

* gh-124176: Add support for "dataclasses.dataclass()" in
  "unittest.mock.create_autospec()". Now "create_autospec" will check
  for potential dataclasses and use "dataclasses.fields()" function to
  retrieve the spec information.

* gh-124345: "argparse" supports abbreviated single-dash long options
  separated by "=" from its value.

* gh-124400: Fixed a "pdb" bug where "until" has no effect when it
  appears in a "commands" sequence. Also avoid printing the frame
  information at a breakpoint that has a command list containing a
  command that resumes execution.

* gh-90562: Modify dataclasses to support zero-argument super() when
  "slots=True" is specified.  This works by modifying all references
  to "__class__" to point to the newly created class.

* gh-104860: Fix disallowing abbreviation of single-dash long options
  in "argparse" with "allow_abbrev=False".

* gh-63143: Fix parsing mutually exclusive arguments in "argparse".
  Arguments with the value identical to the default value (e.g.
  booleans, small integers, empty or 1-character strings) are no
  longer considered “not present”.

* gh-72795: Positional arguments with nargs equal to "'*'" or
  "argparse.REMAINDER" are no longer required. This allows to use
  positional argument with "nargs='*'" and without "default" in
  mutually exclusive group and improves error message about required
  arguments.

* gh-59317: Fix parsing positional argument with nargs equal to "'?'"
  or "'*'" if it is preceded by an option and another positional
  argument.

* gh-100980: The "_fields_" attribute of "ctypes.Structure" and
  "Union" is no longer set if the setattr operation raises an error.

* gh-53780: "argparse" now ignores the first ""--"" (double dash)
  between an option and command.

* gh-124217: Add RFC 9637 reserved IPv6 block "3fff::/20" in
  "ipaddress" module.

* gh-111513: Improve the error message that may be raised by
  "datetime.date.fromtimestamp()".

* gh-124248: Fixed potential crash when using "struct" to process
  zero-width ‘Pascal string’ fields ("0p").

* gh-81691: Fix handling of multiple ""--"" (double dashes) in
  "argparse". Only the first one has now been removed, all subsequent
  ones are now taken literally.

* gh-87041: Fix a bug in "argparse" where lengthy subparser argument
  help is incorrectly indented.

* gh-84559: The default "multiprocessing" start method on Linux and
  other POSIX systems has been changed away from often unsafe ""fork""
  to ""forkserver"" (when the platform supports sending file handles
  over pipes as most do) or ""spawn"".  Mac and Windows are unchanged
  as they already default to ""spawn"".

* gh-124212: Fix invalid variable in "venv" handling of failed symlink
  on Windows

* gh-124171: Add workaround for broken "fmod()" implementations on
  Windows, that loose zero sign (e.g. "fmod(-10, 1)" returns "0.0").
  Patch by Sergey B Kirpichev.

* gh-123978: Remove broken "time.thread_time()" and
  "time.thread_time_ns()" on NetBSD.

* gh-123934: Fix "unittest.mock.MagicMock" resetting magic methods
  return values after ".reset_mock(return_value=True)" was called.

* gh-124016: Update "unicodedata" database to Unicode 16.0.0.

* gh-123968: Fix the command-line interface for the "random" module to
  select floats between 0 and N, not 1 and N.

* gh-123945: Fix a bug where "argparse" doesn’t recognize negative
  numbers with underscores

* gh-123935: Fix parent slots detection for dataclasses that inherit
  from classes with "__dictoffset__".

* gh-123892: Add ""_wmi"" to "sys.stdlib_module_names". Patch by
  Victor Stinner.

* gh-84808: Fix error handling in "socket" method "connect_ex()" on
  platforms where "errno" can be negative.

* gh-123756: Added a new argument "mode" to "pdb.Pdb". Only allow
  "pdb" from command line to use "restart" command.

* gh-122765: Fix unbalanced quote errors occurring when activate.csh
  in "venv" was sourced with a custom prompt containing unpaired
  quotes or newlines.

* gh-123657: Fix crash and memory leak in "decimal.getcontext()". It
  crashed when using a thread-local context by "--with-decimal-
  contextvar=no".

* gh-123339: Fix "inspect.getsource()" for classes in
  "collections.abc" and "decimal" (for pure Python implementation)
  modules. "inspect.getcomments()" now raises OSError instead of
  IndexError if the "__firstlineno__" value for a class is out of
  bound.

* gh-123374: Remove check for redefined memo entry in
  "pickletools.dis()".

* gh-123504: Fixed reference leak in the finalization of "tkinter".

* gh-123430: Pages generated by the "http.server" module allow the
  browser to apply its default dark mode.

* gh-123446: Fix empty function name in "TypeError" when
  "csv.reader()", "csv.writer()", or "csv.register_dialect()" are used
  without the required args.

* gh-123448: Fixed memory leak of "typing.NoDefault" by moving it to
  the static types array.

* gh-123409: Fix "ipaddress.IPv6Address.reverse_pointer" output
  according to **RFC 3596, §2.5**.  Patch by Bénédikt Tran.

* gh-123089: Make "weakref.WeakSet" safe against concurrent mutations
  while it is being iterated. Patch by Kumar Aditya.

* gh-123363: Show string value of "CONTAINS_OP" oparg in "dis" output.
  Patch by Alexandr153.

* gh-123341: Add "__class_getitem__()" to "tkinter.Event" for type
  subscript support at runtime. Patch by Adonis Rakateli.

* gh-123340: Show string value of "IS_OP" oparg in "dis" output.

* gh-119518: Speed up normalization of "pathlib.PurePath" and "Path"
  objects by not interning string parts.

* gh-123270: Applied a more surgical fix for malformed payloads in
  "zipfile.Path" causing infinite loops (gh-122905) without breaking
  contents using legitimate characters.

* gh-73991: Add "pathlib.Path.copy_into()" and "move_into()", which
  copy and move files and directories into *existing* directories.

* gh-123228: Fix return type for
  "_pyrepl.readline._ReadlineWrapper.get_line_buffer()" to be "str()".
  Patch by Sergey B Kirpichev.

* gh-123240: Raise audit events for the "input()" in the new REPL.

* gh-76960: Fix "urllib.parse.urljoin()" and
  "urllib.parse.urldefrag()" for URIs containing empty components. For
  example, "urljoin()" with relative reference “?” now sets empty
  query and removes fragment. Preserve empty components (authority,
  params, query, fragment) in "urljoin()". Preserve empty components
  (authority, params, query) in "urldefrag()".

* gh-116810: Resolve a memory leak introduced in CPython 3.10’s "ssl"
  when the "ssl.SSLSocket.session" property was accessed.  Speeds up
  read and write access to said property by no longer unnecessarily
  cloning session objects via serialization.

* gh-123243: Fix memory leak in "_decimal".

* gh-122546: Consistently use same file name for different exceptions
  in the new repl. Patch by Sergey B Kirpichev.

* gh-123213: "xml.etree.ElementTree.Element.extend()" and "Element"
  assignment no longer hide the internal exception if an erroneous
  generator is passed. Patch by Bar Harel.

* gh-85110: Preserve relative path in URL without netloc in
  "urllib.parse.urlunsplit()" and "urllib.parse.urlunparse()".

* gh-123165: Add support for rendering "Positions" in "dis".

* gh-122909: In urllib.request when URLError is raised opening an ftp
  URL, the exception argument is now consistently a string. Earlier
  versions passed either a string or an ftplib exception instance as
  the argument to URLError.

* gh-123084: Deprecate "shutil.ExecError", which hasn’t been raised by
  any "shutil" function since Python 3.4. It’s now an alias for
  "RuntimeError".

* gh-123085: In a bare call to "importlib.resources.files()", ensure
  the caller’s frame is properly detected when "importlib.resources"
  is itself available as a compiled module only (no source).

* gh-123067: Fix quadratic complexity in parsing """-quoted cookie
  values with backslashes by "http.cookies".

* gh-123049: Add support for "UNNAMED_SECTION" in
  "configparser.ConfigParser.add_section()".

* gh-121735: When working with zip archives, importlib.resources now
  properly honors module-adjacent references (e.g. "files(pkg.mod)"
  and not just "files(pkg)").

* gh-122981: Fix "inspect.getsource()" for generated classes with
  Python base classes (e.g. enums).

* gh-122903: "zipfile.Path.glob" now correctly matches directories
  instead of silently omitting them.

* gh-122905: "zipfile.Path" objects now sanitize names from the
  zipfile.

* gh-122873: Enable "json" module to work as a script using the "-m"
  switch: "python -m json". See the JSON command-line interface
  documentation. Patch by Trey Hunner.

* gh-122858: Deprecate "asyncio.iscoroutinefunction()" in favor of
  "inspect.iscoroutinefunction()".

* gh-116263: "logging.handlers.RotatingFileHandler" no longer rolls
  over empty log files.

* gh-105376: Restore the deprecated "logging" "warn()" method. It was
  removed in Python 3.13 alpha 1. Keep the deprecated "warn()" method
  in Python 3.13. Patch by Victor Stinner.

* gh-122311: Improve errors in the "pickle" module. "PicklingError" is
  now raised more often instead of "UnicodeEncodeError", "ValueError"
  and "AttributeError", and the original exception is chained to it.
  Improve and unify error messages in Python and C implementations.

* gh-122744: Bump the version of pip bundled in ensurepip to version
  24.2.

* gh-118761: Improve import time of "pprint" by around seven times.
  Patch by Hugo van Kemenade.

* gh-118974: Add "decorator" parameter to
  "dataclasses.make_dataclass()" to customize the functional creation
  of dataclasses.

* gh-118814: Fix the "typing.TypeVar" constructor when name is passed
  by keyword.

* gh-122637: Adjust "cmath.tanh(nanj)" and "cmath.tanh(infj)" for
  recent C standards.

* gh-122478: Remove internal frames from tracebacks shown in
  "code.InteractiveInterpreter" with non-default "sys.excepthook()".
  Save correct tracebacks in "sys.last_traceback" and update
  "__traceback__" attribute of "sys.last_value" and "sys.last_exc".

* gh-116622: On Android, the "FICLONE" and "FICLONERANGE" constants
  are no longer exposed by "fcntl", as these ioctls are blocked by
  SELinux.

* gh-82378: Make sure that the new *REPL* interprets
  "sys.tracebacklimit" in the same way that the classic REPL did.

* gh-122334: Fix crash when importing "ssl" after the main interpreter
  restarts.

* gh-122459: Optimize "pickling" by name objects without the
  "__module__" attribute.

* gh-87320: In "code.InteractiveInterpreter", handle exceptions caused
  by calling a non-default "sys.excepthook()". Before, the exception
  bubbled up to the caller, ending the *REPL*.

* gh-122272: On some platforms such as Linux, year with century was
  not 0-padded when formatted by "strftime()" with C99-specific
  specifiers "'%C'" or "'%F'". The 0-padding behavior is now
  guaranteed when the format specifiers "'%C'" and "'%F'" are
  supported by the C library. Patch by Ben Hsing

* gh-122400: Handle "ValueError"s raised by "os.stat()" in
  "filecmp.dircmp" and "filecmp.cmpfiles()". Patch by Bénédikt Tran.

* gh-122311: Fix some error messages in "pickle".

* gh-121650: "email" headers with embedded newlines are now quoted on
  output. The "generator" will now refuse to serialize (write) headers
  that are unsafely folded or delimited; see
  "verify_generated_headers". (Contributed by Bas Bloemsaat and Petr
  Viktorin in gh-121650.)

* gh-122332: Fixed segfault with "asyncio.Task.get_coro()" when using
  an eager task factory.

* gh-105733: "ctypes.ARRAY()" is now *soft deprecated*: it no longer
  emits deprecation warnings and is not scheduled for removal.

* gh-122213: Add notes for pickle serialization errors that allow to
  identify the source of the error.

* gh-119180: As part of **PEP 749**, add the following attributes for
  customizing evaluation of annotation scopes:

  * "evaluate_value" on "typing.TypeAliasType"

  * "evaluate_bound", "evaluate_constraints", and "evaluate_default"
    on "typing.TypeVar"

  * "evaluate_default" on "typing.ParamSpec"

  * "evaluate_default" on "typing.TypeVarTuple"

* gh-119180: Fix handling of classes with custom metaclasses in
  "annotationlib.get_annotations".

* gh-122170: Handle "ValueError"s raised by "os.stat()" in
  "linecache". Patch by Bénédikt Tran.

* gh-122163: Add notes for JSON serialization errors that allow to
  identify the source of the error.

* gh-122129: Improve support of method descriptors and wrappers in the
  help title.

* gh-122145: Fix an issue when reporting tracebacks corresponding to
  Python code emitting an empty AST body. Patch by Nikita Sobolev and
  Bénédikt Tran.

* gh-121723: Make "logging.config.dictConfig()" accept any object
  implementing the Queue public API. See the queue configuration
  section for details. Patch by Bénédikt Tran.

* gh-82951: Serializing objects with complex "__qualname__" (such as
  unbound methods and nested classes) by name no longer involves
  serializing parent objects by value in pickle protocols < 4.

* gh-120754: "Pathlib.read_bytes" no longer opens the file in Python’s
  buffered I/O mode. This reduces overheads as the code reads a file
  in whole leading to a modest speedup.

* gh-113785: "csv" now correctly parses numeric fields (when used with
  "csv.QUOTE_NONNUMERIC" or "csv.QUOTE_STRINGS") which start with an
  escape character.

* gh-122088: "@warnings.deprecated" now copies the coroutine status of
  functions and methods so that "inspect.iscoroutinefunction()"
  returns the correct result.

* gh-122081: Fix a crash in the "decimal.IEEEContext()" optional
  function available via the "EXTRA_FUNCTIONALITY" configuration flag.

* gh-73991: Add "pathlib.Path.move()", which moves a file or directory
  tree.

* gh-121268: Remove workarounds for non-IEEE 754 systems in "cmath".

* gh-119698: Due to the lack of interest for
  "symtable.Class.get_methods()", the method is marked as deprecated
  and will be removed in Python 3.16. Patch by Bénédikt Tran.

* gh-121889: Adjusts "cmath.acosh(complex('0+nanj'))" for recent C
  standards.

* gh-121804: Correctly show error locations, when "SyntaxError" raised
  in new repl. Patch by Sergey B Kirpichev.

* gh-121797: Add alternative "Fraction" constructor
  "Fraction.from_number()".

* gh-121798: Add alternative "Decimal" constructor
  "Decimal.from_number()".

* gh-120930: Fixed a bug introduced by gh-92081 that added an
  incorrect extra blank to encoded words occurring in wrapped headers.

* gh-57141: The *shallow* argument to "filecmp.dircmp" (new in Python
  3.13) is now keyword-only.

* gh-121245: Simplify handling of the history file in
  "site.register_readline()" helper. The "CAN_USE_PYREPL" variable now
  will be initialized, when imported.  Patch by Sergey B Kirpichev.

* gh-121249: Support the float complex and double complex C types in
  the "struct" module if the compiler has C11 complex arithmetic.
  Patch by Sergey B Kirpichev.

* gh-121486: "math" functions "isqrt()", "log()", "log2()" and
  "log10()" now support integers larger than "2**2**32" on 32-bit
  platforms.

* gh-121474: Fix missing sanity check for "parties" arg in
  "threading.Barrier" constructor. Patch by Clinton Christian
  (pygeek).

* gh-121450: Hard-coded breakpoints ("breakpoint()" and
  "pdb.set_trace()") now reuse the most recent "Pdb" instance that
  calls "Pdb.set_trace()", instead of creating a new one each time. As
  a result, all the instance specific data like "display" and
  "commands" are preserved across Hard-coded breakpoints.

* gh-119169: Slightly speed up "os.walk()" by simplifying exception
  handling.

* gh-121423: Improve import time of "socket" by lazy importing modules
  and writing "socket.errorTab" as a constant.

* gh-59110: "zipimport" supports now namespace packages when no
  directory entry exists.

* gh-119004: Fix a crash in OrderedDict.__eq__ when operands are
  mutated during the check. Patch by Bénédikt Tran.

* gh-121313: Limit the reading size in the
  "multiprocessing.connection.Connection" class to 64 KiB to prevent
  memory overallocation and unnecessary memory management system
  calls.

* gh-121332: Fix constructor of "ast" nodes with custom "_attributes".
  Previously, passing custom attributes would raise a
  "DeprecationWarning". Passing arguments to the constructor that are
  not in "_fields" or "_attributes" remains deprecated. Patch by Jelle
  Zijlstra.

* gh-121245: Fix a bug in the handling of the command history of the
  new *REPL* that caused the history file to be wiped at REPL exit.

* gh-121210: Handle AST nodes with missing runtime fields or
  attributes in "ast.compare()". Patch by Bénédikt Tran.

* gh-121163: Add support for "all" as an valid "action" for
  "warnings.simplefilter()" and "warnings.filterwarnings()".

* gh-121151: Fix wrapping of long usage text of arguments inside a
  mutually exclusive group in "argparse".

* gh-121141: Add support for "copy.replace()" to AST nodes. Patch by
  Bénédikt Tran.

* gh-87744: Fix waitpid race while calling "send_signal()" in asyncio.
  Patch by Kumar Aditya.

* gh-121027: Add a future warning in "functools.partial.__get__()". In
  future Python versions "functools.partial" will be a method
  descriptor.

* gh-121027: Make the "functools.partial" object a method descriptor.

* gh-117784: CPython now detects whether its linked TLS library
  supports TLSv1.3 post-handshake authentication and disables that
  feature if support is lacking.

* gh-121025: Improve the "__repr__()" of "functools.partialmethod".
  Patch by Bénédikt Tran.

* gh-121018: Fixed issues where "argparse.ArgumentParser.parse_args()"
  did not honor "exit_on_error=False". Based on patch by Ben Hsing.

* gh-119614: Fix truncation of strings with embedded null characters
  in some internal operations in "tkinter".

* gh-120910: When reading installed files from an egg, use
  "relative_to(walk_up=True)" to honor files installed outside of the
  installation root.

* gh-61103: Support float complex, double complex and long double
  complex C types in "ctypes" as "c_float_complex", "c_double_complex"
  and "c_longdouble_complex" if the compiler has C11 complex
  arithmetic. Patch by Sergey B Kirpichev.

* gh-120888: Upgrade pip wheel bundled with ensurepip (pip 24.1.1)

* gh-101830: Accessing the "tkinter" object’s string representation no
  longer converts the underlying Tcl object to a string on Windows.

* gh-120678: Fix regression in the new REPL that meant that globals
  from files passed using the "-i" argument would not be included in
  the REPL’s global namespace. Patch by Alex Waygood.

* gh-120811: Fix possible memory leak in "contextvars.Context.run()".

* gh-120782: Fix wrong references of the "datetime" types after
  reloading the module.

* gh-120713: "datetime.datetime.strftime()" now 0-pads years with less
  than four digits for the format specifiers "%Y" and "%G" on Linux.
  Patch by Ben Hsing

* gh-120769: Make empty line in "pdb" repeats the last command even
  when the command is from "cmdqueue".

* gh-120780: Show string value of LOAD_SPECIAL oparg in "dis" output.

* gh-41431: Add "datetime.time.strptime()" and
  "datetime.date.strptime()". Contributed by Wannes Boeykens.

* gh-120743: *Soft deprecate* "os.popen()" and "os.spawn*" functions.
  They should no longer be used to write new code. The "subprocess"
  module is recommended instead. Patch by Victor Stinner.

* gh-120732: Fix "name" passing to "unittest.mock.Mock" object when
  using "unittest.mock.create_autospec()".

* gh-111259: "re" now handles patterns like ""[\s\S]"" or ""\s|\S""
  which match any character as effectively as a dot with the "DOTALL"
  modifier (""(?s:.)"").

* gh-120683: Fix an error in "logging.LogRecord", when the integer
  part of the timestamp is rounded up, while the millisecond
  calculation truncates, causing the log timestamp to be wrong by up
  to 999 ms (affected roughly 1 in 8 million timestamps).

* gh-118710: "ipaddress.IPv4Address" and "ipaddress.IPv6Address"
  attributes "version" and "max_prefixlen" are now available on the
  class.

* gh-120633: Move scrollbar and remove tear-off menus in turtledemo.

* gh-120606: Allow users to use EOF to exit "commands" definition in
  "pdb"

* gh-120284: Allow "asyncio.Runner.run()" to accept *awaitable*
  objects instead of simply *coroutine*s.

* gh-120541: Improve the prompt in the “less” pager when "help()" is
  called with non-string argument.

* gh-120495: Fix incorrect exception handling in Tab Nanny. Patch by
  Wulian233.

* gh-120388: Improve a warning message when a test method in
  "unittest" returns something other than "None". Now we show the
  returned object type and optional asyncio-related tip.

* gh-120381: Correct "inspect.ismethoddescriptor()" to check also for
  the lack of "__delete__()".  Patch by Jan Kaliszewski.

* gh-90425: The OS byte in gzip headers is now always set to 255 when
  using "gzip.compress()".

* gh-120343: Fix column offset reporting for tokens that come after
  multiline f-strings in the "tokenize" module.

* gh-119180: As part of implementing **PEP 649** and **PEP 749**, add
  a new module "annotationlib". Add support for unresolved forward
  references in annotations to "dataclasses", "typing.TypedDict", and
  "typing.NamedTuple".

* gh-119600: Fix "unittest.mock.patch()" to not read attributes of the
  target when "new_callable" is set. Patch by Robert Collins.

* gh-120289: Fixed the use-after-free issue in "cProfile" by
  disallowing "disable()" and "clear()" in external timers.

* gh-82017: Added support for converting any objects that have the
  "as_integer_ratio()" method to a "Fraction".

* gh-114053: Fix edge-case bug where "typing.get_type_hints()" would
  produce incorrect results if type parameters in a class scope were
  overridden by assignments in a class scope and "from __future__
  import annotations" semantics were enabled. Patch by Alex Waygood.

* gh-114053: Fix erroneous "NameError" when calling
  "inspect.get_annotations()" with "eval_str=True`" on a class that
  made use of **PEP 695** type parameters in a module that had "from
  __future__ import annotations" at the top of the file. Patch by Alex
  Waygood.

* gh-120268: Prohibit passing "None" to pure-Python
  "datetime.date.fromtimestamp()" to achieve consistency with
  C-extension implementation.

* gh-120244: Fix memory leak in "re.sub()" when the replacement string
  contains backreferences.

* gh-120254: Added "commands" argument to "pdb.set_trace()" which
  allows users to send debugger commands from the source file.

* gh-120211: Fix "tkinter.ttk" with Tcl/Tk 9.0.

* gh-71587: Fix crash in C version of "datetime.datetime.strptime()"
  when called again on the restarted interpreter.

* gh-117983: Defer the "threading" import in "importlib.util" until
  lazy loading is used.

* gh-120157: Remove unused constant
  "concurrent.futures._base._FUTURE_STATES" in "concurrent.futures".
  Patch by Clinton Christian (pygeek).

* gh-120161: "datetime" no longer crashes in certain complex reference
  cycle situations.

* gh-119698: Fix "symtable.Class.get_methods()" and document its
  behaviour. Patch by Bénédikt Tran.

* gh-120121: Add "concurrent.futures.InvalidStateError" to module’s
  "__all__".

* gh-119933: Add the "symtable.SymbolTableType" enumeration to
  represent the possible outputs of the
  "symtable.SymbolTable.get_type" method. Patch by Bénédikt Tran.

* gh-120029: Expose "symtable.Symbol" methods "is_free_class()",
  "is_comp_iter()" and "is_comp_cell()". Patch by Bénédikt Tran.

* gh-120108: Fix calling "copy.deepcopy()" on "ast" trees that have
  been modified to have references to parent nodes. Patch by Jelle
  Zijlstra.

* gh-120056: Add "socket.IP_RECVERR" and "socket.IP_RECVTTL" constants
  (both available since Linux 2.2). And "socket.IP_RECVORIGDSTADDR"
  constant (available since Linux 2.6.29).

* gh-112672: Support building "tkinter" with Tcl 9.0.

* gh-120057: Added the "os.environ.refresh()" method to update
  "os.environ" with changes to the environment made by "os.putenv()",
  by "os.unsetenv()", or made outside Python in the same process.
  Patch by Victor Stinner.

* gh-120029: Expose "symtable.Symbol.is_type_parameter()" in the
  "symtable" module. Patch by Bénédikt Tran.

* gh-119819: Fix regression to allow logging configuration with
  multiprocessing queue types.

* gh-65454: "unittest.mock.Mock.attach_mock()" no longer triggers a
  call to a "PropertyMock" being attached.

* gh-117142: The "ctypes" module may now be imported in all
  subinterpreters, including those that have their own GIL.

* gh-118835: Fix _pyrepl crash when using custom prompt with ANSI
  escape codes.

* gh-81936: "help()" and "showtopic()" methods now respect a
  configured *output* argument to "pydoc.Helper" and not use the pager
  in such cases. Patch by Enrico Tröger.

* gh-117398: The "_datetime" module (C implementation for "datetime")
  now supports being imported in multiple interpreters.

* gh-119824: Print stack entry in "pdb" when and only when user input
  is needed.

* gh-119838: In mixed arithmetic operations with "Fraction" and
  complex, the fraction is now converted to "float" instead of
  "complex".

* gh-119770: Make "termios" "ioctl()" constants positive. Patch by
  Victor Stinner.

* gh-89727: Fix issue with "shutil.rmtree()" where a "RecursionError"
  is raised on deep directory trees.

* gh-119577: The "DeprecationWarning" emitted when testing the truth
  value of an "xml.etree.ElementTree.Element" now describes
  unconditionally returning "True" in a future version rather than
  raising an exception in Python 3.14.

* gh-89727: Partially fix issue with "shutil.rmtree()" where a
  "RecursionError" is raised on deep directory trees. A recursion
  error is no longer raised when "rmtree.avoids_symlink_attacks" is
  false.

* gh-93963: Remove deprecated names from "importlib.abc" as found in
  "importlib.resources.abc".

* gh-119118: Fix performance regression in the "tokenize" module by
  caching the "line" token attribute and calculating the column offset
  more efficiently.

* gh-89727: Fix issue with "os.fwalk()" where a "RecursionError" was
  raised on deep directory trees by adjusting the implementation to be
  iterative instead of recursive.

* gh-119594: If one calls pow(fractions.Fraction, x, module) with
  modulo not None, the error message now says that the types are
  incompatible rather than saying pow only takes 2 arguments. Patch by
  Wim Jeantine-Glenn and Mark Dickinson.

* gh-119588: "zipfile.Path.is_symlink" now assesses if the given path
  is a symlink.

* gh-119562: Remove "ast.Num", "ast.Str", "ast.Bytes",
  "ast.NameConstant" and "ast.Ellipsis". They had all emitted
  deprecation warnings since Python 3.12. Patch by Alex Waygood.

* gh-119555: Catch "SyntaxError" from "compile()" in the runsource()
  method of the InteractiveColoredConsole.  Patch by Sergey B
  Kirpichev.

* gh-118908: Limit exposed globals from internal imports and
  definitions on new REPL startup. Patch by Eugene Triguba and Pablo
  Galindo.

* gh-117865: Improve the import time of the "ast" module by deferring
  the import of "re". Patch by Jelle Zijlstra.

* gh-119127: Positional arguments of "functools.partial()" objects now
  support placeholders via "functools.Placeholder".

* gh-113892: Now, the method "sock_connect" of
  "asyncio.ProactorEventLoop" raises a "ValueError" if given socket is
  not in non-blocking mode, as well as in other loop implementations.

* gh-119506: Fix "io.TextIOWrapper.write()" method breaks internal
  buffer when the method is called again during flushing internal
  buffer.

* gh-69214: Fix "fcntl.ioctl()" *request* parameter: use an "unsigned
  long" instead of an "unsigned int" for the *request* parameter of
  "fcntl.ioctl()" to support requests larger than "UINT_MAX". Patch by
  Victor Stinner.

* gh-119105: "difflib"’s "DIffer.compare()" (and so also "ndiff") can
  no longer be provoked into cubic-time behavior, or into unbounded
  recursion, and should generally be faster in ordinary cases too.
  Results may change in some cases, although that should be rare.
  Correctness of diffs is not affected. Some similar lines far apart
  may be reported as deleting one and adding the other, where before
  they were displayed on adjacent output lines with markup showing the
  intraline differences.

* gh-119443: The interactive REPL no longer runs with "from __future__
  import annotations" enabled. Patch by Jelle Zijlstra.

* gh-119461: Add "socket.VMADDR_CID_LOCAL" constant. Patch by Victor
  Stinner.

* gh-117398: Objects in the datetime C-API are now all statically
  allocated, which means better memory safety, especially when the
  module is reloaded. This should be transparent to users.

* gh-118894: "asyncio" REPL now has the same capabilities as PyREPL.

* gh-118830: Bump "pickle" default protocol to "5".

* gh-118911: In PyREPL, updated "maybe-accept"’s logic so that if the
  user hits "Enter" twice, they are able to terminate the block even
  if there’s trailing whitespace. Also, now when the user hits arrow
  up, the cursor is on the last functional line. This matches
  IPython’s behavior. Patch by Aya Elsayed.

* gh-115225: Raise error on certain technically valid but pathological
  ISO 8601 strings passed to "datetime.time.fromisoformat()" that were
  previously parsed incorrectly.

* gh-111201: Remove dependency to "readline" from the new Python REPL.

* gh-119189: When using the "**" operator or "pow()" with "Fraction"
  as the base and an exponent that is not rational, a float, or a
  complex, the fraction is no longer converted to a float.

* gh-119174: Fix high DPI causes turtledemo(turtle-graphics examples)
  windows blurry Patch by Wulian233 and Terry Jan Reedy

* gh-119121: Fix a NameError happening in
  "asyncio.staggered.staggered_race". This function is now tested.

* gh-119105: "difflib.Differ" is much faster for some cases of diffs
  where many pairs of lines are equally similar.

* gh-119113: Fix issue where "pathlib.PurePath.with_suffix()" didn’t
  raise "TypeError" when given "None" as a suffix.

* gh-118643: Fix an AttributeError in the "email" module when re-fold
  a long address list. Also fix more cases of incorrect encoding of
  the address separator in the address list.

* gh-73991: Add "pathlib.Path.copy()", which copies a file or
  directory to another.

* gh-58933: Make "pdb" return to caller frame correctly when "f_trace"
  of the caller frame is not set

* gh-82805: Support single-dot file extensions in
  "pathlib.PurePath.suffix" and related attributes and methods. For
  example, the "suffixes" of "PurePath('foo.bar.')" are now "['.bar',
  '.']" rather than "[]". This brings file extension splitting in line
  with "os.path.splitext()".

* gh-118924: Remove "version" and "version_info" from "sqlite3". Patch
  by Hugo van Kemenade.

* gh-118928: Disallow using a sequence of parameters with named
  placeholders in "sqlite3" queries. Patch by Erlend E. Aasland.

* gh-118895: Setting attributes on "typing.NoDefault" now raises
  "AttributeError" instead of "TypeError".

* gh-118868: Fixed issue where kwargs were no longer passed to the
  logging handler QueueHandler

* gh-118827: Remove deprecated "Quoter" class from "urllib.parse". It
  had previously raised a "DeprecationWarning" since Python 3.11.
  Patch by Nikita Sobolev.

* gh-118824: Remove deprecated "pty.master_open()" and
  "pty.slave_open()". Use "pty.openpty()" instead. Patch by Nikita
  Sobolev.

* gh-118851: "ctx" arguments to the constructors of "ast" node classes
  now default to "ast.Load()". Patch by Jelle Zijlstra.

* gh-101588: Remove copy, deepcopy, and pickle from itertools. These
  had previously raised a DeprecationWarning since Python 3.12.

* gh-118805: Remove *type*, *choices*, and *metavar* parameters of
  "argparse.BooleanOptionalAction". They were deprecated since Python
  3.12.

* gh-118803: "typing.ByteString" and "collections.abc.ByteString" are
  removed. They had previously raised a "DeprecationWarning" since
  Python 3.12.

* gh-118798: The *isdst* parameter has been removed from
  "email.utils.localtime()". Patch by Hugo van Kemenade.

* gh-118760: Restore the default value of "tkiter.wantobjects" to "1".

* gh-118760: Fix errors in calling Tkinter bindings on Windows.

* gh-74033: Drop support for passing keyword arguments to
  "pathlib.Path".

* gh-101357: Suppress all "OSError" exceptions from
  "pathlib.Path.exists()" and "is_*()" methods, rather than a
  selection of more common errors. The new behaviour is consistent
  with "os.path.exists()", "os.path.isdir()", etc. Use
  "pathlib.Path.stat()" to retrieve the file status without
  suppressing exceptions.

* gh-78707: Drop support for passing additional positional arguments
  to "pathlib.PurePath.relative_to()" and "is_relative_to()".

* gh-118507: Fix "os.path.isfile()" on Windows for pipes. Speedup
  "os.path.isjunction()" and "os.path.lexists()" on Windows with a
  native implementation.

* gh-118772: Allow "typing.TypeVar" instances without a default to
  follow instances without a default in some cases. Patch by Jelle
  Zijlstra.

* gh-118714: Allow "restart" in post-mortem debugging of "pdb".
  Removed restart message when the user quits pdb from post-mortem
  mode.

* gh-118673: Removed executable bits and shebang from stdlib modules.

* gh-110863: "os.path.realpath()" now suppresses any "OSError" from
  "os.readlink()" when *strict* mode is disabled (the default).

* gh-118263: Speed up "os.path.splitroot()" & "os.path.normpath()"
  with a direct C call.

* gh-110190: Fix ctypes structs with array on SPARC by setting
  "MAX_STRUCT_SIZE" to 32 in stgdict. Patch by Jakub Kulik

* gh-118033: Fix "dataclasses.dataclass()" not creating a
  "__weakref__" slot when subclassing "typing.Generic".

* gh-117766: Always use "str()" to print "choices" in "argparse".

* gh-106531: In "importlib.resources", sync with importlib_resources
  6.3.2, including: "MultiplexedPath" now expects "Traversable" paths,
  deprecating string arguments to "MultiplexedPath"; Enabled support
  for resources in namespace packages in zip files; Fixed
  "NotADirectoryError" when calling files on a subdirectory of a
  namespace package.

* gh-115937: Removed extra preprocessing for the "__signature__"
  attribute: the code just check if it’s a "inspect.Signature"
  instance.  Patch by Sergey B Kirpichev.

* gh-115808: Add "operator.is_none()" and "operator.is_not_none()"
  functions.

* gh-114264: Improve performance of "copy.deepcopy()" by adding a fast
  path for atomic types.

* gh-113878: Add *doc* parameter to "dataclasses.field()", so it can
  be stored and shown as a documentation / metadata. If
  "@dataclass(slots=True)" is used, then the supplied string is
  available in the "__slots__" dict. Otherwise, the supplied string is
  only available in the corresponding "dataclasses.Field" object.

  In order to support this feature we are changing the "__slots__"
  format in dataclasses from "tuple" to "dict" when documentation /
  metadata is present.

* gh-113978: Ignore warnings on text completion inside REPL.

* gh-113008: Correct argparse usage output for required, mutually
  exclusive groups containing a positional argument

* gh-108172: "webbrowser" honors OS preferred browser on Linux when
  its desktop entry name contains the text of a known browser name.

* gh-109109: You can now get the raw TLS certificate chains from TLS
  connections via "ssl.SSLSocket.get_verified_chain()" and
  "ssl.SSLSocket.get_unverified_chain()" methods.

  Contributed by Mateusz Nowak.

* gh-105623: Fix performance degradation in
  "logging.handlers.RotatingFileHandler". Patch by Craig Robson.

* gh-102450: Add missing ISO-8601 24:00 alternative to midnight of
  next day to "datetime.datetime.fromisoformat()" and
  "datetime.time.fromisoformat()". Patch by Izan “TizzySaurus”
  Robinson (tizzysaurus@gmail.com)

* gh-103956: Fix lack of newline characters in "trace" module output
  when line tracing is enabled but source code line for current frame
  is not available.

* gh-92081: Fix missing spaces in email headers when the spaces are
  mixed with encoded 8-bit characters.

* gh-103194: Prepare Tkinter for C API changes in Tcl 8.7/9.0 to avoid
  "_tkinter.Tcl_Obj" being unexpectedly returned instead of "bool",
  "str", "bytearray", or "int".

* gh-87106: Fixed handling in "inspect.Signature.bind()" of keyword
  arguments having the same name as positional-only arguments when a
  variadic keyword argument (e.g. "**kwargs") is present.

* gh-103134: Add additional methods to proxy objects in the
  "multiprocessing" module:

  * "clear()" and "copy()" for proxies of "list"

  * "fromkeys()", "reversed(d)", "d | {}", "{} | d", "d |= {'b': 2}"
    for proxies of "dict"

* bpo-45767: Fix integer conversion in "os.major()", "os.minor()", and
  "os.makedev()". Support device numbers larger than "2**63-1".
  Support non-existent device number ("NODEV").

* bpo-44864: Do not translate user-provided strings in
  "argparse.ArgumentParser".

* bpo-41843: Solaris now uses "os.sendfile()" fast-copy syscall for
  more efficient "shutil" file copy related functions.

* bpo-15987: Implemented "ast.compare()" for comparing two ASTs. Patch
  by Batuhan Taskaya with some help from Jeremy Hylton.

* gh-67693: Fix "urllib.parse.urlunparse()" and
  "urllib.parse.urlunsplit()" for URIs with path starting with
  multiple slashes and no authority. Based on patch by Ashwin
  Ramaswami.

* bpo-14074: Fix "argparse" metavar processing to allow positional
  arguments to have a tuple metavar.


IDLE
----

* gh-122392: Increase currently inadequate vertical spacing for the
  IDLE browsers (path, module, and stack) on high-resolution monitors.

* gh-112938: Fix uninteruptable hang when Shell gets rapid continuous
  output.

* gh-122482: Change About IDLE to direct users to discuss.python.org
  instead of the now unused idle-dev email and mailing list.

* gh-78889: Stop Shell freezes by blocking user access to non-method
  sys.stdout.shell attributes, which are all private.

* gh-120083: Add explicit black IDLE Hovertip foreground color needed
  for recent macOS. Fixes Sonoma showing unreadable white on pale
  yellow.  Patch by John Riggles.

* gh-120104: Fix padding in config and search dialog windows in IDLE.


Documentation
-------------

* gh-124872: Added definitions for *context*, *current context*, and
  *context management protocol*, updated related definitions to be
  consistent, and expanded the documentation for
  "contextvars.Context".

* gh-125018: The "importlib.metadata" documentation now includes
  semantic cross-reference targets for the significant documented
  APIs. This means intersphinx references like
  "importlib.metadata.version()" will now work as expected.

* gh-124720: Update “Using Python on a Mac” section of the “Python
  Setup and Usage” document and include information on installing
  free-threading support.

* gh-124457: Remove coverity scan from the CPython repo. It has not
  been used since 2020 and is currently unmaintained.

* gh-116622: Add an Android platform guide, and flag modules not
  available on Android.

* gh-123976: Refresh docs around custom providers.

* gh-70870: Clarified the dual usage of the term “free variable” (both
  the formal meaning of any reference to names defined outside the
  local scope, and the narrower pragmatic meaning of nonlocal
  variables named in "co_freevars").

* gh-121277: Writers of CPython’s documentation can now use "next" as
  the version for the "versionchanged", "versionadded", "deprecated"
  directives.

* gh-117765: Improved documentation for "unittest.mock.patch.dict()"

* gh-121749: Fix documentation for "PyModule_AddObjectRef()".

* gh-120012: Clarify the behaviours of "multiprocessing.Queue.empty()"
  and "multiprocessing.SimpleQueue.empty()" on closed queues. Patch by
  Bénédikt Tran.

* gh-119574: Added some missing environment variables to the output of
  "--help-env".

* bpo-34008: The "Py_Main()" documentation moved from the “Very High
  Level API” section to the “Initialization and Finalization” section.

  Also make it explicit that we expect "Py_Main" to typically be
  called instead of "Py_Initialize" rather than after it (since
  "Py_Main" makes its own call to "Py_Initialize"). Document that
  calling both is supported but is version dependent on which settings
  will be applied correctly.


Core and Builtins
-----------------

* gh-124375: Fix a crash in the free threading build when the GC runs
  concurrently with a new thread starting.

* gh-125221: Fix possible race condition when calling
  "__reduce_ex__()" for the first time in the free threading build.

* gh-125174: Make the handling of reference counts of immortal objects
  more robust. Immortal objects with reference counts that deviate
  from their original reference count by up to a billion (half a
  billion on 32 bit builds) are still counted as immortal.

* gh-125039: Make "this_instr" and "prev_instr" const in cases
  generator.

* gh-125008: Fix "tokenize.untokenize()" producing invalid syntax for
  double braces preceded by certain escape characters.

* gh-124871: Fix compiler bug (in some versions of 3.13) where an
  assertion fails during reachability analysis.

* gh-123378: Fix a crash in the "__str__()" method of "UnicodeError"
  objects when the "UnicodeError.start" and "UnicodeError.end" values
  are invalid or out-of-range. Patch by Bénédikt Tran.

* gh-118093: Improve the experimental JIT compiler’s ability to stay
  “on trace” when encountering highly-biased branches.

* gh-124642: Fixed scalability issue in free-threaded builds for lock-
  free reads from dictionaries in multi-threaded scenarios

* gh-116510: Fix a crash caused by immortal interned strings being
  shared between sub-interpreters that use basic single-phase init.
  In that case, the string can be used by an interpreter that outlives
  the interpreter that created and interned it.  For interpreters that
  share obmalloc state, also share the interned dict with the main
  interpreter.

* gh-116510: Fix a bug that can cause a crash when sub-interpreters
  use “basic” single-phase extension modules.  Shared objects could
  refer to PyGC_Head nodes that had been freed as part of interpreter
  cleanup.

* gh-119180: The "__main__" module no longer always contains an
  "__annotations__" dictionary in its global namespace.

* gh-124547: When deallocating an object with inline values whose
  "__dict__" is still live: if memory allocation for the inline values
  fails, clear the dictionary. Prevents an interpreter crash.

* gh-124513: Fix a crash in FrameLocalsProxy constructor: check the
  number of arguments. Patch by Victor Stinner.

* gh-124442: Fix nondeterminism in compilation by sorting the value of
  "__static_attributes__". Patch by kp2pml30.

* gh-124285: Fix bug where "bool(a)" can be invoked more than once
  during the evaluation of a compound boolean expression.

* gh-123856: Fix PyREPL failure when a keyboard interrupt is triggered
  after using a history search

* gh-65961: Deprecate the setting and using "__package__" and
  "__cached__".

* gh-119726: The JIT now generates more efficient code for calls to C
  functions resulting in up to 0.8% memory savings and 1.5% speed
  improvement on AArch64. Patch by Diego Russo.

* gh-122878: Use the "pager" binary, if available (e.g. on Debian and
  derivatives), to display REPL "help()".

* gh-124188: Fix reading and decoding a line from the source file with
  non-UTF-8 encoding for syntax errors raised in the compiler.

* gh-124027: Support "<page up>", "<page down>", and "<delete>" keys
  in the Python REPL when "$TERM" is set to "vt100".

* gh-124022: Fix bug where docstring is removed from classes in
  interactive mode.

* gh-123958: docstrings are now removed from the optimized AST in
  optimization level 2.

* gh-123923: The "f_executable" field in the internal
  "_PyInterpreterFrame" struct now uses a tagged pointer. Profilers
  and debuggers that uses this field should clear the least
  significant bit to recover the PyObject* pointer.

* gh-77894: Fix possible crash in the garbage collector when it tries
  to break a reference loop containing a "memoryview" object. Now a
  "memoryview" object can only be cleared if there are no buffers that
  refer it.

* gh-120221: asyncio REPL is now again properly recognizing
  KeyboardInterrupts. Display of exceptions raised in secondary
  threads is fixed.

* gh-119310: Allow the new interactive shell to read history files
  written with the editline library that use unicode-escaped entries.
  Patch by aorcajo and Łukasz Langa.

* gh-123572: Fix key mappings for various F-keys in Windows for the
  new REPL. Patch by devdanzin

* gh-123614: Add "turtle.save()" to easily save Turtle drawings as
  PostScript files. Patch by Marie Roald and Yngve Mardal Moe.

* gh-123339: Setting the "__module__" attribute for a class now
  removes the "__firstlineno__" item from the type’s dict, so they
  will no longer be inconsistent.

* gh-119034: Change "<page up>" and "<page down>" keys of the Python
  REPL to history search forward/backward. Patch by Victor Stinner.

* gh-123562: Improve "SyntaxError" message for using "case ... as ..."
  with not a name.

* gh-123545: Fix a double decref in rare cases on experimental JIT
  builds.

* gh-123484: Fix "_Py_DebugOffsets" for long objects to be relative to
  the start of the object rather than the start of a subobject.

* gh-123446: Fix empty function name in "TypeError" when builtin magic
  methods are used without the required args.

* gh-123440: Improve "SyntaxError" message for using "except as" with
  not a name.

* gh-116017: Improved JIT memory consumption by periodically freeing
  memory used by infrequently-executed code. This change is especially
  likely to improve the memory footprint of long-running programs.

* gh-123344: Add AST optimizations for type parameter defaults.

* gh-123321: Prevent Parser/myreadline race condition from segfaulting
  on multi-threaded use. Patch by Bar Harel and Amit Wienner.

* gh-123177: Fix a bug causing stray prompts to appear in the middle
  of wrapped lines in the new REPL.

* gh-122982: Extend the deprecation period for bool inversion ("~") by
  two years.

* gh-123271: Make concurrent iterations over the same "zip()" iterator
  safe under free-threading.

* gh-123275: Support "-X gil=1" and "PYTHON_GIL=1" on non-free-
  threaded builds.

* gh-123177: Deactivate line wrap in the Apple Terminal via a ANSI
  escape code. Patch by Pablo Galindo

* gh-123229: Fix valgrind warning by initializing the f-string buffers
  to 0 in the tokenizer. Patch by Pablo Galindo

* gh-122298: Restore printout of GC stats when
  "gc.set_debug(gc.DEBUG_STATS)" is called. This feature was
  accidentally removed when implementing incremental GC.

* gh-121804: Correctly show error locations when a "SyntaxError" is
  raised in the basic REPL. Patch by Sergey B Kirpichev.

* gh-115776: Enables inline values (Python’s equivalent of hidden
  classes) on any class who’s instances are of a fixed size.

* gh-123142: Fix too-wide source location in exception tracebacks
  coming from broken iterables in comprehensions.

* gh-123048: Fix a bug where pattern matching code could emit a
  "JUMP_FORWARD" with no source location.

* gh-118093: Break up "CALL_ALLOC_AND_ENTER_INIT" into micro-ops and
  relax requirement for exact args, in order to increase the amount of
  code supported by tier 2.

* gh-123123: Fix displaying "SyntaxError" exceptions covering multiple
  lines. Patch by Pablo Galindo

* gh-123083: Fix a potential use-after-free in "STORE_ATTR_WITH_HINT".

* gh-123022: Fix crash in free-threaded build when calling
  "Py_Initialize()" from a non-main thread.

* gh-118093: Add three specializations for "CALL_KW":

  * "CALL_KW_PY" for calls to Python functions

  * "CALL_KW_BOUND_METHOD" for calls to bound methods

  * "CALL_KW_NON_PY" for all other calls

* gh-122821: Make sure that branches in "while" statements have
  consistent offsets for "sys.monitoring". "while" statements are now
  compiled with a simple jump at the end of the body, instead of
  duplicating the test.

* gh-122907: Building with "HAVE_DYNAMIC_LOADING" now works as well as
  it did in 3.12. Existing deficiences will be addressed separately.
  (See https://github.com/python/cpython/issues/122950.)

* gh-122888: Fix crash on certain calls to "str()" with positional
  arguments of the wrong type. Patch by Jelle Zijlstra.

* gh-118093: Improve the experimental JIT’s handling of polymorphic
  code.

* gh-122697: Fixed memory leaks at interpreter shutdown in the free-
  threaded build, and also reporting of leaked memory blocks via "-X
  showrefcount".

* gh-116622: Fix Android stdout and stderr messages being truncated or
  lost.

* gh-122527: Fix a crash that occurred when a "PyStructSequence" was
  deallocated after its type’s dictionary was cleared by the GC.  The
  type’s "tp_basicsize" now accounts for non-sequence fields that
  aren’t included in the "Py_SIZE" of the sequence.

* gh-122445: Add only fields which are modified via self.* to
  "__static_attributes__".

* gh-122417: In the free-threaded build, the reference counts for heap
  type objects are now partially stored in a distributed manner in
  per-thread arrays.  This reduces contention on the heap type’s
  reference count fields when creating or destroying instances of the
  same type from multiple threads concurrently.

* gh-116090: Fix an issue in JIT builds that prevented some "for"
  loops from correctly firing "RAISE" monitoring events.

* gh-122300: Preserve AST nodes for f-string with single-element
  format specifiers. Patch by Pablo Galindo

* gh-120906: "frame.f_locals" now supports arbitrary hashable objects
  as keys.

* gh-122239: When a "list", "tuple" or "dict" with too many elements
  is unpacked, show the actual length in the error message.

* gh-122245: Detection of writes to "__debug__" is moved from the
  compiler’s codegen stage to the symtable. This means that these
  errors are now detected even in code that is optimized away before
  codegen (such as assertions with the "-O" command line option).

* gh-122234: Specializations for sums with float and complex inputs in
  "sum()" now always use compensated summation.  Also, for integer
  items in above specializations: "PyLong_AsDouble()" is used, instead
  of "PyLong_AsLongAndOverflow()".  Patch by Sergey B Kirpichev.

* gh-122208: Dictionary watchers now only deliver the
  PyDict_EVENT_ADDED event when the insertion is in a known good state
  to succeed.

* gh-122160: Remove the "BUILD_CONST_KEY_MAP" opcode. Use "BUILD_MAP"
  instead.

* gh-122029: Emit "c_call" events in "sys.setprofile()" when a
  "PyMethodObject" pointing to a "PyCFunction" is called.

* gh-122026: Fix a bug that caused the tokenizer to not correctly
  identify mismatched parentheses inside f-strings in some situations.
  Patch by Pablo Galindo

* gh-99108: Python’s hashlib now unconditionally uses the vendored
  HACL* library for Blake2. Python no longer accepts libb2 as an
  optional dependency for Blake2.

  We refreshed HACL* to the latest version, and now vendor HACL*’s
  128-bit and 256-bit wide vector implementations for Blake2, which
  are used on x86/x64 toolchains when the required CPU features are
  available at runtime.

  HACL*’s 128-bit wide vector implementation of Blake2 can also run on
  ARM NEON and Power8, but lacking evidence of a performance gain,
  these are not enabled (yet).

* gh-121999: The default extraction filter for the "tarfile" module is
  now set to "'data'".

* gh-121860: Fix crash when rematerializing a managed dictionary after
  it was deleted.

* gh-121795: Improve performance of set membership testing,
  "set.remove()" and "set.discard()" when the argument is a set.

* gh-121814: Fixed the SegFault when "PyEval_SetTrace()" is used with
  no Python frame on stack.

* gh-121295: Fix PyREPL console getting into a blocked state after
  interrupting a long paste

* gh-121794: Fix bug in free-threaded Python where a resurrected
  object could lead to a negative ref count assertion failure.

* gh-121657: Improve the "SyntaxError" message if the user tries to
  use "yield from" outside a function.

* gh-121609: Fix pasting of characters containing unicode character
  joiners in the new REPL. Patch by Marta Gomez Macias

* gh-121297: Previously, incorrect usage of "await" or asynchronous
  comprehensions in code removed by the "-O" option was not flagged by
  the Python compiler. Now, such code raises "SyntaxError". Patch by
  Jelle Zijlstra.

* gh-117482: Unexpected slot wrappers are no longer created for
  builtin static types in subinterpreters.

* gh-121562: Optimized performance of hex_from_char by replacing
  switch-case with a lookup table

* gh-121499: Fix a bug affecting how multi-line history was being
  rendered in the new REPL after interacting with the new screen
  cache. Patch by Pablo Galindo

* gh-121497: Fix a bug that was preventing the REPL to correctly
  respect the history when an input hook was set. Patch by Pablo
  Galindo

* gh-121012: Tier 2 execution now ensures that list iterators remain
  exhausted, once they become exhausted.

* gh-121439: Allow tuples of length 20 in the freelist to be reused.

* gh-121288: "ValueError" messages for "list.index()",
  "range.index()", "deque.index()", "deque.remove()" and
  "ShareableList.index()" no longer contain the repr of the searched
  value (which can be arbitrary large) and are consistent with error
  messages for other "index()" and "remove()" methods.

* gh-121368: Fix race condition in "_PyType_Lookup" in the free-
  threaded build due to a missing memory fence.  This could lead to
  "_PyType_Lookup" returning incorrect results on arm64.

* gh-121149: Added specialization for summation of complexes, this
  also improves accuracy of builtin "sum()" for such inputs.  Patch by
  Sergey B Kirpichev.

* gh-121130: Fix f-strings with debug expressions in format
  specifiers. Patch by Pablo Galindo

* gh-121381: Remove "subprocess._USE_VFORK" escape hatch code and
  documentation. It was added just in case, and doesn’t have any known
  cases that require it.

* gh-119726: Optimize code layout for calls to C functions from the
  JIT on AArch64. Patch by Diego Russo.

* gh-121115: "PyLong_AsNativeBytes()" no longer uses "__index__()"
  methods by default. The "Py_ASNATIVEBYTES_ALLOW_INDEX" flag has been
  added to allow it.

* gh-120838: "Py_Finalize()" and "Py_FinalizeEx()" now always run with
  the main interpreter active.

* gh-113433: Subinterpreters now get cleaned up automatically during
  runtime finalization.

* gh-119726: Improve the speed and memory use of C function calls from
  JIT code on AArch64. Patch by Diego Russo

* gh-116017: Simplify the warmup mechanism used for “side exits” in
  JIT code, resulting in slightly better performance and slightly
  lower memory usage for most platforms.

* gh-98442: Fix too wide source locations of the cleanup instructions
  of a with statement.

* gh-120754: Reduce the number of system calls invoked when reading a
  whole file (ex. "open('a.txt').read()"). For a sample program that
  reads the contents of the 400+ ".rst" files in the cpython
  repository "Doc" folder, there is an over 10% reduction in system
  call count.

* gh-119462: Make sure that invariants of type versioning are
  maintained: * Superclasses always have their version number assigned
  before subclasses * The version tag is always zero if the tag is not
  valid. * The version tag is always non-if the tag is valid.

* gh-120437: Fix "_CHECK_STACK_SPACE" optimization problems introduced
  in gh-118322.

* gh-120722: Correctly set the bytecode position on return
  instructions within lambdas. Patch by Jelle Zijlstra.

* gh-120367: Fix bug where compiler creates a redundant jump during
  pseudo-op replacement. Can only happen with a synthetic AST that has
  a try on the same line as the instruction following the exception
  handler.

* gh-120507: Remove the "BEFORE_WITH" and "BEFORE_ASYNC_WITH"
  instructions. Add the new "LOAD_SPECIAL" instruction. Generate code
  for "with" and "async with" statements using the new instruction.

* gh-113993: Strings interned with "sys.intern()" are again garbage-
  collected when no longer used, as per the documentation. Strings
  interned with the C function "PyUnicode_InternInPlace()" are still
  immortal. Internals of the string interning mechanism have been
  changed. This may affect performance and identities of "str"
  objects.

* gh-120485: Add an override of "allow_reuse_port" on classes
  subclassing "socketserver.TCPServer" where "allow_reuse_address" is
  also overridden.

* gh-120384: Fix an array out of bounds crash in "list_ass_subscript",
  which could be invoked via some specifically tailored input:
  including concurrent modification of a list object, where one thread
  assigns a slice and another clears it.

* gh-120367: Fix crash in compiler on code with redundant NOPs and
  JUMPs which show up after exception handlers are moved to the end of
  the code.

* gh-120380: Fix Python implementation of "pickle.Pickler" for "bytes"
  and "bytearray" objects when using protocol version 5. Patch by
  Bénédikt Tran.

* gh-120397: Improve the throughput by up to two times for the
  "str.count()", "bytes.count()" and "bytearray.count()" methods for
  counting single characters.

* gh-120221: Deliver real signals on Ctrl-C and Ctrl-Z in the new
  REPL. Patch by Pablo Galindo

* gh-120346: Respect "PYTHON_BASIC_REPL" when running in interactive
  inspect mode ("python -i"). Patch by Pablo Galindo

* gh-93691: Fix source locations of instructions generated for the
  iterator of a for statement.

* gh-120198: Fix a crash when multiple threads read and write to the
  same "__class__" of an object concurrently.

* gh-120298: Fix use-after free in "list_richcompare_impl" which can
  be invoked via some specifically tailored evil input.

* gh-119666: Fix a compiler crash in the case where two comprehensions
  in class scope both reference "__class__".

* gh-119726: JIT: Re-use trampolines on AArch64 when creating
  stencils. Patch by Diego Russo

* gh-120225: Fix crash in compiler on empty block at end of exception
  handler.

* gh-93691: Fix source locations of instructions generated for with
  statements.

* gh-120097: "FrameLocalsProxy" now subclasses
  "collections.abc.Mapping" and can be matched as a mapping in "match"
  statements

* gh-120080: Direct call to the "int.__round__()" now accepts "None"
  as a valid argument.

* gh-119933: Improve "SyntaxError" messages for invalid expressions in
  a type parameters bound, a type parameter constraint tuple or a
  default type parameter. Patch by Bénédikt Tran.

* gh-119724: Reverted improvements to error messages for "elif"/"else"
  statements not matching any valid statements, which made in hard to
  locate the syntax errors inside those "elif"/"else" blocks.

* gh-119879: String search is now slightly faster for certain cases.
  It now utilizes last character gap (good suffix rule) for two-way
  periodic needles.

* gh-119842: Honor "PyOS_InputHook()" in the new REPL. Patch by Pablo
  Galindo

* gh-119180: "classmethod()" and "staticmethod()" now wrap the
  "__annotations__" and "__annotate__" attributes of their underlying
  callable lazily. See **PEP 649**. Patch by Jelle Zijlstra.

* gh-119821: Fix execution of annotation scopes within classes when
  "globals" is set to a non-dict. Patch by Jelle Zijlstra.

* gh-118934: Make "PyEval_GetLocals" return borrowed reference

* gh-119740: Remove the previously-deprecated delegation of "int()" to
  "__trunc__()".

* gh-119689: Generate stack effect metadata for pseudo instructions
  from bytecodes.c.

* gh-109218: "complex()" accepts now a string only as a positional
  argument. Passing a complex number as the “real” or “imag” argument
  is deprecated; it should only be passed as a single positional
  argument.

* gh-119548: Add a "clear" command to the REPL. Patch by Pablo Galindo

* gh-111999: Fix the signature of "str.format_map()".

* gh-119560: An invalid assert in beta 1 has been removed.  The assert
  would fail if "PyState_FindModule()" was used in an extension
  module’s init function before the module def had been initialized.

* gh-119369: Fix deadlock during thread deletion in free-threaded
  build, which could occur when the GIL was enabled at runtime.

* gh-119525: Fix deadlock involving "_PyType_Lookup()" cache in the
  free-threaded build when the GIL is dynamically enabled at runtime.

* gh-119258: Eliminate type version guards in the tier two
  interpreter.

  Note that setting the "tp_version_tag" manually (which has never
  been supported) may result in crashes.

* gh-119311: Fix bug where names are unexpectedly mangled in the bases
  of generic classes.

* gh-119395: Fix bug where names appearing after a generic class are
  mangled as if they are in the generic class.

* gh-119372: Correct invalid corner cases in complex division
  (resulted in "(nan+nanj)" output), e.g.  "1/complex('(inf+infj)')".
  Patch by Sergey B Kirpichev.

* gh-119180: Evaluation of annotations is now deferred. See **PEP
  649** for details.

* gh-119180: Replace "LOAD_ASSERTION_ERROR" opcode with
  "LOAD_COMMON_CONSTANT" and add support for "NotImplementedError".

* gh-119213: Non-builtin modules built with argument clinic were
  crashing if used in a subinterpreter before the main interpreter.
  The objects that were causing the problem by leaking between
  interpreters carelessly have been fixed.

* gh-119011: Fixes "type.__type_params__" to return an empty tuple
  instead of a descriptor.

* gh-118692: Avoid creating unnecessary "StopIteration" instances for
  monitoring.

* gh-119180: Add an "__annotate__" attribute to functions, classes,
  and modules as part of **PEP 649**. Patch by Jelle Zijlstra.

* gh-119049: Fix displaying the source line for warnings created by
  the C API if the "warnings" module had not yet been imported.

* gh-119057: Improve "ZeroDivisionError" error message. Now, all error
  messages are harmonized: all "/", "//", and "%" operations just use
  “division by zero” message. And "0 ** -1" operation uses “zero to a
  negative power”.

* gh-118844: Fix build failures when configuring with both "--disable-
  gil" and "--enable-experimental-jit".

* gh-118921: Add "copy()" method for "FrameLocalsProxy" which returns
  a snapshot "dict" for local variables.

* gh-117657: Fix data races on the field that stores a pointer to the
  interpreter’s main thread that occur in free-threaded builds.

* gh-118750: If the C version of the "decimal" module is available,
  "int(str)" now uses it to supply an asymptotically much faster
  conversion. However, this only applies if the string contains over
  about 2 million digits.

* gh-118767: Using "NotImplemented" in a boolean context now raises
  "TypeError". Contributed by Jelle Zijlstra.

* gh-118561: Fix race condition in free-threaded build where
  "list.extend()" could expose uninitialised memory to concurrent
  readers.

* gh-117139: Convert the Python evaluation stack to use internal stack
  references. The purpose is to support tagged pointers. In **PEP
  703**, this will allow for its form of deferred reference counting.
  For both the default and free-threaded builds, this sets up the
  infrastructure for unboxed integers in the future.

* gh-115801: Raise "TypeError" when passing a string to
  "difflib.unified_diff()" and "difflib.context_diff()".

* gh-117558: Improve error messages when a string, bytes or bytearray
  object of length 1 is expected.

* gh-117195: Avoid assertion failure for debug builds when calling
  "object.__sizeof__(1)"

* gh-116022: Improve the "__repr__()" output of "AST" nodes.

* gh-114091: Changed the error message for awaiting something that
  can’t be awaited from “object <type> can’t be used in an await
  expression” to “’<type>’ object can’t be awaited”.

* gh-113190: "Py_Finalize()" now deletes all interned strings.

* gh-84978: Add class methods "float.from_number()" and
  "complex.from_number()".

* gh-95144: Improve the error message from "a in b" when "b" is not a
  container to mention the term “container”.

* bpo-24766: Fix handling of "doc" argument to subclasses of
  "property".


C API
-----

* gh-123961: Convert the curses.window static type exposed by the
  "PyCursesWindow_Type" macro in "Include/py_curses.h" to a heap type.
  Patch by Bénédikt Tran.

* gh-124502: Add "PyUnicode_Equal()" function to the limited C API:
  test if two strings are equal. Patch by Victor Stinner.

* gh-124296: "PyDictObject" no longer maintains a private version tag
  field "ma_version_tag" per **PEP 699**.  This field was originally
  added in Python 3.6 (**PEP 509**) and deprecated in Python 3.12.

* gh-124160: Fix crash when importing modules containing state and
  single-phase initialization in a subinterpreter.

* gh-124153: Add "PyType_GetBaseByToken()" and "Py_tp_token" slot for
  easier type checking, related to **PEP 489** and **PEP 630**.

* gh-124127: In the limited C API 3.14 and newer, "Py_REFCNT()" is now
  implemented as an opaque function call to hide implementation
  details. Patch by Victor Stinner.

* gh-123880: Fixed a bug that prevented circular imports of extension
  modules that use single-phase initialization.

* gh-123909: "PyType_FromSpec()", "PyType_FromSpecWithBases()" and
  "PyType_FromModuleAndSpec()" will now fail if the metaclass of the
  new type has custom "tp_new".

* gh-107954: Add functions to configure the Python initialization
  (**PEP 741**):

  * "PyInitConfig_Create()"

  * "PyInitConfig_Free()"

  * "PyInitConfig_GetError()"

  * "PyInitConfig_GetExitCode()"

  * "PyInitConfig_HasOption()"

  * "PyInitConfig_GetInt()"

  * "PyInitConfig_GetStr()"

  * "PyInitConfig_GetStrList()"

  * "PyInitConfig_FreeStrList()"

  * "PyInitConfig_SetInt()"

  * "PyInitConfig_SetStr()"

  * "PyInitConfig_SetStrList()"

  * "PyInitConfig_AddModule()"

  * "Py_InitializeFromInitConfig()"

  Patch by Victor Stinner.

* gh-107954: Add functions to get and set the current runtime Python
  configuration:

  * "PyConfig_Get()"

  * "PyConfig_GetInt()"

  * "PyConfig_Set()"

  * "PyConfig_Names()"

  Patch by Victor Stinner.

* gh-123465: "Py_RELATIVE_OFFSET" is now allowed in "PyMemberDef" for
  the special offset member ""__vectorcalloffset__"", as well as the
  discouraged special offset members ""__dictoffset__"" and
  ""__weaklistoffset__""

* gh-100554: Added a slot "Py_tp_vectorcall" to set "tp_vectorcall"
  via the "PyType_FromSpec()" function family. Limited API extensions
  can use this feature to provide more efficient vector call-based
  implementation of "__new__" and "__init__".

* gh-122854: Add "Py_HashBuffer()" to compute and return the hash
  value of a buffer. Patch by Antoine Pitrou and Victor Stinner.

* gh-122728: Fix "PyEval_GetLocals()" to avoid "SystemError" (“bad
  argument to internal function”). Patch by Victor Stinner.

* gh-116622: Make "PyObject_Print" work around a bug in Android and
  OpenBSD which prevented it from throwing an exception when trying to
  write to a read-only stream.

* gh-105201: Add "PyIter_NextItem()" to replace "PyIter_Next()", which
  has an ambiguous return value. Patch by Irit Katriel and Erlend
  Aasland.

* gh-121489: Export private "_PyBytes_Join()" again.

* gh-121645: Add "PyBytes_Join(sep, iterable)" function, similar to
  "sep.join(iterable)" in Python. Patch by Victor Stinner.

* gh-89364: Export the "PySignal_SetWakeupFd()" function. Previously,
  the function was documented but it couldn’t be used in 3rd party
  code. Patch by Victor Stinner.

* gh-113993: "PyUnicode_InternInPlace()" no longer prevents its
  argument from being garbage collected.

  Several functions that take "char *" are now documented as possibly
  preventing string objects from being garbage collected; refer to
  their documentation for details: "PyUnicode_InternFromString()",
  "PyDict_SetItemString()", "PyObject_SetAttrString()",
  "PyObject_DelAttrString()", "PyUnicode_InternFromString()", and
  "PyModule_Add*" convenience functions.

* gh-113601: Removed debug build assertions related to interning
  strings, which were falsely triggered by stable ABI extensions.

* gh-112136: Restore the private "_PyArg_Parser" structure and the
  private "_PyArg_ParseTupleAndKeywordsFast()" function, previously
  removed in Python 3.13 alpha 1. Patch by Victor Stinner.

* gh-120642: Remove the private "_Py_CODEUNIT" type from the public C
  API. The internal "pycore_code.h" header should now be used to get
  this internal type. Patch by Victor Stinner.

* gh-120858: "PyDict_Next()" no longer locks the dictionary in the
  free-threaded build.  The locking needs to be done by the caller
  around the entire iteration loop.

* gh-120642: Remove the following unstable functions:

  * "PyUnstable_Replace_Executor()"

  * "PyUnstable_SetOptimizer()"

  * "PyUnstable_GetOptimizer()"

  * "PyUnstable_GetExecutor()"

  * "PyUnstable_Optimizer_NewCounter()"

  * "PyUnstable_Optimizer_NewUOpOptimizer()"

  Patch by Victor Stinner.

* gh-120389: Add new functions to convert C "<stdint.h>" numbers
  from/to Python "int":

  * "PyLong_FromInt32()"

  * "PyLong_FromUInt32()"

  * "PyLong_FromInt64()"

  * "PyLong_FromUInt64()"

  * "PyLong_AsInt32()"

  * "PyLong_AsUInt32()"

  * "PyLong_AsInt64()"

  * "PyLong_AsUInt64()"

  Patch by Victor Stinner.

* gh-120600: In the limited C API 3.14 and newer, "Py_TYPE()" is now
  implemented as an opaque function call to hide implementation
  details. Patch by Victor Stinner.

* gh-70278: "PyUnicode_FromFormat()" no longer produces the ending
  "\ufffd" character for truncated C string when use precision with
  "%s" and "%V". It now truncates the string before the start of
  truncated multibyte sequences.

* gh-119771: Set "errno" in "_Py_c_pow()" on overflows.  Patch by
  Sergey B Kirpichev.

* gh-119182: Add a new "PyUnicodeWriter" API to create a Python "str"
  object:

  * "PyUnicodeWriter_Create()".

  * "PyUnicodeWriter_Discard()".

  * "PyUnicodeWriter_Finish()".

  * "PyUnicodeWriter_WriteChar()".

  * "PyUnicodeWriter_WriteUTF8()".

  * "PyUnicodeWriter_WriteUCS4()".

  * "PyUnicodeWriter_WriteWideChar()".

  * "PyUnicodeWriter_WriteStr()".

  * "PyUnicodeWriter_WriteRepr()".

  * "PyUnicodeWriter_WriteSubstring()".

  * "PyUnicodeWriter_Format()".

  * "PyUnicodeWriter_DecodeUTF8Stateful()".

  Patch by Victor Stinner.

* gh-119613: Soft deprecate the "Py_MEMCPY" macro: use directly
  "memcpy()" instead.  Patch by Victor Stinner.

* gh-119775: Creating "immutable types" with mutable bases was
  deprecated since 3.12 and now raises a "TypeError".

* gh-119585: Fix crash when a thread state that was created by
  "PyGILState_Ensure()" calls a destructor that during
  "PyThreadState_Clear()" that calls back into "PyGILState_Ensure()"
  and "PyGILState_Release()". This might occur when in the free-
  threaded build or when using thread-local variables whose
  destructors call "PyGILState_Ensure()".

* gh-119613: Macros "Py_IS_NAN", "Py_IS_INFINITY" and "Py_IS_FINITE"
  are *soft deprecated*.

* gh-119336: Restore the removed "_PyLong_NumBits()" function. It is
  used by the pywin32 project. Patch by Ethan Smith

* gh-119344: The critical section API is now public as part of the
  non-limited C API.

* gh-119333: Add "PyContext_AddWatcher()" and
  "PyContext_ClearWatcher()" APIs to register callbacks to receive
  notification on enter and exit of context objects.

* gh-119247: Added "Py_BEGIN_CRITICAL_SECTION_SEQUENCE_FAST" and
  "Py_END_CRITICAL_SECTION_SEQUENCE_FAST" macros to make it possible
  to use PySequence_Fast APIs safely when free-threaded, and update
  str.join to work without the GIL using them.

* gh-111389: Add "PyHASH_MULTIPLIER" constant: prime multiplier used
  in string and various other hashes. Patch by Victor Stinner.

* gh-118771: Several C declarations with names that didn’t start with
  the "Py" or "_Py" prefixes, which were added by mistake in 3.13
  alpha and beta releases, were moved to internal headers.

* gh-116984: Make mimalloc includes relative to the current file to
  avoid embedders or extensions needing to include "Internal/mimalloc"
  if they are already including internal CPython headers.

* gh-118789: Add "PyUnstable_Object_ClearWeakRefsNoCallbacks()", which
  clears weakrefs without calling their callbacks.

* gh-118789: Restore "_PyWeakref_ClearRef" that was previously removed
  in Python 3.13 alpha 1.

* gh-117511: Make the "PyMutex" public in the non-limited C API.

* gh-116560: Add "PyLong_GetSign()" function.  Patch by Sergey B
  Kirpichev.

* gh-97588: Fix creating bitfields in "ctypes" structures and unions.
  Fields no longer overlap.

* gh-87135: Attempting to acquire the GIL after runtime finalization
  has begun in a different thread now causes the thread to hang rather
  than terminate, which avoids potential crashes or memory corruption
  caused by attempting to terminate a thread that is running code not
  specifically designed to support termination. In most cases this
  hanging is harmless since the process will soon exit anyway.

  The "PyThread_exit_thread" function is now deprecated.  Its behavior
  is inconsistent across platforms, and it can only be used safely in
  the unlikely case that every function in the entire call stack has
  been designed to support the platform-dependent termination
  mechanism.  It is recommended that users of this function change
  their design to not require thread termination.  In the unlikely
  case that thread termination is needed and can be done safely, users
  may migrate to calling platform-specific APIs such as "pthread_exit"
  (POSIX) or "_endthreadex" (Windows) directly.

* bpo-34008: Added "Py_IsInitialized" to the list of APIs that are
  safe to call before the interpreter is initialized, and updated the
  embedding tests to cover it.


Build
-----

* gh-125269: Fix detection of whether "-latomic" is needed when cross-
  compiling CPython using the configure script.

* gh-123990: Remove "WITH_FREELISTS" macro and "--without-freelists"
  build configuration

* gh-124102: Update internal documentation under PCbuild, so it now
  correctly states that Windows requires VS2017 or later and Python
  3.10 or later

* gh-124043: Building using "--with-trace-refs" is (temporarily)
  disallowed when the GIL is disabled.

* gh-123418: Updated Android build to use OpenSSL 3.0.15.

* gh-123297: Propagate the value of "LDFLAGS" to "LDCXXSHARED" in
  "sysconfig". Patch by Pablo Galindo

* gh-121634: Allow for specifying the target compile triple for WASI.

* gh-122578: Use WASI SDK 24 for testing.

* gh-116622: Rename build variable "MODULE_LDFLAGS" back to
  "LIBPYTHON", as it’s used by package build systems (e.g. Meson).

* gh-118943: Fix an issue where the experimental JIT could be built
  several times by the "make regen-all" target, leading to possible
  race conditions on heavily parallelized builds.

* gh-121996: Introduce ./configure –disable-safety and –enable-slower-
  safety options. Patch by Donghee Na.

* gh-120522: Added a "--with-app-store-compliance" option to patch out
  known issues with macOS/iOS App Store review processes.

* gh-120371: Support WASI SDK 22 by explicitly skipping functions that
  are just stubs in wasi-libc.

* gh-121731: Fix mimalloc compile error on GNU/Hurd

* gh-121487: Fix deprecation warning for ATOMIC_VAR_INIT in mimalloc.

* gh-121467: Fix a Makefile bug that prevented mimalloc header files
  from being installed.

* gh-121103: On POSIX systems, excluding macOS framework installs, the
  lib directory for the free-threaded build now includes a “t” suffix
  to avoid conflicts with a co-located default build installation.

* gh-120831: The default minimum iOS version was increased to 13.0.

* gh-121082: Fix build failure when the developer use "--enable-
  pystats" arguments in configuration command after #118450.

* gh-120671: Fix failing configure tests due to a missing space when
  appending to CFLAGS.

* gh-120602: Correctly handle LLVM installs with "LLVM_VERSION_SUFFIX"
  when building with "--enable-experimental-jit".

* gh-120688: On WASI in debug mode, Python is now built with compiler
  flag "-O3" instead of "-Og", to support more recursive calls. Patch
  by Victor Stinner.

* gh-118943: Fix a possible race condition affecting parallel builds
  configured with "--enable-experimental-jit", in which
  "FileNotFoundError" could be caused by another process already
  moving "jit_stencils.h.new" to "jit_stencils.h".

* gh-120326: On Windows, fix build error when "--disable-gil" and "--
  experimental-jit" options are combined.

* gh-120291: Make the "python-config" shell script compatible with
  non-bash shells.

* gh-113565: Improve "curses" and "curses.panel" dependency checks in
  **configure**.

* gh-119729: On POSIX systems, the pkg-config (".pc") filenames now
  include the ABI flags, which may include debug (“d”) and free-
  threaded (“t”).  For example: * "python-3.14.pc" (default, non-debug
  build) * "python-3.14d.pc" (default, debug build) *
  "python-3.14t.pc" (free-threaded build)

* gh-119400: "make_ssl_certs", the script that prepares certificate
  data for the test suite, now allows specifying expiration dates.

* gh-115119: Fall back to the bundled libmpdec if a system version
  cannot be found.

* gh-119132: Update "sys.version" to identify whether the build is
  default build or free-threading build. Patch By Donghee Na.

* gh-118836: Fix an "AssertionError" when building with "--enable-
  experimental-jit" and the compiler emits a "SHT_NOTE" section.

* gh-118943: Fix a possible race condition affecting parallel builds
  configured with "--enable-experimental-jit", in which compilation
  errors could be caused by an incompletely-generated header file.


Python 3.13.0 beta 1
====================

*Release date: 2024-05-08*


Security
--------

* gh-116741: Update bundled libexpat to 2.6.2

* gh-117233: Detect BLAKE2, SHA3, Shake, & truncated SHA512 support in
  the OpenSSL-ish libcrypto library at build time.  This allows
  "hashlib" to be used with libraries that do not to support every
  algorithm that upstream OpenSSL does.


Core and Builtins
-----------------

* gh-118414: Add instrumented opcodes to YIELD_VALUE assertion for
  tracing cases.

* gh-117953: When a builtin or extension module is imported for the
  first time, while a subinterpreter is active, the module’s init
  function is now run by the main interpreter first before import
  continues in the subinterpreter. Consequently, single-phase init
  modules now fail in an isolated subinterpreter without the init
  function running under that interpreter, whereas before it would run
  under the subinterpreter *before* failing, potentially leaving
  behind global state and callbacks and otherwise leaving the module
  in an inconsistent state.

* gh-117549: Don’t use designated initializer syntax in inline
  functions in internal headers. They cause problems for C++ or MSVC
  users who aren’t yet using the latest C++ standard (C++20). While
  internal, pycore_backoff.h, is included (indirectly, via
  pycore_code.h) by some key 3rd party software that does so for
  speed.

* gh-95382: Improve performance of "json.dumps()" and "json.dump()"
  when using the argument *indent*. Depending on the data the encoding
  using "json.dumps()" with *indent* can be up to 2 to 3 times faster.

* gh-116322: In "--disable-gil" builds, the GIL will be enabled while
  loading C extension modules. If the module indicates that it
  supports running without the GIL, the GIL will be disabled once
  loading is complete. Otherwise, the GIL will remain enabled for the
  remainder of the interpreter’s lifetime. This behavior does not
  apply if the GIL has been explicitly enabled or disabled with
  "PYTHON_GIL" or "-Xgil".

* gh-118513: Fix incorrect "UnboundLocalError" when two comprehensions
  in the same function both reference the same name, and in one
  comprehension the name is bound while in the other it’s an implicit
  global.

* gh-118518: Allow the Linux perf support to work without frame
  pointers using perf’s advanced JIT support. The feature is activated
  when using the "PYTHON_PERF_JIT_SUPPORT" environment variable or
  when running Python with "-Xperf_jit". Patch by Pablo Galindo.

* gh-117514: Add "sys._is_gil_enabled()" function that returns whether
  the GIL is currently enabled.  In the default build it always
  returns "True" because the GIL is always enabled.  In the free-
  threaded build, it may return "True" or "False".

* gh-118164: Break a loop between the Python implementation of the
  "decimal" module and the Python code for integer to string
  conversion. Also optimize integer to string conversion for values in
  the range from 9_000 to 135_000 decimal digits.

* gh-118473: Fix "sys.set_asyncgen_hooks()" not to be partially set
  when raising "TypeError".

* gh-118465: Compiler populates the new "__firstlineno__" field on a
  class with the line number of the first line of the class
  definition.

* gh-118492: Fix an issue where the type cache can expose a previously
  accessed attribute when a finalizer is run.

* gh-117714: update "async_generator.athrow().close()" and
  "async_generator.asend().close()" to close their section of the
  underlying async generator

* gh-111201: The *interactive* interpreter is now implemented in
  Python, which allows for a number of new features like colors,
  multiline input, history viewing, and paste mode. Contributed by
  Pablo Galindo, Łukasz Langa and Lysandros Nikolaou based on code
  from the PyPy project.

* gh-74929: Implement PEP 667: converted "FrameType.f_locals" and
  "PyFrame_GetLocals()" to return a write-through proxy object when
  the frame refers to a function or comprehension.

* gh-116767: Fix crash in compiler on ‘async with’ that has many
  context managers.

* gh-118335: Change how to use the tier 2 interpreter. Instead of
  running Python with "-X uops" or setting the environment variable
  "PYTHON_UOPS=1", this choice is now made at build time by
  configuring with "--enable-experimental-jit=interpreter".

  **Beware!** This changes the environment variable to enable or
  disable micro-ops to "PYTHON_JIT". The old "PYTHON_UOPS" is no
  longer used.

* gh-118306: Update JIT compilation to use LLVM 18

* gh-118160: Annotation scopes within classes can now contain
  comprehensions. However, such comprehensions are not inlined into
  their parent scope at runtime. Patch by Jelle Zijlstra.

* gh-118272: Fix bug where "generator.close" does not free the
  generator frame’s locals.

* gh-118216: Don’t consider "__future__" imports with dots before the
  module name.

* gh-118074: Make sure that the Executor objects in the COLD_EXITS
  array aren’t assumed to be GC-able (which would access bytes outside
  the object).

* gh-107674: Lazy load frame line number to improve performance of
  tracing

* gh-118082: Improve "SyntaxError" message for imports without names,
  like in "from x import" and "import" cases. It now points out to
  users that "import" expects at least one name after it.

* gh-118090: Improve "SyntaxError" message for empty type param
  brackets.

* gh-117958: Added a "get_jit_code()" method to access JIT compiled
  machine code from the UOp Executor when the experimental JIT is
  enabled. Patch by Anthony Shaw.

* gh-117901: Add option for compiler’s codegen to save nested
  instruction sequences for introspection.

* gh-116622: Redirect stdout and stderr to system log when embedded in
  an Android app.

* gh-109118: annotation scope within class scopes can now contain
  lambdas.

* gh-117894: Prevent "agen.aclose()" objects being re-used after
  ".throw()".

* gh-117881: prevent concurrent access to an async generator via
  athrow().throw() or asend().throw()

* gh-117536: Fix a "RuntimeWarning" when calling
  "agen.aclose().throw(Exception)".

* gh-117755: Fix mimalloc allocator for huge memory allocation (around
  8,589,934,592 GiB) on s390x. Patch by Victor Stinner.

* gh-117750: Fix issue where an object’s dict would get out of sync
  with the object’s internal values when being cleared.
  "obj.__dict__.clear()" now clears the internal values, but leaves
  the dict attached to the object.

* gh-117431: Improve the performance of the following "bytes" and
  "bytearray" methods by adapting them to the "METH_FASTCALL" calling
  convention:

  * "count()"

  * "find()"

  * "index()"

  * "rfind()"

  * "rindex()"

* gh-117709: Speed up calls to "str()" with positional-only argument,
  by using the **PEP 590** "vectorcall" calling convention. Patch by
  Erlend Aasland.

* gh-117680: Give "_PyInstructionSequence" a Python interface and use
  it in tests.

* gh-115776: Statically allocated objects are, by definition, immortal
  so must be marked as such regardless of whether they are in
  extension modules or not.

* gh-117385: Remove unhandled "PY_MONITORING_EVENT_BRANCH" and
  "PY_MONITORING_EVENT_EXCEPTION_HANDLED" events from
  "sys.settrace()".

* gh-116322: Extension modules may indicate to the runtime that they
  can run without the GIL. Multi-phase init modules do so by calling
  providing "Py_MOD_GIL_NOT_USED" for the "Py_mod_gil" slot, while
  single-phase init modules call "PyUnstable_Module_SetGIL(mod,
  Py_MOD_GIL_NOT_USED)" from their init function.

* gh-116129: Implement **PEP 696**, adding support for defaults on
  type parameters. Patch by Jelle Zijlstra.

* gh-93502: Add two new functions to the C-API,
  "PyRefTracer_SetTracer()" and "PyRefTracer_GetTracer()", that allows
  to track object creation and destruction the same way the
  "tracemalloc" module does. Patch by Pablo Galindo

* gh-107674: Improved the performance of "sys.settrace()"
  significantly

* gh-95754: Improve the error message when a script shadowing a module
  from the standard library causes "AttributeError" to be raised.
  Similarly, improve the error message when a script shadowing a third
  party module attempts to access an attribute from that third party
  module while still initialising.

* gh-99180: Elide uninformative traceback indicators in "return" and
  simple "assignment" statements. Patch by Pablo Galindo.

* gh-105879: Allow the *globals* and *locals* arguments to "exec()"
  and "eval()" to be passed as keywords.


Library
-------

* gh-118418: A "DeprecationWarning" is now emitted if you fail to pass
  a value to the new *type_params* parameter of "typing._eval_type()"
  or "typing.ForwardRef._evaluate()". (Using either of these private
  and undocumented functions is discouraged to begin with, but failing
  to pass a value to the "type_params" parameter may lead to incorrect
  behaviour on Python 3.12 or newer.)

* gh-118660: Add an optional second type parameter to
  "typing.ContextManager" and "typing.AsyncContextManager",
  representing the return types of "__exit__()" and "__aexit__()"
  respectively. This parameter defaults to "bool | None".

* gh-118650: The "enum" module allows method named "_repr_*" to be
  defined on "Enum" types.

* gh-118648: Add type parameter defaults to "typing.Generator" and
  "typing.AsyncGenerator".

* gh-101137: Mime type "text/x-rst" is now supported by "mimetypes".

* gh-118164: The Python implementation of the "decimal" module could
  appear to hang in relatively small power cases (like "2**117") if
  context precision was set to a very high value. A different method
  to check for exactly representable results is used now that doesn’t
  rely on computing "10**precision" (which could be effectively too
  large to compute).

* gh-111744: "breakpoint()" and "pdb.set_trace()" now enter the
  debugger immediately after the call rather than before the next line
  is executed.

* gh-118500: Add "pdb" support for zipapps

* gh-118406: Add signature for "sqlite3.Connection" objects.

* gh-101732: Use a Y2038 compatible openssl time function when
  available.

* gh-118404: Fix "inspect.signature()" for non-comparable callables.

* gh-118402: Fix "inspect.signature()" for the result of the
  "functools.cmp_to_key()" call.

* gh-116622: On Android, "sysconfig.get_platform" now returns the
  format specified by **PEP 738**.

* gh-118285: Allow to specify the signature of custom callable
  instances of extension type by the "__text_signature__" attribute.
  Specify signatures of "operator.attrgetter", "operator.itemgetter",
  and "operator.methodcaller" instances.

* gh-118314: Fix an edge case in "binascii.a2b_base64()" strict mode,
  where excessive padding is not detected when no padding is
  necessary.

* gh-118271: Add the "PhotoImage" methods "read()" to read an image
  from a file and "data()" to get the image data. Add *background* and
  *grayscale* parameters to "PhotoImage" method "write()".

* gh-118225: Add the "PhotoImage" method "copy_replace()" to copy a
  region from one image to other image, possibly with pixel zooming
  and/or subsampling. Add *from_coords* parameter to "PhotoImage"
  methods "copy()", "zoom()" and "subsample()". Add *zoom* and
  *subsample* parameters to "PhotoImage" method "copy()".

* gh-118221: Fix a bug where "sqlite3.Connection.iterdump()" could
  fail if a custom "row factory" was used. Patch by Erlend Aasland.

* gh-118013: Fix regression introduced in gh-103193 that meant that
  calling "inspect.getattr_static()" on an instance would cause a
  strong reference to that instance’s class to persist in an internal
  cache in the "inspect" module. This caused unexpected memory
  consumption if the class was dynamically created, the class held
  strong references to other objects which took up a significant
  amount of memory, and the cache contained the sole strong reference
  to the class. The fix for the regression leads to a slowdown in
  "getattr_static()", but the function should still be significantly
  faster than it was in Python 3.11. Patch by Alex Waygood.

* gh-118218: Speed up "itertools.pairwise()" in the common case by up
  to 1.8x.

* gh-117486: Improve the behavior of user-defined subclasses of
  "ast.AST". Such classes will now require no changes in the usual
  case to conform with the behavior changes of the "ast" module in
  Python 3.13. Patch by Jelle Zijlstra.

* gh-90848: Fixed "unittest.mock.create_autospec()" to configure
  parent mock with keyword arguments.

* gh-118168: Fix incorrect argument substitution when "typing.Unpack"
  is used with the builtin "tuple". "typing.Unpack" now raises
  "TypeError" when used with certain invalid types. Patch by Jelle
  Zijlstra.

* gh-118131: Add command-line interface for the "random" module. Patch
  by Hugo van Kemenade.

* gh-118107: Fix "zipimport" reading of ZIP64 files with file entries
  that are too big or offset too far.

* gh-102511: Fix "os.path.normpath()" for UNC paths on Windows. Speed
  up "os.path.splitroot()" with a native implementation.

* gh-117535: Change the unknown filename of "warnings" from "sys" to
  "<sys>" to clarify that it’s not a real filename.

* gh-114053: Fix erroneous "NameError" when calling
  "typing.get_type_hints()" on a class that made use of **PEP 695**
  type parameters in a module that had "from __future__ import
  annotations" at the top of the file. Patch by Alex Waygood.

* gh-116931: Add parameter *fileobj* check for
  "tarfile.TarFile.addfile()"

* gh-117995: Don’t raise "DeprecationWarning" when a *sequence* of
  parameters is used to bind indexed, nameless placeholders. See also
  gh-100668.

* gh-80361: Fix TypeError in "email.message.Message.get_payload()"
  when the charset is **RFC 2231** encoded.

* gh-86650: Fix IndexError when parse some emails with invalid
  Message-ID (including one-off addresses generated by Microsoft
  Outlook).

* gh-117691: Improve the error messages emitted by "tarfile"
  deprecation warnings relating to PEP 706. If a "filter" argument is
  not provided to "extract()" or "extractall", the deprecation warning
  now points to the line in the user’s code where the relevant
  function was called. Patch by Alex Waygood.

* gh-115874: Fixed a possible segfault during garbage collection of
  "_asyncio.FutureIter" objects. Patch by Savannah Ostrowski.

* gh-115060: Speed up "pathlib.Path.glob()" by omitting an initial
  "is_dir()" call. As a result of this change, "glob()" can no longer
  raise "OSError".

* gh-77102: "site" module now parses ".pth" file with UTF-8 first, and
  *locale encoding* if "UnicodeDecodeError" happened. It supported
  only locale encoding before.

* gh-76785: We’ve exposed the low-level "_interpreters" module for the
  sake of the PyPI implementation of **PEP 734**.  It was sometimes
  available as the "_xxsubinterpreters" module and was formerly used
  only for testing. For the most part, it should be considered an
  internal module, like "_thread" and "_imp". See
  https://discuss.python.org/t/pep-734-multiple-interpreters-in-the-
  stdlib/41147/26.

* gh-115060: Speed up "pathlib.Path.glob()" by not scanning
  directories for non-wildcard pattern segments.

* gh-117727: Speed up "pathlib.Path.iterdir()" by using "os.scandir()"
  internally.

* gh-117586: Speed up "pathlib.Path.walk()" by working with strings
  internally.

* gh-117722: Change the new multi-separator support in
  "asyncio.StreamReader.readuntil()" to only accept tuples of
  separators rather than arbitrary iterables.

* gh-117692: Fixes a bug when "doctest.DocTestFinder" was failing on
  wrapped "builtin_function_or_method".

* gh-117348: Largely restored import time performance of configparser
  by avoiding dataclasses.

* gh-117641: Speedup "os.path.commonpath()" on Unix.

* gh-117663: Fix "_simple_enum" to detect aliases when multiple
  arguments are present but only one is the member value.

* gh-117636: Speedup "os.path.join()".

* gh-117618: Support "package.module" as "filename" for "break"
  command of "pdb"

* gh-102247: the status codes enum with constants in http.HTTPStatus
  are updated to include the names from RFC9110. This RFC includes
  some HTTP statuses previously only used for WEBDAV and assigns more
  generic names to them.

  The old constants are preserved for backwards compatibility.

* gh-117607: Speedup "os.path.relpath()".

* gh-117586: Speed up "pathlib.Path.glob()" by working with strings
  internally.

* gh-117225: Add colour to doctest output. Patch by Hugo van Kemenade.

* gh-117566: "ipaddress.IPv6Address.is_loopback()" will now return
  "True" for IPv4-mapped loopback addresses, i.e. addresses in the
  "::ffff:127.0.0.0/104" address space.

* gh-117546: Fix issue where "os.path.realpath()" stopped resolving
  symlinks after encountering a symlink loop on POSIX.

* gh-116720: Improved behavior of "asyncio.TaskGroup" when an external
  cancellation collides with an internal cancellation. For example,
  when two task groups are nested and both experience an exception in
  a child task simultaneously, it was possible that the outer task
  group would misbehave, because its internal cancellation was
  swallowed by the inner task group.

  In the case where a task group is cancelled externally and also must
  raise an "ExceptionGroup", it will now call the parent task’s
  "cancel()" method. This ensures that a "asyncio.CancelledError" will
  be raised at the next "await", so the cancellation is not lost.

  An added benefit of these changes is that task groups now preserve
  the cancellation count ("asyncio.Task.cancelling()").

  In order to handle some corner cases, "asyncio.Task.uncancel()" may
  now reset the undocumented "_must_cancel" flag when the cancellation
  count reaches zero.

* gh-117516: Add "typing.TypeIs", implementing **PEP 742**. Patch by
  Jelle Zijlstra.

* gh-117503: Fix support of non-ASCII user names in bytes paths in
  "os.path.expanduser()" on Posix.

* gh-117394: "os.path.ismount()" is now 2-3 times faster if the user
  has permissions.

* gh-117313: Only treat "'\n'", "'\r'" and "'\r\n'" as line separators
  in re-folding the "email" messages. Preserve control characters
  "'\v'", "'\f'", "'\x1c'", "'\x1d'" and "'\x1e'" and Unicode line
  separators "'\x85'", "'\u2028'" and "'\u2029'" as is.

* gh-117142: Convert "_ctypes" to multi-phase initialisation (**PEP
  489**).

* gh-66543: Add the "mimetypes.guess_file_type()" function which works
  with file path. Passing file path instead of URL in "guess_type()"
  is *soft deprecated*.

* gh-68583: webbrowser CLI: replace getopt with argparse, add long
  options. Patch by Hugo van Kemenade.

* gh-116871: Name suggestions for "AttributeError" and "ImportError"
  now only include underscored names if the original name was
  underscored.

* gh-116023: Don’t show empty fields (value "None" or "[]") in
  "ast.dump()" by default. Add "show_empty=False" parameter to
  optionally show them.

* gh-115961: Added "name" and "mode" attributes for compressed and
  archived file-like objects in modules "bz2", "lzma", "tarfile" and
  "zipfile". The value of the "mode" attribute of "gzip.GzipFile" was
  changed from integer ("1" or "2") to string ("'rb'" or "'wb'"). The
  value of the "mode" attribute of the readable file-like object
  returned by "zipfile.ZipFile.open()" was changed from "'r'" to
  "'rb'".

* gh-82062: Fix "inspect.signature()" to correctly handle parameter
  defaults on methods in extension modules that use names defined in
  the module namespace.

* gh-83856: Honor "atexit" for all "multiprocessing" start methods

* gh-113081: Print colorized exception just like built-in traceback in
  "pdb"

* gh-112855: Speed up pickling of "pathlib.PurePath" objects. Patch by
  Barney Gale.

* gh-111744: Support opcode events in "bdb"

* gh-109617: "ncurses": fixed a crash that could occur on macOS 13 or
  earlier when Python was built with Apple Xcode 15’s SDK.

* gh-83151: Enabled arbitrary statements and evaluations in "pdb"
  shell to access the local variables of the current frame, which made
  it possible for multi-scope code like generators or nested function
  to work.

* gh-110209: Add "__class_getitem__()" to "types.GeneratorType" and
  "types.CoroutineType" for type hinting purposes. Patch by James
  Hilton-Balfe.

* gh-108191: The "types.SimpleNamespace" now accepts an optional
  positional argument which specifies initial values of attributes as
  a dict or an iterable of key-value pairs.

* gh-62090: Fix assertion errors caused by whitespace in metavars or
  "SUPPRESS"-ed groups in "argparse" by simplifying usage formatting.
  Patch by Ali Hamdan.

* gh-102402: Adjust "logging.LogRecord" to use "time.time_ns()" and
  fix minor bug related to floating-point math.

* gh-100242: Bring pure Python implementation
  "functools.partial.__new__" more in line with the C-implementation
  by not just always checking for the presence of the attribute
  "'func'" on the first argument of "partial". Instead, both the
  Python version and the C version perform an "isinstance(func,
  partial)" check on the first argument of "partial".

* gh-99730: HEAD requests are no longer upgraded to GET request during
  redirects in urllib.

* gh-66410: Setting the "tkinter" module global "wantobjects" to "2"
  before creating the "Tk" object or call the "wantobjects()" method
  of the "Tk" object with argument "2" makes now arguments to
  callbacks registered in the "tkinter" module to be passed as various
  Python objects ("int", "float", "bytes", "tuple"), depending on
  their internal representation in Tcl, instead of always "str".
  "tkinter.wantobjects" is now set to "2" by default.

* bpo-40943: Fix several IndexError when parse emails with truncated
  Message-ID, address, routes, etc, e.g. "example@".

* bpo-39324: Add mime type mapping for .md <-> text/markdown

* bpo-18108: "shutil.chown()" now supports *dir_fd* and
  *follow_symlinks* keyword arguments.

* bpo-30988: Fix parsing of emails with invalid address headers having
  a leading or trailing dot. Patch by tsufeki.

* bpo-32839: Add the "after_info()" method for Tkinter widgets.


Documentation
-------------

* gh-117928: The minimum Sphinx version required for the documentation
  is now 6.2.1.


Build
-----

* gh-118734: Fixes Windows build when invoked directly (not through
  the "build.bat" script) without specifying a value for "UseTIER2".

* gh-115119: The "configure" option "--with-system-libmpdec" now
  defaults to "yes". The bundled copy of "libmpdecimal" will be
  removed in Python 3.15.

* gh-117845: Fix building against recent libedit versions by detecting
  readline hook signatures in **configure**.

* gh-116622: A testbed project was added to run the test suite on
  Android.

* gh-117645: Increase WASI stack size from 512 KiB to 8 MiB and the
  initial memory from 10 MiB to 20 MiB. Patch by Victor Stinner.

* gh-115119: **configure** now uses **pkg-config** to detect "decimal"
  dependencies if the "--with-system-libmpdec" option is given.


Windows
-------

* gh-115119: Update Windows installer to use libmpdecimal 4.0.0.

* gh-118486: "os.mkdir()" now accepts *mode* of "0o700" to restrict
  the new directory to the current user.

* gh-118347: Fixes launcher updates not being installed.

* gh-118293: The "multiprocessing" module now passes the
  "STARTF_FORCEOFFFEEDBACK" flag when spawning processes to tell
  Windows not to change the mouse cursor.

* gh-115009: Update Windows installer to use SQLite 3.45.3.

* gh-90329: Suppress the warning displayed on virtual environment
  creation when the requested and created paths differ only by a short
  (8.3 style) name. Warnings will continue to be shown if a junction
  or symlink in the path caused the venv to be created in a different
  location than originally requested.

* gh-117786: Fixes virtual environments not correctly launching when
  created from a Store install.


macOS
-----

* gh-115119: Update macOS installer to use libmpdecimal 4.0.0.

* gh-114099: iOS preprocessor symbol usage was made compatible with
  older macOS SDKs.

* gh-115009: Update macOS installer to use SQLite 3.45.3.

* gh-91629: Use "~/.config/fish/conf.d" configs and **fish_add_path**
  to set "PATH" when installing for the Fish shell.


IDLE
----

* bpo-34774: Use user-selected color theme for Help => IDLE Doc.


C API
-----

* gh-118124: Fix "Py_BUILD_ASSERT" and "Py_BUILD_ASSERT_EXPR" for non-
  constant expressions: use "static_assert()" on C11 and newer. Patch
  by Victor Stinner.

* gh-110850: Add “Raw” variant of PyTime functions

  * "PyTime_MonotonicRaw()"

  * "PyTime_PerfCounterRaw()"

  * "PyTime_TimeRaw()"

  Patch by Victor Stinner.

* gh-117987: Restore functions removed in Python 3.13 alpha 1:

  * "Py_SetPythonHome()"

  * "Py_SetProgramName()"

  * "PySys_SetArgvEx()"

  * "PySys_SetArgv()"

  Patch by Victor Stinner.

* gh-117929: Restore removed "PyEval_InitThreads()" function. Patch by
  Victor Stinner.

* gh-117534: Improve validation logic in the C implementation of
  "datetime.datetime.fromisoformat()" to better handle invalid years.
  Patch by Vlad Efanov.

* gh-68114: Fixed skipitem()’s handling of the old ‘w’ and ‘w#’
  formatters. These are no longer supported and now raise an exception
  if used.

* gh-111997: Add a C-API for firing monitoring events.


Python 3.13.0 alpha 6
=====================

*Release date: 2024-04-09*


Core and Builtins
-----------------

* gh-117494: Refactored the instruction sequence data structure out of
  compile.c into instruction_sequence.c.

* gh-116968: Introduce a unified 16-bit backoff counter type
  ("_Py_BackoffCounter"), shared between the Tier 1 adaptive
  specializer and the Tier 2 optimizer. The API used for adaptive
  specialization counters is changed but the behavior is (supposed to
  be) identical.

  The behavior of the Tier 2 counters is changed:

  * There are no longer dynamic thresholds (we never varied these).

  * All counters now use the same exponential backoff.

  * The counter for "JUMP_BACKWARD" starts counting down from 16.

  * The "temperature" in side exits starts counting down from 64.

* gh-117431: Improve the performance of the following "bytes" and
  "bytearray" methods by adapting them to the "METH_FASTCALL" calling
  convention:

  * "endswith()"

  * "startswith()"

* gh-117431: Improve the performance of the following "str" methods by
  adapting them to the "METH_FASTCALL" calling convention:

  * "count()"

  * "endswith()"

  * "find()"

  * "index()"

  * "rfind()"

  * "rindex()"

  * "startswith()"

* gh-117411: Move "PyFutureFeatures" to an internal header and make it
  private.

* gh-109120: Added handle of incorrect star expressions, e.g "f(3,
  *)". Patch by Grigoryev Semyon

* gh-117266: Fix crashes for certain user-created subclasses of
  "ast.AST". Such classes are now expected to set the "_field_types"
  attribute.

* gh-99108: Updated the "hashlib" built-in HACL* project C code from
  upstream that we use for many implementations when they are not
  present via OpenSSL in a given build.  This also avoids the rare
  potential for a C symbol name one definition rule linking issue.

* gh-117108: Change the old space bit of objects in the young
  generation from 0 to gcstate->visited, so that any objects created
  during GC will have the old bit set correctly if they get moved into
  the old generation.

* gh-117108: The cycle GC now chooses the size of increments based on
  the total heap size, instead of the rate of object creation. This
  ensures that it can keep up with growing heaps.

* gh-116735: For "INSTRUMENTED_CALL_FUNCTION_EX", set "arg0" to
  "sys.monitoring.MISSING" instead of "None" for "CALL" event.

* gh-113964: Starting new threads and process creation through
  "os.fork()" are now only prevented once all non-daemon threads exit.

* gh-116626: Ensure "INSTRUMENTED_CALL_FUNCTION_EX" always emits
  "CALL"

* gh-116554: "list.sort()" now exploits more cases of partial
  ordering, particularly those with long descending runs with sub-runs
  of equal values. Those are recognized as single runs now
  (previously, each block of repeated values caused a new run to be
  created).

* gh-114099: Added a Loader that can discover extension modules in an
  iOS-style Frameworks folder.

* gh-115775: Compiler populates the new "__static_attributes__" field
  on a class with the names of attributes of this class which are
  accessed through self.X from any function in its body.

* gh-115776: The array of values, the "PyDictValues" struct is now
  embedded in the object during allocation. This provides better
  performance in the common case, and does not degrade as much when
  the object’s "__dict__" is materialized.

* gh-108362: Implement an incremental cyclic garbage collector. By
  collecting the old generation in increments, there is no need for a
  full heap scan. This can hugely reduce maximum pause time for
  programs with large heaps.

  Reduce the number of generations from three to two. The old
  generation is split into two spaces, “visited” and “pending”.

  Collection happens in two steps:: * An increment is formed from the
  young generation and a small part of the pending space. * This
  increment is scanned and the survivors moved to the end of the
  visited space.

  When the collecting space becomes empty, the two spaces are swapped.

* gh-109870: Dataclasses now calls "exec()" once per dataclass,
  instead of once per method being added.  This can speed up dataclass
  creation by up to 20%.

* gh-97901: Mime type "text/rtf" is now supported by "mimetypes".

* bpo-24612: Improve the "SyntaxError" that happens when ‘not’ appears
  after an operator. Patch by Pablo Galindo


Library
-------

* gh-117648: Improve performance of "os.path.join()" and
  "os.path.expanduser()".

* gh-117584: Raise "TypeError" for non-paths in "posixpath.relpath".

* gh-117467: Preserve mailbox ownership when rewriting in
  "mailbox.mbox.flush". Patch by Tony Mountifield.

* gh-114848: Raise "FileNotFoundError" when "getcwd()" returns
  ‘(unreachable)’, which can happen on Linux >= 2.6.36 with glibc <
  2.27.

* gh-117459: "asyncio.asyncio.run_coroutine_threadsafe()" now keeps
  the traceback of "CancelledError", "TimeoutError" and
  "InvalidStateError" which are raised in the coroutine.

* gh-117381: Fix error message for "ntpath.commonpath()".

* gh-117337: Deprecate undocumented "glob.glob0()" and "glob.glob1()"
  functions. Use "glob.glob()" and pass a directory to its *root_dir*
  argument instead.

* gh-117349: Optimise several functions in "os.path".

* gh-117348: Refactored "configparser.RawConfigParser._read()" to
  reduce cyclometric complexity and improve comprehensibility.

* gh-117335: Raise TypeError for non-sequences for
  "ntpath.commonpath()".

* gh-66449: "configparser.ConfigParser" now accepts unnamed sections
  before named ones, if configured to do so.

* gh-88014: In documentation of "gzip.GzipFile" in module gzip,
  explain data type of optional constructor argument *mtime*, and
  recommend "mtime = 0" for generating deterministic streams.

* gh-117310: Fixed an unlikely early & extra "Py_DECREF" triggered
  crash in "ssl" when creating a new "_ssl._SSLContext" if CPython was
  built implausibly such that the default cipher list is empty **or**
  the SSL library it was linked against reports a failure from its C
  "SSL_CTX_set_cipher_list()" API.

* gh-117294: A "DocTestCase" now reports as skipped if all examples in
  the doctest are skipped.

* gh-98966: In "subprocess", raise a more informative message when
  "stdout=STDOUT".

* gh-117225: doctest: only print “and X failed” when non-zero, don’t
  pluralise “1 items”. Patch by Hugo van Kemenade.

* gh-117205: Speed up "compileall.compile_dir()" by 20% when using
  multiprocessing by increasing "chunksize".

* gh-117178: Fix regression in lazy loading of self-referential
  modules, introduced in gh-114781.

* gh-112383: Fix "dis" module’s handling of "ENTER_EXECUTOR"
  instructions.

* gh-117182: Lazy-loading of modules that modify their own "__class__"
  no longer reverts the "__class__" to "types.ModuleType".

* gh-117084: Fix "zipfile" extraction for directory entries with the
  name containing backslashes on Windows.

* gh-117114: Make "os.path.isdevdrive()" available on all platforms.
  For those that do not offer Dev Drives, it will always return
  "False".

* gh-117110: Fix a bug that prevents subclasses of "typing.Any" to be
  instantiated with arguments. Patch by Chris Fu.

* gh-109653: Deferred select imports in importlib.metadata and
  importlib.resources for a 14% speedup.

* gh-70647: Start the deprecation period for the current behavior of
  "datetime.datetime.strptime()" and "time.strptime()" which always
  fails to parse a date string with a "ValueError" involving a day of
  month such as "strptime("02-29", "%m-%d")" when a year is **not**
  specified and the date happen to be February 29th.  This should help
  avoid users finding new bugs every four years due to a natural
  mistaken assumption about the API when parsing partial date values.

* gh-116987: Fixed "inspect.findsource()" for class code objects.

* gh-114099: Modify standard library to allow for iOS platform
  differences.

* gh-90872: On Windows, "subprocess.Popen.wait()" no longer calls
  "WaitForSingleObject()" with a negative timeout: pass "0" ms if the
  timeout is negative. Patch by Victor Stinner.

* gh-116957: configparser: Don’t leave ConfigParser values in an
  invalid state (stored as a list instead of a str) after an earlier
  read raised DuplicateSectionError or DuplicateOptionError.

* gh-115538: "_io.WindowsConsoleIO" now emit a warning if a boolean
  value is passed as a filedescriptor argument.

* gh-90095: Ignore empty lines and comments in ".pdbrc"

* gh-106531: Refreshed zipfile._path from zipp 3.18, providing better
  compatibility for PyPy, better glob performance for deeply nested
  zipfiles, and providing internal access to "CompleteDirs.inject" for
  use in other tests (like importlib.resources).

* gh-63207: On Windows, "time.time()" now uses the
  "GetSystemTimePreciseAsFileTime()" clock to have a resolution better
  than 1 us, instead of the "GetSystemTimeAsFileTime()" clock which
  has a resolution of 15.6 ms. Patch by Victor Stinner.

* gh-116764: Restore support of "None" and other false values in
  "urllib.parse" functions "parse_qs()" and "parse_qsl()". Also, they
  now raise a TypeError for non-zero integers and non-empty sequences.

* gh-116811: In "PathFinder.invalidate_caches", delegate to
  "MetadataPathFinder.invalidate_caches".

* gh-116647: Fix recursive child in dataclasses

* gh-113171: Fixed various false positives and false negatives in

  * "ipaddress.IPv4Address.is_private" (see these docs for details)

  * "ipaddress.IPv4Address.is_global"

  * "ipaddress.IPv6Address.is_private"

  * "ipaddress.IPv6Address.is_global"

  Also in the corresponding "ipaddress.IPv4Network" and
  "ipaddress.IPv6Network" attributes.

* gh-63283: In "encodings.idna", any capitalization of the ACE prefix
  ("xn--") is now acceptable. Patch by Pepijn de Vos and Zackery
  Spytz.

* gh-71042: Add "platform.android_ver()", which provides device and OS
  information on Android.

* gh-73468: Added new "math.fma()" function, wrapping C99’s "fma()"
  operation: fused multiply-add function. Patch by Mark Dickinson and
  Victor Stinner.

* gh-116608: The "importlib.resources" functions "is_resource()",
  "open_binary()", "open_text()", "path()", "read_binary()", and
  "read_text()" are un-deprecated, and support subdirectories via
  multiple positional arguments. The "contents()" function also allows
  subdirectories, but remains deprecated.

* gh-116484: Change automatically generated "tkinter.Checkbutton"
  widget names to avoid collisions with automatically generated
  "tkinter.ttk.Checkbutton" widget names within the same parent
  widget.

* gh-114314: In "ctypes", ctype data is now stored in type objects
  directly rather than in a dict subclass. This is an internal change
  that should not affect usage.

* gh-116401: Fix blocking "os.fwalk()" and "shutil.rmtree()" on
  opening named pipe.

* gh-71052: Implement "ctypes.util.find_library()" on Android.

* gh-90535: Fix support of *interval* values > 1 in
  "logging.TimedRotatingFileHandler" for "when='MIDNIGHT'" and
  "when='Wx'".

* gh-113308: Remove some internal protected parts from "uuid":
  "_has_uuid_generate_time_safe", "_netbios_getnode",
  "_ipconfig_getnode", and "_load_system_functions". They were unused.

* gh-115627: Fix the "ssl" module error handling of connection
  terminate by peer. It now throws an OSError with the appropriate
  error code instead of an EOFError.

* gh-114847: Speed up "os.path.realpath()" on non-Windows platforms.

* gh-114271: Fix a race in "threading.Thread.join()".

  "threading._MainThread" now always represents the main thread of the
  main interpreter.

  "PyThreadState.on_delete" and "PyThreadState.on_delete_data" have
  been removed.

* gh-113538: Add "asyncio.Server.close_clients()" and
  "asyncio.Server.abort_clients()" methods which allow to more
  forcefully close an asyncio server.

* gh-85287: Changes Unicode codecs to return UnicodeEncodeError or
  UnicodeDecodeError, rather than just UnicodeError.

* gh-113548: "pdb" now allows CLI arguments to "pdb -m".

* gh-112948: Make completion of "pdb" similar to Python REPL

* gh-105866: Fixed "_get_slots" bug which caused error when defining
  dataclasses with slots and a weakref_slot.

* gh-96471: Add "asyncio.Queue" termination with "shutdown()" method.

* gh-89739: The "zipimport" module can now read ZIP64 files.

* bpo-33533: "asyncio.as_completed()" now returns an object that is
  both an asynchronous iterator and plain iterator. The new
  asynchronous iteration pattern allows for easier correlation between
  prior tasks and their completed results. This is a closer match to
  "concurrent.futures.as_completed()"’s iteration pattern. Patch by
  Justin Arthur.

* bpo-27578: "inspect.getsource()" (and related functions) work with
  empty module files, returning "'\n'" (or reasonable equivalent)
  instead of raising "OSError". Patch by Kernc.

* bpo-37141: Accept an iterable of separators in
  "asyncio.StreamReader.readuntil()", stopping when one of them is
  encountered.

* gh-66543: Make "mimetypes.guess_type()" properly parsing of URLs
  with only a host name, URLs containing fragment or query, and
  filenames with only a UNC sharepoint on Windows. Based on patch by
  Dong-hee Na.

* bpo-15010: "unittest.TestLoader.discover()" now saves the original
  value of "unittest.TestLoader._top_level_dir" and restores it at the
  end of the call.


Documentation
-------------

* gh-115977: Remove compatibility references to Emscripten.

* gh-114099: Add an iOS platform guide, and flag modules not available
  on iOS.

* gh-91565: Changes to documentation files and config outputs to
  reflect the new location for reporting bugs - i.e. GitHub rather
  than bugs.python.org.


Tests
-----

* gh-83434: Disable JUnit XML output ("--junit-xml=FILE" command line
  option) in regrtest when hunting for reference leaks ("-R" option).
  Patch by Victor Stinner.

* gh-117187: Fix XML tests for vanilla Expat <2.6.0.

* gh-116333: Tests of TLS related things (error codes, etc) were
  updated to be more lenient about specific error message strings and
  behaviors as seen in the BoringSSL and AWS-LC forks of OpenSSL.

* gh-117089: Consolidated tests for importlib.metadata in their own
  "metadata" package.

* gh-115979: Update test_importlib so that it passes under WASI SDK
  21.

* gh-112536: Add –tsan to test.regrtest for running TSAN tests in
  reasonable execution times. Patch by Donghee Na.

* gh-116307: Added import helper "isolated_modules" as "CleanImport"
  does not remove modules imported during the context. Use it in
  importlib.resources tests to avoid leaving "mod" around to impede
  importlib.metadata tests.


Build
-----

* gh-114736: Have WASI builds use WASI SDK 21.

* gh-115983: Skip building test modules that must be built as shared
  under WASI.

* gh-71052: Add Android build script and instructions.


Windows
-------

* gh-117267: Ensure "DirEntry.stat().st_ctime" behaves consistently
  with "os.stat()" during the deprecation period of "st_ctime" by
  containing the same value as "st_birthtime". After the deprecation
  period, "st_ctime" will be the metadata change time (or unavailable
  through "DirEntry"), and only "st_birthtime" will contain the
  creation time.

* gh-116195: Improves performance of "os.getppid()" by using an
  alternate system API when available. Contributed by vxiiduu.

* gh-88494: On Windows, "time.monotonic()" now uses the
  "QueryPerformanceCounter()" clock to have a resolution better than 1
  us, instead of the "GetTickCount64()" clock which has a resolution
  of 15.6 ms. Patch by Victor Stinner.

* gh-116773: Fix instances of "<_overlapped.Overlapped object at
  0xXXX> still has pending operation at deallocation, the process may
  crash".

* gh-91227: Fix the asyncio ProactorEventLoop implementation so that
  sending a datagram to an address that is not listening does not
  prevent receiving any more datagrams.

* gh-115119: Switched from vendored "libmpdecimal" code to a
  separately-hosted external package in the "cpython-source-deps"
  repository when building the "_decimal" module.


C API
-----

* gh-117642: Fix **PEP 737** implementation for "%#T" and "%#N".

* gh-87193: "_PyBytes_Resize()" can now be called for bytes objects
  with reference count > 1, including 1-byte bytes objects. It creates
  a new bytes object and destroys the old one if it has reference
  count > 1.

* gh-117021: Fix integer overflow in "PyLong_AsPid()" on non-Windows
  64-bit platforms.

* gh-115756: "PyCode_GetFirstFree()" is an ustable API now and has
  been renamed to "PyUnstable_Code_GetFirstFree()". (Contributed by
  Bogdan Romanyuk in gh-115781)

* gh-116869: Add "test_cext" test: build a C extension to check if the
  Python C API emits C compiler warnings. Patch by Victor Stinner.

* gh-116869: Make the C API compatible with "-Werror=declaration-
  after-statement" compiler flag again. Patch by Victor Stinner.

* gh-116936: Add "PyType_GetModuleByDef()" to the limited C API. Patch
  by Victor Stinner.

* gh-116809: Restore removed private "_PyErr_ChainExceptions1()"
  function. Patch by Victor Stinner.

* gh-115754: In the limited C API version 3.13, getting "Py_None",
  "Py_False", "Py_True", "Py_Ellipsis" and "Py_NotImplemented"
  singletons is now implemented as function calls at the stable ABI
  level to hide implementation details. Getting these constants still
  return borrowed references. Patch by Victor Stinner.

* gh-115754: Add "Py_GetConstant()" and "Py_GetConstantBorrowed()"
  functions to get constants. For example,
  "Py_GetConstant(Py_CONSTANT_ZERO)" returns a *strong reference* to
  the constant zero. Patch by Victor Stinner.

* gh-111696: Add support for "%T", "%T#", "%N" and "%N#" formats to
  "PyUnicode_FromFormat()": format the fully qualified name of an
  object type and of a type: call "PyType_GetModuleName()". See **PEP
  737** for more information. Patch by Victor Stinner.

* gh-111696: Add "PyType_GetModuleName()" function to get the type’s
  module name. Equivalent to getting the "type.__module__" attribute.
  Patch by Eric Snow and Victor Stinner.

* gh-111696: Add "PyType_GetFullyQualifiedName()" function to get the
  type’s fully qualified name. Equivalent to
  "f"{type.__module__}.{type.__qualname__}"", or "type.__qualname__"
  if "type.__module__" is not a string or is equal to ""builtins"".
  Patch by Victor Stinner.

* gh-85283: The "fcntl", "grp", "pwd", "termios", "_statistics" and
  "_testconsole" C extensions are now built with the limited C API.
  Patch by Victor Stinner.

* gh-111140: Add additional flags to "PyLong_AsNativeBytes()" and
  "PyLong_FromNativeBytes()" to allow the caller to determine how to
  handle edge cases around values that fill the entire buffer.

* gh-113024: Add "PyObject_GenericHash()" function.


Python 3.13.0 alpha 5
=====================

*Release date: 2024-03-12*


Security
--------

* gh-115398: Allow controlling Expat >=2.6.0 reparse deferral (**CVE
  2023-52425**) by adding five new methods:

  * "xml.etree.ElementTree.XMLParser.flush()"

  * "xml.etree.ElementTree.XMLPullParser.flush()"

  * "xml.parsers.expat.xmlparser.GetReparseDeferralEnabled()"

  * "xml.parsers.expat.xmlparser.SetReparseDeferralEnabled()"

  * "xml.sax.expatreader.ExpatParser.flush()"

* gh-114572: "ssl.SSLContext.cert_store_stats()" and
  "ssl.SSLContext.get_ca_certs()" now correctly lock access to the
  certificate store, when the "ssl.SSLContext" is shared across
  multiple threads.


Core and Builtins
-----------------

* gh-116604: Respect the status of the garbage collector when indirect
  calls are made via "PyErr_CheckSignals()" and the evaluation
  breaker. Patch by Pablo Galindo

* gh-112087: "list" is now compatible with the implementation of **PEP
  703**.

* gh-116381: Add specialization for "CONTAINS_OP".

* gh-116296: Fix possible refleak in "object.__reduce__()" internal
  error handling.

* gh-115823: Properly calculate error ranges in the parser when
  raising "SyntaxError" exceptions caused by invalid byte sequences.
  Patch by Pablo Galindo

* gh-115778: Add "tierN" annotation for instruction definition in
  interpreter DSL.

* gh-115733: Fix crash when calling "next()" on exhausted list
  iterators.

* gh-115700: The regen-cases build stage now works on Windows.

* gh-115347: Fix bug where docstring was replaced by a redundant NOP
  when Python is run with "-OO".

* gh-115323: Make error message more meaningful for when
  "bytearray.extend()" is called with a "str" object.

* gh-112175: Every "PyThreadState" now has its own "eval_breaker",
  allowing specific threads to be interrupted.

* gh-115154: Fix a bug that was causing the "tokenize.untokenize()"
  function to handle unicode named literals incorrectly. Patch by
  Pablo Galindo

* gh-112433: Add ability to force alignment of "ctypes.Structure" by
  way of the new "_align_" attribute on the class.

* gh-104090: The multiprocessing resource tracker now exits with non-
  zero status code if a resource leak was detected. It still exits
  with status code 0 otherwise.

* gh-105858: Improve the constructors for "ast" nodes. Arguments of
  list types now default to an empty list if omitted, and optional
  fields default to "None". AST nodes now have an "__annotations__"
  attribute with the expected types of their attributes. Passing
  unrecognized extra arguments to AST nodes is deprecated and will
  become an error in Python 3.15. Omitting a required argument to an
  AST node is deprecated and will become an error in Python 3.15.
  Patch by Jelle Zijlstra.

* gh-101860: Expose "__name__" attribute on property.

* gh-96497: Fix incorrect resolution of mangled class variables used
  in assignment expressions in comprehensions.


Library
-------

* gh-116600: Fix "repr()" for global "Flag" members.

* gh-116349: "platform.java_ver()" is deprecated and will be removed
  in 3.15. It was largely untested, had a confusing API, and was only
  useful for Jython support.

* gh-116143: Fix a race in pydoc "_start_server", eliminating a window
  in which "_start_server" can return a thread that is “serving” but
  without a "docserver" set.

* gh-116127: "typing": implement **PEP 705** which adds
  "typing.ReadOnly" support to "typing.TypedDict".

* gh-116325: "typing": raise "SyntaxError" instead of "AttributeError"
  on forward references as empty strings.

* gh-115957: When "asyncio.TaskGroup.create_task" is called on an
  inactive "asyncio.TaskGroup", the given coroutine will be closed
  (which prevents a "RuntimeWarning").

* gh-115978: Disable preadv(), readv(), pwritev(), and writev() on
  WASI.

  Under wasmtime for WASI 0.2, these functions don’t pass test_posix
  (https://github.com/bytecodealliance/wasmtime/issues/7830).

* gh-88352: Fix the computation of the next rollover time in the
  "logging.TimedRotatingFileHandler" handler. "computeRollover()" now
  always returns a timestamp larger than the specified time and works
  correctly during the DST change. "doRollover()" no longer overwrite
  the already rolled over file, saving from data loss when run at
  midnight or during repeated time at the DST change.

* gh-87115: Set "__main__.__spec__" to "None" when running a script
  with "pdb"

* gh-76511: Fix UnicodeEncodeError in "email.Message.as_string()" that
  results when a message that claims to be in the ascii character set
  actually has non-ascii characters. Non-ascii characters are now
  replaced with the U+FFFD replacement character, like in the
  "replace" error handler.

* gh-89547: Add support for nested typing special forms like
  Final[ClassVar[int]].

* gh-65824: Improve the "less" prompt in "pydoc".

* gh-116040: [Enum] fix by-value calls when second value is falsey;
  e.g. Cardinal(1, 0)

* gh-115821: [Enum] Improve error message when calling
  super().__new__() in custom __new__.

* gh-85644: Use the "XDG_CURRENT_DESKTOP" environment variable in
  "webbrowser" to check desktop. Prefer it to the deprecated
  "GNOME_DESKTOP_SESSION_ID" for GNOME detection.

* gh-75988: Fixed "unittest.mock.create_autospec()" to pass the call
  through to the wrapped object to return the real result.

* gh-115881: Fix issue where "ast.parse()" would incorrectly flag
  conditional context managers (such as "with (x() if y else z()):
  ...") as invalid syntax if "feature_version=(3, 8)" was passed. This
  reverts changes to the grammar made as part of gh-94949.

* gh-115886: Fix silent truncation of the name with an embedded null
  character in "multiprocessing.shared_memory.SharedMemory".

* gh-115532: Add kernel density estimation to the statistics module.

* gh-115714: On WASI, the "time" module no longer get process time
  using "times()" or "CLOCK_PROCESS_CPUTIME_ID", system API is that is
  unreliable and is likely to be removed from WASI. The affected clock
  functions fall back to calling "clock()".

* gh-115809: Improve algorithm for computing which rolled-over log
  files to delete in "logging.TimedRotatingFileHandler". It is now
  reliable for handlers without "namer" and with arbitrary
  deterministic "namer" that leaves the datetime part in the file name
  unmodified.

* gh-74668: "urllib.parse" functions "parse_qs()" and "parse_qsl()"
  now support bytes arguments containing raw and percent-encoded non-
  ASCII data.

* gh-67044: "csv.writer()" now always quotes or escapes "'\r'" and
  "'\n'", regardless of *lineterminator* value.

* gh-115712: Restore support of space delimiter with
  "skipinitialspace=True" in "csv". "csv.writer()" now quotes empty
  fields if delimiter is a space and skipinitialspace is true and
  raises exception if quoting is not possible.

* gh-112364: Fixed "ast.unparse()" to handle format_spec with """, "'"
  or "\\". Patched by Frank Hoffmann.

* gh-112997: Stop logging potentially sensitive callback arguments in
  "asyncio" unless debug mode is active.

* gh-114914: Fix an issue where an abandoned "StreamWriter" would not
  be garbage collected.

* gh-111358: Fix a bug in
  "asyncio.BaseEventLoop.shutdown_default_executor()" to ensure the
  timeout passed to the coroutine behaves as expected.

* gh-115618: Fix improper decreasing the reference count for "None"
  argument in "property" methods "getter()", "setter()" and
  "deleter()".

* gh-112720: Refactor "dis.ArgResolver" to make it possible to
  subclass and change the way jump args are interpreted.

* gh-112006: Fix "inspect.unwrap()" for types with the "__wrapper__"
  data descriptor. Fix "inspect.Signature.from_callable()" for
  builtins "classmethod()" and "staticmethod()".

* gh-101293: Support callables with the "__call__()" method and types
  with "__new__()" and "__init__()" methods set to class methods,
  static methods, bound methods, partial functions, and other types of
  methods and descriptors in "inspect.Signature.from_callable()".

* gh-103092: Isolate "_lsprof" (apply **PEP 687**).

* gh-113942: "pydoc" no longer skips global functions implemented as
  builtin methods, such as "MethodDescriptorType" and
  "WrapperDescriptorType".

* gh-115256: Added DeprecationWarning when accessing the tarfile
  attribute of TarInfo objects. The attribute is never used internally
  and is only attached to TarInfos when the tarfile is opened in
  write-mode, not read-mode. The attribute creates an unnecessary
  reference cycle which may cause corruption when not closing the
  handle after writing a tarfile.

* gh-115197: "urllib.request" no longer resolves the hostname before
  checking it against the system’s proxy bypass list on macOS and
  Windows.

* gh-113812: "DatagramTransport.sendto()" will now send zero-length
  datagrams if called with an empty bytes object. The transport flow
  control also now accounts for the datagram header when calculating
  the buffer size.

* gh-114763: Protect modules loaded with "importlib.util.LazyLoader"
  from race conditions when multiple threads try to access attributes
  before the loading is complete.

* gh-114709: "posixpath.commonpath()" now raises a "ValueError"
  exception when passed an empty iterable. Previously, "IndexError"
  was raised.

  "posixpath.commonpath()" now raises a "TypeError" exception when
  passed "None". Previously, "ValueError" was raised.

* gh-114610: Fix bug where "pathlib.PurePath.with_stem()" converted a
  non-empty path suffix to a stem when given an empty *stem* argument.
  It now raises "ValueError", just like
  "pathlib.PurePath.with_suffix()" does when called on a path with an
  empty stem, given a non-empty *suffix* argument.

* gh-107361: Add "ssl.VERIFY_X509_PARTIAL_CHAIN" and
  "VERIFY_X509_STRICT" to the default SSL context created with
  "ssl.create_default_context()".

* gh-112281: Allow creating union of types for "typing.Annotated" with
  unhashable metadata.

* gh-111775: Fix "importlib.resources.simple.ResourceHandle.open()"
  for text mode, added missed "stream" argument.

